//
// MyBitmap.h
// ----------

// DSgf : http://sourceforge.net/projects/dsgf
//

/* system includes */
#include <nds.h>

#ifndef MYBITMAP_H
#define MYBITMAP_H

//---------------------------------------------------------------------------------------

struct MyPoint
{
		u16	x;	
		u16	y;
		
		MyPoint() : x (0),y( 0 )
		{ }
};

struct MyRect
{
	u16 x;
	u16 y;
	u16 width;
	u16 height;
};

//---------------------------------------------------------------------------------------

// CMyBitmap : 	Encapsule les bitmaps, qu'ils soient prdfinis (binaries de /data - ils sont Read only) ou bien
//						crs dynamiquement (R/W).
//						On distinguera les bitmaps intgrant la transparence (sprites!) des autres... le flag "transparence" est l pour a!

class CMyBitmap
{
	public:
		
	// Attributs
	
	u16 		size_x,size_y;
	u8*			p_data;
	bool		read_only;
	bool		transparence;	// transparence non utilise/teste!
	u8			couleur_transp;
	
	// Fonctions
		
	CMyBitmap(const u8* p_binary,u16 sx,u16 sy, bool transp=false,u8 coul_transp=0);	// Constructeur depuis un bitmap de /data
																																										// par dfaut, ils n'intgrent pas la transparence																																	
	CMyBitmap(u16 sx,u16 sy, bool transp=false,u8 coul_transp=0);
	
	void DrawRect(u16 x,u16 y,u16 dx, u16 dy, u8 palette_index);
	void DrawFrameRect(u16 x,u16 y,u16 dx, u16 dy, u8 palette_index);
	void DrawFrameRect(MyRect m_rect, u8 palette_index);
	
	void Fill(u8 color);
	void Fill(MyRect rect, u8 palette_index);
	
	void Copy2VRAM(u16* pdest);	// copie 1 pour 1
	void Copy2VRAMscroll256x192(u16* pdest, u16 vertical_scroll);	// scrolling d'un bitmap vers du 256*192
	void Copy2VRAMscroll256x126(u16* pdest, u16 vertical_scroll);	// scrolling d'un bitmap vers du 256*126
	
	void SetPixel(u16 x,u16 y,u8 color);
	u8 GetPixel(u16 x,u16 y);
	
	void Copy2Bitmap(u16 x0,u16 y0, u16 width, u16 height, CMyBitmap* pbmpdest, u16 x1=0, u16 y1=0);
						// copie le rectangle x0,y0/width,length
						// vers le bitmap bmpdest aux coordonnes x1, y1
						
	void BitBltOnBitmap(CMyBitmap* pbmpdest, u16 x1=0, u16 y1=0);	// comme copy2bitmap mais gre la transparence...
	
	void Copy2Bitmap(CMyBitmap* pbmpdest, u16 x1=0, u16 y1=0); // le mme mais on copie l'intgralit du bitmap source
		
	void CopyToMAIN_BG(u16 xdest,u16 ydest);
	void RemoveFromMAIN_BG(u16 xdest,u16 ydest);

	void CopyToMAIN_LARGE_BG(u16 xdest,u16 ydest);
	void RemoveFromMAIN_LARGE_BG(u16 xdest,u16 ydest);
	
	void SetPixelMAIN_BG(u16 x,u16 y,u8 value);
	void SetPixelMAIN_LARGE_BG(u16 x,u16 y,u8 value);
	
	void DrawHorizLine(u16 x,u16 y, u16 width, u8 color);
	
	~CMyBitmap();
		
};

//------------------------------------------------------------------------------------------------------


#endif /* MYBITMAP_H */
