//
// MyChoiceList.cpp
// ----------------
// 
// Liste de choix avec barre de dfilement...
//
// DSgf : http://sourceforge.net/projects/dsgf
//

/* system includes */
#include <nds.h>
#include <nds/arm9/console.h> // module console	pour iprintf (debug)
#include <stdio.h>						// fonctions standarts d'I/O (idem:debug/console)
#include <vector>

/* my includes */
#include "MyTools.h"
#include "MyChoiceList.h"
#include "MyFont.h"

extern CMyFont*	arial12;	// pour dire que cette variable principale est dfinie ailleurs (dans main.cpp)

extern	CMyBitmap fleche_haut;
extern	CMyBitmap fleche_bas;

// CMyChoiceList

CMyChoiceList::CMyChoiceList(vector<string> liste,CMyBitmap* pbmp,u8 nb,u8 marge)
{
		my_pbmp=pbmp;
		my_nb=nb;
		my_marge=marge;
		my_selection=0;
		my_scroll_index=0;
		items.clear();
		items=liste;
		show_indicator=true;
}

CMyChoiceList::~CMyChoiceList()
{
		items.clear();
}

//------------------------------------------------------------------------

void CMyChoiceList::initial_draw(MyRect rect)
{
	// On dessine sur le bitmap (*pmp)
	
	my_rect.x=rect.x;
	my_rect.y=rect.y;
	my_rect.width=rect.width;
	my_rect.height=rect.height;
	
	if (my_rect.height<64)
		show_indicator=false;
	
	// rappel : par convention, on a cod en dur (main.cpp) 3 couleurs dans les palettes
	// noire : 255, blanc : 254, gris : 253
	
	my_pbmp->DrawRect(rect.x,rect.y,rect.width,rect.height, 254);	// remplit de blanc
	
	my_pbmp->DrawFrameRect(rect.x+rect.width-16,rect.y,16,16, 255); // cadre en noir
	fleche_haut.BitBltOnBitmap(my_pbmp,rect.x+rect.width-16+1,rect.y);
	my_pbmp->DrawFrameRect(rect.x+rect.width-16,rect.y+16,16,16, 255);
	fleche_bas.BitBltOnBitmap(my_pbmp,rect.x+rect.width-16+1,rect.y+16);
	my_pbmp->DrawFrameRect(rect.x+rect.width-16,rect.y+32,16,rect.height-32, 255);
	my_pbmp->DrawFrameRect(rect.x,rect.y,rect.width,rect.height, 255);
}

void CMyChoiceList::update()
{
	// On dessine sur le bitmap (*pmp)
	
	// Nettoyage de la zone de texte...
	
	my_pbmp->DrawRect(my_rect.x+1,my_rect.y+1,my_rect.width-1-16,my_rect.height-2, 254);	// remplit de blanc
	
	// On met la slection en background gris
	
	my_pbmp->DrawRect(my_rect.x+1,my_rect.y+my_marge+my_selection*12,my_rect.width-1-16,12, 253);	// remplit de gris
	
	// On crit les items
	
	u8 y=my_rect.y+my_marge;	
	u8 i;
	
	for (i=my_scroll_index;i<(my_scroll_index+my_nb);i++)
	{
		if (i<items.size())
			arial12->WriteParagraph(items[i],my_pbmp,(my_rect.x+my_marge),y,(my_rect.x+my_rect.width-16),y+12);
			//arial12->BasicWrite((char*)items[i].c_str(),my_pbmp,(my_rect.x+my_marge),y);
		else
			break;
		y+=12;
	}
	
	if (show_indicator)
	{
		// nettoyage de la zone de l'"ascenceur"
		
		my_pbmp->DrawRect(my_rect.x+my_rect.width-16+1,my_rect.y+32+1,15,my_rect.height-32-1, 254);
		
		// TODO: remplacer l'usage du float par une division d'entiers !
		float f;
		f=(my_selection+my_scroll_index)*(my_rect.height-32-12);
		f=f/(items.size());
		u8 t=(u8)f;
		
		my_pbmp->DrawRect(my_rect.x+my_rect.width-16+1,my_rect.y+32+1+t,15,15, 253);	
	}
}

