//
// MyGoban.cpp
// -----------
// 
// Classe de reprsentation d'un goban
//
// DSgf : http://sourceforge.net/projects/dsgf
//

//------------------------------------------------------------------------------

#include <nds.h>
#include <nds/arm9/console.h> // module console	pour iprintf (debug)
#include <stdio.h>			  // fonctions standarts d'I/O (idem:debug/console)

#include <string>

#include "main.h"
#include "MyTools.h"

#include "MyGoban.h"

//------------------------------------------------------------------------------

// Variables principales dfinies dans main.cpp

extern Goban_type	Goban;		// le goban

extern Coordonnees_type	Liste_capturees_g1[400];	// il peut y avoir jusqu' 4 groupes de capturs simultanment !
extern u16					Nb_capturees_g1;
extern bool				groupe1_vivant;

extern Coordonnees_type	Liste_capturees_g2[400];
extern u16					Nb_capturees_g2;
extern bool				groupe2_vivant;

extern Coordonnees_type	Liste_capturees_g3[400];
extern u16					Nb_capturees_g3;
extern bool				groupe3_vivant;

extern Coordonnees_type	Liste_capturees_g4[400];
extern u16					Nb_capturees_g4;
extern bool				groupe4_vivant;

extern u16					Total_prisonniers_blancs;
extern u16					Total_prisonniers_noirs;

extern Pierre_type	Couleur_capturees;
extern u8 repartition_groupes [20][20];	// sert  dfinir les groupes de capture

extern CMyBitmap whiteStone384;
extern CMyBitmap blackStone384;
extern CMyBitmap whiteStone192;
extern CMyBitmap blackStone192;

//------------------------------------------------------------------------------

void PosePierreGobans(u8 a, u8 b, Pierre_type pierre)
{
	if (pierre==PierreBlanche)
	{
		u16 x2,y2;
						
		Goban2Screen384(a,b,x2,y2);
		//swiWaitForVBlank();			
		whiteStone384.CopyToMAIN_LARGE_BG(x2-9,y2-7);	
		
		Goban2Screen192(a,b,x2,y2);
		//swiWaitForVBlank();	
		whiteStone192.CopyToMAIN_BG(x2-3,y2-4);	
		
		Goban.intersection[a][b]=PierreBlanche;		
	}
	else if (pierre==PierreNoire)
	{
		u16 x2,y2;
				
		Goban2Screen384(a,b,x2,y2);
		//swiWaitForVBlank();			
		blackStone384.CopyToMAIN_LARGE_BG(x2-9,y2-7);	
		
		Goban2Screen192(a,b,x2,y2);
		//swiWaitForVBlank();	
		blackStone192.CopyToMAIN_BG(x2-3,y2-4);			
		
		Goban.intersection[a][b]=PierreNoire;		
	}	
	else if (pierre==AucunePierre)
	{
		u16 x2,y2;
				
		Goban2Screen384(a,b,x2,y2);
		
		if (Goban.intersection[a][b]==PierreBlanche)
			whiteStone384.RemoveFromMAIN_LARGE_BG(x2-9,y2-7);
		else if (Goban.intersection[a][b]==PierreNoire)
			blackStone384.RemoveFromMAIN_LARGE_BG(x2-9,y2-7);
				
		Goban2Screen192(a,b,x2,y2);			

		if (Goban.intersection[a][b]==PierreBlanche)
			whiteStone192.RemoveFromMAIN_BG(x2-3,y2-4);			
		else if (Goban.intersection[a][b]==PierreNoire)
			blackStone192.RemoveFromMAIN_BG(x2-3,y2-4);			
		
		Goban.intersection[a][b]=AucunePierre;		
	}	
}

// Fonctions rcupres de goban.c :

// TODO : faire une classe MyGoban ? ou intgrer  MyTree ?
// Bref, faire le mnage pour soulager main.h/main.cpp car ca commence  tre le bordel!

void initialise_goban(Goban_type* goban,string size)
{
	u8 a,b;

	Total_prisonniers_blancs=0;
	Total_prisonniers_noirs=0;

	if (size=="19")
	{	goban->size=19; }
/*	else
	if (size=="13")
	{	goban->size=13; }
	else
	if (size=="9")
	{	goban->size=9; }
*/
	else
	{
		//PA_ClearTextBg(1);
		iprintf("initialise_goban taille non prvue");
		//plante();
	}

	for (a=1;a<=goban->size;a++)
		for (b=1;b<=goban->size;b++)
		{
			goban->intersection[a][b]=AucunePierre;
		}
}

void convertit_coord(string str,Coordonnees_type &co,int size)
{
	char px;
	char py;

	if (str.length()!=2)
	{
		iprintf("ERREUR FATALE : convertit_coord : str=%d\n",str.c_str());
		while(1);
	}

	px=str[0];
	py=str[1];
		
	px=tolower(px);
	py=tolower(py);

	co.x=toascii(px)-toascii('a')+1;
	co.y=size-(toascii(py)-toascii('a'));
}

void pose_pierre(u8 xgoban,u8 ygoban,Pierre_type pierre)
{
	PosePierreGobans(xgoban,ygoban,pierre);
}


void copie_goban(Goban_type* goban_s,Goban_type* goban_d)
{
	u8 a,b;

	goban_d->size=goban_s->size;

	for (a=1;a<=goban_s->size;a++)
		for (b=1;b<=goban_s->size;b++)
		{
			goban_d->intersection[a][b]=goban_s->intersection[a][b];
		}
}

void Restore_Setup(Goban_type* goban)
{
	u8 a,b;

	for (a=1;a<=goban->size;a++)
		for (b=1;b<=goban->size;b++)
		{
			if (goban->intersection[a][b]!=AucunePierre)
				PosePierreGobans(a,b,goban->intersection[a][b]);
		}	
}

void verifie_capture(u8 x, u8 y)	// Couleur_capturee contient la couleur  capturer
									// x et y correspondent aux coordonnes de la pierre qui est cense capturer...
{
	u8 a,b;
	// initialisation
	Nb_capturees_g1=0;
	Nb_capturees_g2=0;
	Nb_capturees_g3=0;
	Nb_capturees_g4=0;

	groupe1_vivant=false;	// jusqu' preuve du contraire !
	groupe2_vivant=false;	
	groupe3_vivant=false;	
	groupe4_vivant=false;	

	for (a=1;a<=19;a++)
		for (b=1;b<=19;b++)
		{
			repartition_groupes[a][b]=0;
		}
		
	// Affectation des groupes et vrification !

	verifie_groupe1((x-1),y);
	verifie_groupe2((x+1),y);
	verifie_groupe3(x,(y-1));
	verifie_groupe4(x,(y+1));

	// Alors ?

	if (Nb_capturees_g1==0)
	{	groupe1_vivant=true;	}
	if (Nb_capturees_g2==0)
	{	groupe2_vivant=true;	}
	if (Nb_capturees_g3==0)
	{	groupe3_vivant=true;	}
	if (Nb_capturees_g4==0)
	{	groupe4_vivant=true;	}
/*
	ClearConsole();
	iprintf("x,y= %d,%d\n",x,y);
	iprintf("groupe1: vivant=%d pierre(s)=%d\n",groupe1_vivant,Nb_capturees_g1);
	iprintf("groupe2: vivant=%d pierre(s)=%d\n",groupe2_vivant,Nb_capturees_g2);
	iprintf("groupe3: vivant=%d pierre(s)=%d\n",groupe3_vivant,Nb_capturees_g3);
	iprintf("groupe4: vivant=%d pierre(s)=%d\n",groupe4_vivant,Nb_capturees_g4);
	WaitForTouch();
*/
	if (groupe1_vivant)
	{
		Nb_capturees_g1=0;	// ben ouais, tout de mme !
	}
	if (groupe2_vivant)
	{
		Nb_capturees_g2=0;
	}
	if (groupe3_vivant)
	{
		Nb_capturees_g3=0;
	}
	if (groupe4_vivant)
	{
		Nb_capturees_g4=0;
	}
}

void verifie_groupe1(u8 x, u8 y)
{	
	if (x==0||x>19||y==0||y>19)	// en dehors des limites!
	{ return; }
	if (Goban.intersection[x][y]==PierreBlanche && Couleur_capturees==PierreNoire)
	{ return; }
	if (Goban.intersection[x][y]==PierreNoire && Couleur_capturees==PierreBlanche)
	{ return; }

	if (Goban.intersection[x][y]==AucunePierre)	// Une libert !!!
	{ 
		groupe1_vivant=true;	// It's alive... ALIVE !!!
		return;
	}


	if (repartition_groupes[x][y]!=0)	// elle a dj un groupe!
	{
		return;
	}

	// Bienvenue dans le groupe1, ma belle...
	/*if (debug_mode)
	{
		PA_OutputText(1, 0, 8, "ajout au groupe1! ");wait_for_keypressed();
	}*/

	repartition_groupes[x][y]=1;
	Nb_capturees_g1++;

	// Ca vaut le coup de vrifier ses voisines, maintenant !

	verifie_groupe1(x-1,y);
	verifie_groupe1(x+1,y);
	verifie_groupe1(x,y-1);
	verifie_groupe1(x,y+1);
}

void verifie_groupe2(u8 x, u8 y)
{
	if (x==0||x>19||y==0||y>19)	// en dehors des limites!	// TODO : mettre la taille en dynamique !!!
	{ return; }
	if (Goban.intersection[x][y]==PierreBlanche && Couleur_capturees==PierreNoire)
	{ return; }
	if (Goban.intersection[x][y]==PierreNoire && Couleur_capturees==PierreBlanche)
	{ return; }

	if (Goban.intersection[x][y]==AucunePierre)	// Une libert !!!
	{ 
		groupe2_vivant=true;	// It's alive... ALIVE !!!
		return;
	}


	if (repartition_groupes[x][y]!=0)	// elle a dj un groupe!
	{
		return;
	}

	// Bienvenue dans le groupe2, ma belle...

	repartition_groupes[x][y]=2;
	Nb_capturees_g2++;

	// Ca vaut le coup de vrifier ses voisines, maintenant !

	verifie_groupe2(x-1,y);
	verifie_groupe2(x+1,y);
	verifie_groupe2(x,y-1);
	verifie_groupe2(x,y+1);
}

void verifie_groupe3(u8 x, u8 y)
{
	if (x==0||x>19||y==0||y>19)	// en dehors des limites!
	{ return; }
	if (Goban.intersection[x][y]==PierreBlanche && Couleur_capturees==PierreNoire)
	{ return; }
	if (Goban.intersection[x][y]==PierreNoire && Couleur_capturees==PierreBlanche)
	{ return; }

	if (Goban.intersection[x][y]==AucunePierre)	// Une libert !!!
	{ 
		groupe3_vivant=true;	// It's alive... ALIVE !!!
		return;
	}


	if (repartition_groupes[x][y]!=0)	// elle a dj un groupe!
	{
		return;
	}

	// Bienvenue dans le groupe3, ma belle...

	repartition_groupes[x][y]=3;
	Nb_capturees_g3++;

	// Ca vaut le coup de vrifier ses voisines, maintenant !

	verifie_groupe3(x-1,y);
	verifie_groupe3(x+1,y);
	verifie_groupe3(x,y-1);
	verifie_groupe3(x,y+1);
}

void verifie_groupe4(u8 x, u8 y)
{
	if (x==0||x>19||y==0||y>19)	// en dehors des limites!
	{ return; }
	if (Goban.intersection[x][y]==PierreBlanche && Couleur_capturees==PierreNoire)
	{ return; }
	if (Goban.intersection[x][y]==PierreNoire && Couleur_capturees==PierreBlanche)
	{ return; }

	if (Goban.intersection[x][y]==AucunePierre)	// Une libert !!!
	{ 
		groupe4_vivant=true;	// It's alive... ALIVE !!!
		return;
	}


	if (repartition_groupes[x][y]!=0)	// elle a dj un groupe!
	{
		return;
	}

	// Bienvenue dans le groupe4, ma belle...

	repartition_groupes[x][y]=4;
	Nb_capturees_g4++;

	// Ca vaut le coup de vrifier ses voisines, maintenant !

	verifie_groupe4(x-1,y);
	verifie_groupe4(x+1,y);
	verifie_groupe4(x,y-1);
	verifie_groupe4(x,y+1);
}
