//
// MyKeyboard.cpp
// --------------
// 
// Notre clavier  nous !

// It's clearly pictochat-like... thanks to Nintendo for the original design ! ^ ^

//
// DSgf : http://sourceforge.net/projects/dsgf
//

/* system includes */
#include <nds.h>
#include <nds/arm9/console.h> 	// module console	pour iprintf (debug)
#include <stdio.h> 				// fonctions standarts d'I/O (idem:debug/console)
#include <string>

using namespace std ;

/* my includes */
#include "main.h"
#include "MySound.h"
#include "MyBitmap.h"
#include "MyTools.h"
#include "MySprite.h"
#include "MyFont.h"
#include "MyKeyboard.h"

//---------------------------------------

extern u16* pSUB_BG;
extern u16* pMAIN_BG;
extern CMyBitmap keyboard_qwerty_lower;	
extern CMyBitmap keyboard_qwerty_shift;	
extern CMyBitmap keyboard_qwerty_caps;
extern	CMyFont*	arial12;
extern	CMyFont*	arialb22;
extern CMySound 	S_valid;
extern CMySound 	S_typewriter1;
extern CMySound 	S_typewriter2;

//---------------------------------------

// dclaration statique du clavier qwerty

const Touche CMyKeyboard::clavier_qwerty[45] =
{
	// premire ligne : de 0  11
	{'1','!'},{'2','@'},{'3','#'},{'4','!'},{'5','$'},{'6','^'},{'7','&'},{'8','*'},{'9','('},{'0',')'},{'-','_'},{'=','+'},
	// lignes 2,3 et 4...
	{'q','Q'},{'w','W'},{'e','E'},{'r','R'},{'t','T'},{'y','Y'},{'u','U'},{'i','I'},{'o','O'},{'p','P'},
	{'a','A'},{'s','S'},{'d','D'},{'f','F'},{'g','G'},{'h','H'},{'j','J'},{'k','K'},{'l','L'},
	{'z','Z'},{'x','X'},{'c','C'},{'v','V'},{'b','B'},{'n','N'},{'m','M'},{',','<'},{'.','>'},{'/','?'},
	// dernire ligne... les 2 premiers sont  gauche de "space" et les 2 autres  droite...
	{';',':'},{'\'','~'},{'[','{'},{']','}'}
};

const MyRect CMyKeyboard::coord_qwerty[45] =
{
	// premire ligne : de 0  11
	{26,105,15,14},{42,105,15,14},{58,105,15,14},{74,105,15,14},{90,105,15,14},{106,105,15,14},{122,105,15,14},{138,105,15,14},{154,105,15,14},{170,105,15,14},{186,105,15,14},{202,105,15,14},
	// lignes 2,3 et 4...
	{35,120,15,15},{51,120,15,15},{67,120,15,15},{83,120,15,15},{99,120,15,15},{115,120,15,15},{131,120,15,15},{147,120,15,15},{163,120,15,15},{179,120,15,15},
	{42,136,15,15},{58,136,15,15},{74,136,15,15},{90,136,15,15},{106,136,15,15},{122,136,15,15},{138,136,15,15},{154,136,15,15},{170,136,15,15},
	{50,152,15,15},{66,152,15,15},{82,152,15,15},{96,152,15,15},{112,152,15,15},{128,152,15,15},{144,152,15,15},{160,152,15,15},{178,152,15,15},{194,152,15,15},
	// dernire ligne... les 2 premiers sont  gauche de "space" et les 2 autres  droite...
	{58,168,15,14},{74,168,15,14},{170,168,15,14},{186,168,15,14}
};

//---------------------------------------

CMyKeyboard::CMyKeyboard()
{
	qwerty_RETURN.x=186;
	qwerty_RETURN.y=136;
	qwerty_RETURN.width=34;
	qwerty_RETURN.height=15;	
	
	qwerty_DELETE.x=195;
	qwerty_DELETE.y=120;
	qwerty_DELETE.width=25;
	qwerty_DELETE.height=15;	

	qwerty_SPACE.x=90;
	qwerty_SPACE.y=168;
	qwerty_SPACE.width=79;
	qwerty_SPACE.height=14;	

	qwerty_SHIFT.x=24;
	qwerty_SHIFT.y=152;
	qwerty_SHIFT.width=25;
	qwerty_SHIFT.height=15;

	qwerty_CAPS.x=24;
	qwerty_CAPS.y=136;
	qwerty_CAPS.width=17;
	qwerty_CAPS.height=15;	
}

CMyKeyboard::~CMyKeyboard()
{
}

//---------------------------------------

void CMyKeyboard::Edit(string titre,string &field)
{

	fadeToWhite(MAIN_SCREEN);
	
	CMyBitmap* pBas=new CMyBitmap(256,192);
	pBas->Fill(254);	
	
	BackupMainBG2();
		
	keyboard_qwerty_lower.Copy2Bitmap(pBas,0,103);
	
	arialb22->BasicWrite((char*)titre.c_str(),pBas,8,4);	
	pBas->DrawHorizLine(8,30,240,253);

	// Affichage initial de la valeur du champ
	
	arial12->WriteParagraph(field,pBas,9,40,247,94);
	
	pBas->Copy2VRAM(pMAIN_BG);

	fadeFromWhite(MAIN_SCREEN);
	
	// Boucle de saisie clavier...
	
	u8 styletx;
	u8 stylety;
	bool update_field;
	bool b_shift=false;
	bool b_caps=false;
	
	while(1)
	{		
		scanKeys();
		update_field=false;
		if (keysDown() & KEY_TOUCH)
		{							
			styletx=IPC->touchXpx;
			stylety=IPC->touchYpx;	
			
			if (IsHit(styletx,stylety,qwerty_RETURN))
			{
																// validation
				swiWaitForVBlank();	
				S_typewriter1.play();				
				break;
			}
			else if (IsHit(styletx,stylety,qwerty_DELETE))
			{
				if (field.length()>0)
				{
					update_field=true;
					field.erase(field.length()-1);					// vire le dernier caractre
					swiWaitForVBlank();	
					S_typewriter2.play();				
				}
			}
			else if (IsHit(styletx,stylety,qwerty_SPACE))
			{
				update_field=true;
				field+=" ";		
				swiWaitForVBlank();	
				S_typewriter1.play();				
		
			}
			else if (IsHit(styletx,stylety,qwerty_SHIFT))
			{
				update_field=true;
				if (b_shift)
				{
					keyboard_qwerty_lower.Copy2Bitmap(pBas,0,103);	
					b_shift=false;
					
				}
				else
				{
					keyboard_qwerty_shift.Copy2Bitmap(pBas,0,103);
					b_shift=true;
					b_caps=false;
				}
			}
			else if (IsHit(styletx,stylety,qwerty_CAPS))
			{
				update_field=true;
				if (b_caps)
				{
					keyboard_qwerty_lower.Copy2Bitmap(pBas,0,103);	
					b_caps=false;
				}
				else
				{
					keyboard_qwerty_caps.Copy2Bitmap(pBas,0,103);
					b_caps=true;
					b_shift=false;
				}
			}
			else
			{
				// on va tester sur chaque touche...
				//bool trouve=false;
				u8 i;
				for (i=0;i<=44;i++)
				{
					if (IsHit(styletx,stylety,coord_qwerty[i]))
					{
						// on a trouv la bonne touche...
						
						if (b_shift)
						{
							// tout en upper case
							field+=clavier_qwerty[i].m_idglyph_shifted;
						}
						else
						if (b_caps)
						{
							// 0  11 restent en lowercase, le reste en uppercase
							if (i<=11)
							{
								field+=clavier_qwerty[i].m_idglyph;
							}
							else
							{
								field+=clavier_qwerty[i].m_idglyph_shifted;
							}							
						}
						else
						{
							field+=clavier_qwerty[i].m_idglyph;
						}
						
						if (b_shift)	// s'il y avait un shift, et bien maintenant il n'y en a plus !
						{
							keyboard_qwerty_lower.Copy2Bitmap(pBas,0,103);	
							b_shift=false;
							
						}
						
						update_field=true;
						
						swiWaitForVBlank();	
						S_typewriter1.play();				

						break;
					}
				}
			}
		}
		else
		{
			// ?
		}
		
		// MAJ de l'cran ?
		if (update_field)
		{
			pBas->DrawRect(9,40,247-9,94-40,254);
			arial12->WriteParagraph(field,pBas,9,40,247,94);
			swiWaitForVBlank();	
			pBas->Copy2VRAM(pMAIN_BG);	
		}
	}	
	
	// back to normal...
	
	fadeToWhite(MAIN_SCREEN);
			
	RestoreMainBG2();
	
	//fadeFromWhite(BOTH_SCREENS);
}

//---------------------------------------
