//
// MySGF2.h
// --------
// 
// Prise en charge du format SGF et des parties
//
// DSgf : http://sourceforge.net/projects/dsgf
//

//------------------------------------------------------------------------------

#include <nds.h>
#include <nds/arm9/console.h> // module console	pour iprintf (debug)
#include <stdio.h>			  // fonctions standarts d'I/O (idem:debug/console)
#include <string>

using namespace std;

#include "MyBitmap.h"

//------------------------------------------------------------------------------

enum Typedenode_type {

	node_move,
	node_setup,
	node_neutral,
	node_pass

	};
	
struct Node_type {

	// Liste des actions pour chaque noeud.
	// Pour un coup simple, cel correspond  l'ajout d'une pierre
	// Mais cel peut correspondre  la dfinition d'un problme, d'une position complte
	// c.f. la doc SGF...

	string						node_name;

	string 						commande_SGF;	// Commande(s) SGF correspondant au noeud

	vector<string>				commentaire;	// doit se terminer par \0
												// vide si aucun commentaire
												
	u8							nb_volets_commentaires;	// nombre de volets de 256*126
														// ncessaires pour afficher
														// entirement le commentaire
														// prcalcul lors du chargement
														// pour gagner du lors lors du replay !

	Typedenode_type				type_node;	// node_move ou node_setup

	u16 						move_number;	// MN	
	Coordonnees_type			move_coord;		// coordonnes du coup
	Pierre_type					move_couleur;	// couleur du coup
	vector<Coordonnees_type>	move_captures;	// normalement vide, utilis si le coup capture des pierres

	Goban_type* setup_goban;		// normalement NULL, utilis uniquement en cas de "setup" (commandes AW,AE,WB)
	
	vector<Node_type*>	variantes;	// les variantes pour cette node

	struct Node_type*	node_amont;

	};

//------------------------------------------------------------------------------

class CMySGFTree
{
	public:

	string filename;
	
	// attributs globaux

	string application;			//AP
	string charset; 			//CA
	string fileformat;			//FF
	string game;				//GM
	string style;				//ST
	string size;				//SZ
	string annotation;			//AN
	string black_rank;			//BR
	string black_team;			//BT
	string copyright;			//CP
	string date;				//DT
	string event;				//EV
	string game_comment;		//GC
	string game_name;			//GN
	string opening;				//ON
	string player_black;		//PB
	string place;				//PC
	string player_white;		//PW
	string result;				//RE
	string round;				//RO
	string rules;				//RU
	string source;				//SO
	string time_limit;			//TM
	string user;				//US
	string white_rank;			//WR
	string white_team;			//WT
	string handicap;			//HA
	string komi;				//KM		
	
	int allocated_node_number;
	int allocated_goban_number;
	
	// root de l'arbre

	Node_type	*premiere_node;
	
	// fonctions
	
	CMySGFTree();
	~CMySGFTree();
	
	void ExtractHeaderAttributes(string entete);
	void ExtractAttribute(string source,string pattern,string &res);

	u8 ExtractComment(string entete,vector<string> &commentaire);

	void remplis_arbre(string filename,CMyBitmap* p_ecran);		// cr la structure de l'arbre avec les commandes SGF

	s8 Move_forward(Node_type* node);
	void Move_backward(Node_type* node);
	
	bool Enregistre_coup(Node_type* current_node, u8 xgoban,u8 ygoban,Pierre_type pierre);	// cr une nouvelle node  partir de la node courante

	void Capture_pierres(vector<Coordonnees_type>	move_captures);
	void Uncapture_pierres(vector<Coordonnees_type>	 move_captures,Pierre_type pierre);
	
	void RAZ();	// RAZ de l'arbre (destruction pointeurs, libration mmoire)
	
	void Detruit_aval(Node_type* current_node);	// dtruit l'arbre en aval de current node
};

//------------------------------------------------------------------------------

