//
// MySprite.cpp
// ------------
// 
// 
//
// DSgf : http://sourceforge.net/projects/dsgf
//

/* system includes */
#include <nds.h>
#include <nds/arm9/console.h> // module console	pour iprintf (debug)
#include <stdio.h>						// fonctions standarts d'I/O (idem:debug/console)

/* my includes */
#include "MyTools.h"
#include "MySprite.h"

// CMySprite

// initialisation des attributs statiques (communs  toutes les instances)

bool CMySprite::id_main[128]={0};
bool CMySprite::id_sub[128]={0};
	
u16* CMySprite::free_pos_main=SPRITE_GFX;
u16* CMySprite::free_pos_sub=SPRITE_GFX_SUB;	
	
SpriteEntry CMySprite::main_sprites[128];
SpriteEntry CMySprite::sub_sprites[128];
	
CMySprite::CMySprite(u8 screen, const u8* data, u8 sx, u8 sy)
{
	ecran=screen;
	id=GetNewId(screen);
	size_x=sx;
	size_y=sy;
	u16 index;
	p_data=(u8*)data;
	
	//iprintf("newid=%d;",id);
	
	if (screen==MAIN_SCREEN)
	{	
		on_MAIN=true;
		pdataVRAM=free_pos_main;
		free_pos_main+=size_x*size_y;
		index=(pdataVRAM-SPRITE_GFX)/16;
		
		dmaCopy(p_data, (pdataVRAM), size_x*size_y);
   
	  main_sprites[id].attribute[0] = ATTR0_COLOR_256 | 0; // y
	  
	  main_sprites[id].attribute[1] = ATTR1_ROTDATA(0) | 256; // x
	  if (size_x==16 && size_y==16)
	  {
	  	main_sprites[id].attribute[1]|=ATTR1_SIZE_16;
	  }
	  else
	  if (size_x==32 && size_y==32)
	  {
	  	main_sprites[id].attribute[1]|=ATTR1_SIZE_32;
	  }
	  else
	  if (size_x==64 && size_y==64)
	  {
	  	main_sprites[id].attribute[1]|=ATTR1_SIZE_64;
	  }  	
	  else
	  {
	  	erreurFatale("CMySprite::CMySprite: dimensions incorrectes!");
	  }
	  //main_sprites[id].attribute[1] = ATTR1_ROTDATA(0) | ATTR1_SIZE_16 | 256; // x
	  main_sprites[id].attribute[2] = index;
		
	}
	else
	{
		on_MAIN=false;
		pdataVRAM=free_pos_sub;
		free_pos_sub+=size_x*size_y;
		index=(pdataVRAM-SPRITE_GFX_SUB)/16;
		
		dmaCopy(p_data, (pdataVRAM), size_x*size_y);
   
	  sub_sprites[id].attribute[0] = ATTR0_COLOR_256 | 0; // y
	  
	  sub_sprites[id].attribute[1] = ATTR1_ROTDATA(0) | 256; // x
	  if (size_x==16 && size_y==16)
	  {
	  	sub_sprites[id].attribute[1]|=ATTR1_SIZE_16;
	  }
	  else
	  if (size_x==32 && size_y==32)
	  {
	  	sub_sprites[id].attribute[1]|=ATTR1_SIZE_32;
	  }
	  else
	  if (size_x==64 && size_y==64)
	  {
	  	sub_sprites[id].attribute[1]|=ATTR1_SIZE_64;
	  }  	
	  else
	  {
	  	erreurFatale("CMySprite::CMySprite: dimensions incorrectes!");
	  }
	  //sub_sprites[id].attribute[1] = ATTR1_ROTDATA(0) | ATTR1_SIZE_16 | 256; // x
	  sub_sprites[id].attribute[2] = index;		
	}		
}
	
bool CMySprite::isHit(u8 sx,u8 sy)
{
	if (((sx>=x)&&(sx<=(x+size_x)))
		&& ((sy>=y)&&(sy<=(y+size_y))))
		{ return true; }
	else
		{ return false; }
}	

void CMySprite::RestoreGfx()	// remet le gfx initial
{
	dmaCopy(p_data, (pdataVRAM), size_x*size_y);
}

/*
void CMySprite::SetPixel(s16 x,s16 y,u8 color)
{
	// TODO
}

u8 CMySprite::GetPixel(s16 x,s16 y)
{
	// TODO	
}

void CMySprite::Copy2Bitmap(s16 x0,s16 y0, s16 width, s16 height, CMyBitmap* pbmpdest, s16 x1, s16 y1)
{
	// TODO	
}

void CMySprite::Copy2Bitmap(s16 x0,s16 y0,CMyBitmap* pbmpdest, s16 x1, s16 y1)
{
	// TODO
}
*/	
CMySprite::~CMySprite()
{
	// TODO
}

u8 CMySprite::GetNewId(u8 screen)
{
		int x=0;
		
		if (screen==MAIN_SCREEN)
		{
			while (CMySprite::id_main[x])
			{
				x++;
			}
			CMySprite::id_main[x]=true;
		}
		else	// SUB_SCREEN
		{
			while (CMySprite::id_sub[x])
			{
				x++;
			}
			CMySprite::id_sub[x]=true;			
		}		
		
		return x;
}

void CMySprite::move(MyPoint point)
{
	move(point.x,point.y);
}

void CMySprite::move(s16 mx,s16 my)
{	
	x=mx;
	y=my;
	
	if (on_MAIN)
	{	
		main_sprites[id].attribute[1] &= 0xFE00;
		main_sprites[id].attribute[1] |= (x & 0x01FF);
	
		main_sprites[id].attribute[0] &= 0xFF00;
		main_sprites[id].attribute[0] |= (y & 0x00FF);
	}
	else
	{	
		sub_sprites[id].attribute[1] &= 0xFE00;
		sub_sprites[id].attribute[1] |= (x & 0x01FF);
	
		sub_sprites[id].attribute[0] &= 0xFF00;
		sub_sprites[id].attribute[0] |= (y & 0x00FF);
	}		
}

void CMySprite::cache()
{
	move(256,0);
}	

bool avanceAnimation(MySpriteAnim &anim)
{
	//iprintf("x=%d y=%d\n",anim.x,anim.y);
	if (anim.etat==animOFF)
	{
		return false;
	}
	else if (anim.etat==animIncoming)
	{		
		anim.step++;
		if (anim.step<=anim.steps)
		{
			anim.x+=anim.dx;
			anim.y+=anim.dy;
			
			if (anim.y<-16 || anim.y > 192)
				anim.sprite->cache();
			else			
				anim.sprite->move(anim.x,anim.y);
		}			
		else
		{
			if (anim.type==MenuAnim)
				anim.etat=animWaiting;
			else
			{
				anim.etat=animOFF;
				anim.sprite->cache();
				return true;
			}
		}
	}
	else if (anim.etat==animFleeing)
	{
		anim.step++;
		if (anim.step<=anim.steps)
		{
			anim.x-=anim.dx;
			anim.y-=anim.dy;
			anim.sprite->move(anim.x,anim.y);
		}							
		else
		{
			anim.etat=animOFF;
			anim.sprite->cache();
		}
	}	
	else if (anim.etat==animBlink)
	{
		anim.index_clignotement++;
		if (anim.index_clignotement>=anim.freq_clignotement)
		{
			anim.index_clignotement=0;
			if (anim.blink_on)
			{	
				anim.sprite->cache();
				anim.blink_on=false;
			}
			else
			{	
				anim.sprite->move(anim.destination);
				anim.blink_on=true;
			}				
		}		
	}
	else if (anim.etat==animWaiting)
	{
		//iprintf("waiting...%d\n",anim.index_duree);
		anim.index_duree++;
		if (anim.index_duree>=anim.duree_affichage)
		{
			anim.etat=animFleeing;
			anim.step=0;
			return true;
		}		
	}	
	return false;	
}


