//
// MySprite.h
// ----------
// 
// Classes et fonctions graphiques
//
// DSgf : http://sourceforge.net/projects/dsgf
//

/* system includes */
#include <nds.h>

/* my includes */
#include "main.h"
#include "MyBitmap.h"

#ifndef MYSPRITE_H
#define MYSPRITE_H

// CMySprite

class CMySprite
{
public:
	
	// attributs

	u8*			p_data;
	
	bool		on_MAIN;

	u8 id;	
	u8 ecran;
	u16 x,y;
	u8 size_x,size_y;	
	
	u16* pdataVRAM;
		
	// fonctions

	u8 GetNewId(u8 screen);
	
	void move(MyPoint point);
	void move(s16 mx,s16 my);
	void cache();
	bool isHit(u8 sx,u8 sy);

	void RestoreGfx();
	//void SetPixel(s16 x,s16 y,u8 color);
	//u8 GetPixel(s16 x,s16 y);

	//void Copy2Bitmap(s16 x0,s16 y0, s16 width, s16 height, CMyBitmap* pbmpdest, s16 x1, s16 y1);
						// copie le rectangle x0,y0/width,length
						// du sprite vers le bitmap bmpdest aux coordonnes x1, y1
						
	// Constructeur du sprite
	
	CMySprite(u8 screen, const u8* data, u8 sx, u8 sy);	// cr un sprite  partir d'un binaire de sprite
																				// avec screen = MAIN_SCREEN ou SUB_SCREEN
	
	void Copy2Bitmap(s16 x0,s16 y0, CMyBitmap* pbmpdest, s16 x1, s16 y1); // le mme mais on copie l'intgralit du sprite	
	
	// Destructeur du sprite
	
	~CMySprite();
	
	// static (partags entre les instances)
	
	static bool id_main[128];
	static bool id_sub[128];
	
	static u16* free_pos_main;
	static u16* free_pos_sub;
	
	static SpriteEntry main_sprites[128];
	static SpriteEntry sub_sprites[128];
	
	//static pSpriteRotation main_spriteRotations;
	//static pSpriteRotation sub_spriteRotations;
	
	static void updateMainOAM()
	{
		DC_FlushAll();
    dmaCopy(main_sprites, OAM, 128 * sizeof(SpriteEntry));
	};
	
	static void updateSubOAM()
	{
		DC_FlushAll();
    dmaCopy(sub_sprites, OAM_SUB, 128 * sizeof(SpriteEntry));
	};
	
	static void InitialisationOAMs()
	{
		//main_spriteRotations = (pSpriteRotation)main_sprites;	// la rotation n'est pas utilise
		//sub_spriteRotations = (pSpriteRotation)sub_sprites;
		
		for(int i = 0; i < 128; i++)
		{
			id_main[i]=0;
	   	main_sprites[i].attribute[0] = ATTR0_DISABLED;
	   	main_sprites[i].attribute[1] = 0;
	   	main_sprites[i].attribute[2] = 0;
	   	main_sprites[i].attribute[3] = 0;
	   
	    id_sub[i]=0;
	   	sub_sprites[i].attribute[0] = ATTR0_DISABLED;
	   	sub_sprites[i].attribute[1] = 0;
	   	sub_sprites[i].attribute[2] = 0;
	   	sub_sprites[i].attribute[3] = 0;
    }		
    
    CMySprite::free_pos_main=SPRITE_GFX;
		CMySprite::free_pos_sub=SPRITE_GFX_SUB;	
    
    updateMainOAM();
    updateSubOAM();
	};		
};

enum enumEtatSpriteAnim
{
	animOFF,animWaiting,animBlink,animIncoming,animFleeing
};

enum enumTypeSpriteAnim
{
	MenuAnim,CaretAnim
};


struct MySpriteAnim
{
		enumTypeSpriteAnim	type;
	
		enumEtatSpriteAnim	etat;
		
		CMySprite* sprite;
		
		MyPoint	destination;
		
		s16 x;
		s16 y;
		
		s16 dx;
		s16 dy;
		
		u8	steps;
		u8	step;
		
		u8 freq_clignotement;	// en nombre de boucles de jeu (dure variable, mais >> 1/60s!)
		u8 index_clignotement;
		u8 duree_affichage;		// idem
		u8 index_duree;
		
		bool blink_on;
		
		MySpriteAnim() : etat(animOFF),sprite(0),freq_clignotement(15),duree_affichage(175)
		{ }
};

bool avanceAnimation(MySpriteAnim &anim);

#endif /* MYSPRITE_H */
