//
// MySwitch.cpp
// ------------
// 
// Une toute petite classe pour grer les switch texte (type option ON/OFF)

//
// DSgf : http://sourceforge.net/projects/dsgf
//
/* system includes */
#include <nds.h>
#include <nds/arm9/console.h> 	// module console	pour iprintf (debug)
#include <stdio.h> 				// fonctions standarts d'I/O (idem:debug/console)
#include <string>

using namespace std ;

/* my includes */
#include "main.h"
#include "MyBitmap.h"
#include "MyTools.h"
#include "MyFont.h"
#include "MySwitch.h"

extern CMyFont*	arial12;	// pour dire que cette variable principale est dfinie ailleurs (dans main.cpp)

//---------------------------------------

CMySwitch::CMySwitch(CMyBitmap* pbmp,string v0,string v1,bool etat,u16 x, u16 y)
{

	//iprintf("x=%d y=%d\n",rect.x,rect.y);

	m_rect.x=x;
	m_rect.y=y;
	m_pbmp=pbmp;
	m_valeur0=v0;
	m_valeur1=v1;
	
	//iprintf("v0=.%s.\n",v0.c_str());
	//iprintf("v1=.%s.\n",v1.c_str());
	
	//iprintf("m_valeur0=.%s.\n",m_valeur0.c_str());
	//iprintf("m_valeur1=.%s.\n",m_valeur1.c_str());
	
	m_etat=etat;
	
	string texte;
	
	if (etat)
	{
		//iprintf("etat==1!\n");
		texte=m_valeur1;
	}
	else
	{
		//iprintf("etat==0!\n");
		texte=m_valeur0;
	}
	
	//iprintf("texte=.%s.\n",texte.c_str());
	
	// go!
	//iprintf("avant getwordadvance\n");
	//iprintf("texte=.%s.\n",texte.c_str());
	u16 l=arial12->GetWordAdvance(texte);
	//iprintf("apres getwordadvance l=%d\n",l);
	m_rect.width=l+8;
	m_rect.height=12+2;
	
//iprintf("AVANT writepara\n");		

	//iprintf("x=%d y=%d\n",m_rect.x+4,m_rect.y+1);

	arial12->WriteParagraph(texte.c_str(),m_pbmp,m_rect.x+4,m_rect.y+1,m_rect.x+l+8,m_rect.y+12+2);	
//iprintf("APRES writepara\n");
	m_pbmp->DrawFrameRect(m_rect,253);	
//iprintf("AVANT DrawFrameRect\n");
}

void CMySwitch::doSwitch()
{
	m_pbmp->Fill(m_rect,254);
	m_pbmp->DrawFrameRect(m_rect,254);

	m_etat=!m_etat;
	string texte;
	if (m_etat)
		texte=m_valeur1;
	else
		texte=m_valeur0;
		
	// go!
	int l=arial12->GetWordAdvance(texte);
	
	m_rect.width=l+8;
	m_rect.height=12+2;
	
	m_pbmp->Fill(m_rect,254);
	m_pbmp->DrawFrameRect(m_rect,254);
	
	arial12->WriteParagraph(texte.c_str(),m_pbmp,m_rect.x+4,m_rect.y+1,m_rect.x+l+8,m_rect.y+12+2);	
	m_pbmp->DrawFrameRect(m_rect,253);
}

bool CMySwitch::IsHit(u16 sx,u16 sy)
{
	return (::IsHit(sx,sy,m_rect));
}

string 	CMySwitch::getResult()
{
	if (m_etat)
		return m_valeur1;
	else
		return m_valeur0;	
}

CMySwitch::~CMySwitch()
{
}

//---------------------------------------
