//
// MyTools.cpp
// -----------
// 
// Boite  outils / fourre-tout !
//
// DSgf : http://sourceforge.net/projects/dsgf
//

/* system includes */
#include <nds.h>
#include <nds/arm9/console.h> 	// module console

/* my includes */
#include "main.h"
#include "MyTools.h"
#include "MyFont.h"

void sleep(int nbsecondes)
{
	int delay;
	// On attend nbsecondes*60 balayages d'cran ( 60Hz) => nbsecondes secondes !
	for (delay=nbsecondes*60;delay>0;delay--){ swiWaitForVBlank(); }
}

int Convert255to32(int value)
{
	float f=(((float)value)*31/255);
	return ((int)f);
}

void sleepCycles(int nbcycles)
{
	int delay;
	// On attend nbcycles
	for (delay=nbcycles;delay>0;delay--){ swiWaitForVBlank(); }
}

void erreurFatale(char* mess)
{
	iprintf(mess);
	while (1)
	{
		swiWaitForVBlank();
	}
}

void SetPaletteMAIN_BG(const u8* pal_bin)
{
	dmaCopy(pal_bin, BG_PALETTE, 256*2);  
}

void SetPaletteSUB_BG(const u8* pal_bin)
{
	dmaCopy(pal_bin, BG_PALETTE_SUB, 256*2); 
	BG_PALETTE_SUB[255] = RGB15(31,31,31);	// pour la police de la console! 
}

void SetPaletteMAIN_Sprite(const u8* pal_bin)
{
	dmaCopy(pal_bin, SPRITE_PALETTE, 256*2);  
}

void SetPaletteSUB_Sprite(const u8* pal_bin)
{
	dmaCopy(pal_bin, SPRITE_PALETTE_SUB, 256*2);  
}

void SetBrightness(u8 screen, s8 bright) {
u16 mode = 1 << 14;

	if (bright < 0) {
		mode = 2 << 14;
		bright = -bright;
	}
	if (bright > 31) bright = 31;
	_REG16(REG_BRIGHT + (0x1000 * screen)) = bright + mode;
}

void ecranBlanc(u8 ecran)
{
	if (ecran==BOTH_SCREENS)
	{
			SetBrightness(MAIN_SCREEN, 31);
			SetBrightness(SUB_SCREEN, 31);
	}
		else
	{		SetBrightness(ecran, 31); }
}

void ecranNoir(u8 ecran)
{
	if (ecran==BOTH_SCREENS)
	{
			SetBrightness(MAIN_SCREEN, -31);
			SetBrightness(SUB_SCREEN, -31);
	}
		else
	{		SetBrightness(ecran, -31); }
}

void fadeFromWhite(u8 ecran,u8 fade_loop_delay,u8 fade_limit)
{
	int i, delay;
	
	for (i=fade_limit; i>=0;i--)
	{
		for (delay=fade_loop_delay;delay>0;delay--){ swiWaitForVBlank(); }
		if (ecran==BOTH_SCREENS)
		{
			SetBrightness(MAIN_SCREEN, i);
			SetBrightness(SUB_SCREEN, i);
		}
		else
		{
			SetBrightness(ecran, i);
		}			
	}
}

void fadeFromBlack(u8 ecran,u8 fade_loop_delay,u8 fade_limit)
{
	int i, delay;
	
	for (i=-fade_limit; i<=0;i++)
	{
		for (delay=fade_loop_delay;delay>0;delay--){ swiWaitForVBlank(); }
		if (ecran==BOTH_SCREENS)
		{
			SetBrightness(MAIN_SCREEN, i);
			SetBrightness(SUB_SCREEN, i);
		}
		else
		{
			SetBrightness(ecran, i);
		}			
	}
}

void fadeToWhite(u8 ecran,u8 fade_loop_delay,u8 fade_limit)
{
	int i, delay;
	
	for (i=0; i<=fade_limit;i++)
	{
		for (delay=fade_loop_delay;delay>0;delay--){ swiWaitForVBlank(); }
		if (ecran==BOTH_SCREENS)
		{
			SetBrightness(MAIN_SCREEN, i);
			SetBrightness(SUB_SCREEN, i);
		}
		else
		{
			SetBrightness(ecran, i);
		}			
	}
}

void Initialisation_2D()
{
	powerON(POWER_ALL_2D); // On teint les modules qui ne servent pas (conomie des batteries!)
	
	//irqs are nice
	irqInit();
	irqSet(IRQ_VBLANK, 0);
	irqEnable(IRQ_VBLANK);
}

bool IsHit(u8 sx, u8 sy, MyPoint p1,MyPoint p2)	// p1 en haut  gauche, p2 en bas  droite
{
	if (((sx>=p1.x)&&(sx<=p2.x))&&((sy>=p1.y)&&(sy<=p2.y)))
		return true;
	else
		return false;
}

bool IsHit(u8 sx,u8 sy,u8 x, u8 y, u8 width, u8 height)
{
	if (((sx>=x)&&(sx<=x+width))&&((sy>=y)&&(sy<=y+height)))
		return true;
	else
		return false;
}

bool IsHit(u8 sx,u8 sy,MyRect rect)
{
	return IsHit(sx,sy,rect.x,rect.y,rect.width,rect.height);
}

void WaitForTouch()
{
	while(1)
	{
		swiWaitForVBlank();
		scanKeys();  
	  if ((keysDown() & KEY_TOUCH))
  		break;
  	if ((keysDown() & KEY_A))
  		break;
  	if ((keysDown() & KEY_B))
  		break;
  	if ((keysDown() & KEY_X))
  		break;
  	if ((keysDown() & KEY_Y))
  		break;
  	if ((keysDown() & KEY_L))
  		break;
  	if ((keysDown() & KEY_R))
  		break;
  	if ((keysDown() & KEY_START))
  		break;
  	if ((keysDown() & KEY_SELECT))
  		break;  	
  }
}

void ClearConsole()
{
	iprintf("\x1b[2J");	// ca efface la console !
}

// outils de conversion pour C++ strings

// Apparemment les templates ne sont pas supportes par le compilo' !?!
// on va donc tout prvoir !

std::string to_string( u8 Value )
{
    std::ostringstream oss;
    oss << Value;
    return oss.str();
}

std::string to_string( u16 Value )
{
    std::ostringstream oss;
    oss << Value;
    return oss.str();
}

std::string to_string( u32 Value )
{
    std::ostringstream oss;
    oss << Value;
    return oss.str();
}
std::string to_string( s8 Value )
{
    std::ostringstream oss;
    oss << Value;
    return oss.str();
}
std::string to_string( s16 Value )
{
    std::ostringstream oss;
    oss << Value;
    return oss.str();
}
std::string to_string( s32 Value )
{
    std::ostringstream oss;
    oss << Value;
    return oss.str();
}
std::string to_string( float Value )
{
    std::ostringstream oss;
    oss << Value;
    return oss.str();
}

bool from_string( const std::string & Str, u8 & Dest )
{
    std::istringstream iss( Str );
    return iss >> Dest != 0;
}

bool from_string( const std::string & Str, u16 & Dest )
{
    std::istringstream iss( Str );
    return iss >> Dest != 0;
}
bool from_string( const std::string & Str, u32 & Dest )
{
    std::istringstream iss( Str );
    return iss >> Dest != 0;
}
bool from_string( const std::string & Str, s8 & Dest )
{
    std::istringstream iss( Str );
    return iss >> Dest != 0;
}
bool from_string( const std::string & Str, s16 & Dest )
{
    std::istringstream iss( Str );
    return iss >> Dest != 0;
}
bool from_string( const std::string & Str, s32 & Dest )
{
    std::istringstream iss( Str );
    return iss >> Dest != 0;
}
bool from_string( const std::string & Str, float & Dest )
{
    std::istringstream iss( Str );
    return iss >> Dest != 0;
}

//--------------------------------------------------------------

std::string gobanx2letter(u8 x)	// goban version
{
	switch ( x )
	{
		case 1 : 
			return "a";
		case 2 : 
			return "b";
		case 3 : 
			return "c";
		case 4 : 
			return "d";
		case 5 : 
			return "e";
		case 6 : 
			return "f";
		case 7 : 
			return "g";
		case 8 : 
			return "h";
		case 9 : 
			return "j";
		case 10 : 
			return "k";
		case 11 : 
			return "l";
		case 12 : 
			return "m";
		case 13 : 
			return "n";
		case 14 : 
			return "o";
		case 15 : 
			return "p";
		case 16 : 
			return "q";
		case 17 : 
			return "r";
		case 18 : 
			return "s";
		case 19 : 
			return "t";	

		default : 
			return "?";
	}
}

std::string gobanx2letterWithI(u8 x)	// SGF version
{
	switch ( x )
	{
		case 1 : 
			return "a";
		case 2 : 
			return "b";
		case 3 : 
			return "c";
		case 4 : 
			return "d";
		case 5 : 
			return "e";
		case 6 : 
			return "f";
		case 7 : 
			return "g";
		case 8 : 
			return "h";
		case 9 : 
			return "i";
		case 10 : 
			return "j";
		case 11 : 
			return "k";
		case 12 : 
			return "l";
		case 13 : 
			return "m";
		case 14 : 
			return "n";
		case 15 : 
			return "o";
		case 16 : 
			return "p";
		case 17 : 
			return "q";
		case 18 : 
			return "r";
		case 19 : 
			return "s";	

		default : 
			return "?";
	}
}

u32 GetFileSize( std::stringstream & Fichier )
{
    // sauvegarder la position courante
    u32 pos = Fichier.tellg();
    // se placer en fin de fichier
    Fichier.seekg( 0 , std::ios_base::end );
    // rcuprer la nouvelle position = la taille du fichier
    u32 size = Fichier.tellg() ;
    // restaurer la position initiale du fichier
    Fichier.seekg( pos,  std::ios_base::beg ) ;
    return size ;
}

u32  GetFileSize(FILE* fd)
{
   u32 size;
   fseek(fd, 0, SEEK_END);       // aller  la fin
   size = ftell(fd);             // lire la taille
   fseek(fd, 0, SEEK_SET);       // revenir au dbut!
   return size;
}

