//
// main.cpp
// --------
// 
// DSgf - programme principal
//
// DSgf : http://sourceforge.net/projects/dsgf
//

/* system includes */
#include <nds.h>							// libnds
#include <nds/arm9/console.h> 				// module console
#include <stdio.h>							// fonctions standarts d'I/O
#include <fcntl.h>
#include <unistd.h>
#include "ctype.h"							// je ne sais plus pourquoi !?!
//#include <string.h>						// les string en C
#include <string>							// ha... les string en C++... c'est quand mme autre chose qu'en C, hein !
#include <sstream>							// string streams... marvelous!
#include <sys/stat.h>
#include <sys/dir.h> 
#include <fstream>
#include <iostream>
#include <vector>
//#include <ctime> 
//#include <cstdlib>

using namespace std ;	

/* "others" C includes */

#include "fat.h"

/*extern "C" {								// ncessaire sinon erreur au linkage (voir la FAQ mixing C/C++)
	#include "dirent.h"
 }
*/
 
/* my CPP includes */
#include "main.h"					// dfinitions globales et donnes fichiers binaires (/data)
#include "MyTools.h"				// boite  outils
#include "MyLocalization.h"			// basic langage translation
#include "MyBitmap.h"				// GFX
#include "MySprite.h"				// GFX
#include "MySound.h"				// son
#include "MyFont.h"					// police de caractre
#include "MyChoiceList.h"			// liste droulante
#include "MySwitch.h"				// les "boutons" de type switch/option ON/OFF
#include "MyGoban.h"
#include "MySGF2.h"					// prise en charge des SGF
#include "MyKeyboard.h"				// clavier de saisie

//-------------------------------------------------------------------

// places ici car elles servent pendant toute la dure d'utilisation (ou presque)
// + dans les sous-fonctions de la boucle principale
// les variables temporaires n'ont rien  faire ici et doivent tre dclares en ligne
// dans les sous-fonctions correspondantes


	// Localization
	Localization	MyLocalization;

	// fonts
	CMyFont*		arial12;
	CMyFont*		arialb22;

	// sprites
	CMySprite* whiteStoneMenu_spr;
	CMySprite* blackStoneMenu_spr;
	
	CMySprite* whiteStone384_spr;
	CMySprite* blackStone384_spr;

	CMySprite* whiteStone192_spr;
	CMySprite* blackStone192_spr;
		
	CMySprite*	database_spr;
	CMySprite*	diskette_spr;
	CMySprite*	eject_spr;
	CMySprite*	fastforward_spr;
	CMySprite*	play_spr;
	CMySprite*	quote_spr;
	CMySprite*	rewind_spr;
	CMySprite*	skipback_spr;
	CMySprite*	skip_spr;
	CMySprite*	trash_spr;
	CMySprite*	user_spr;
	CMySprite*	playback_spr;
	CMySprite* 	checkmark_spr;

	// backgrounds
	CMyBitmap pageMenuHaut(menu_haut_Bitmap_bin,256,192);	
	
	// Goban
	CMyBitmap gobanNormal(goban_256x192_zinger3_Bitmap_bin,256,192);	
	CMyBitmap gobanZoom(goban_512x384_zinger3_Bitmap_bin,512,384);
	
	// bitmaps
	CMyBitmap whiteStone384(white_stone_384_type2_Bitmap_bin,32,32);	
	CMyBitmap blackStone384(black_stone_384_type2_Bitmap_bin,32,32);
	CMyBitmap whiteStone192(white_stone_192_type2_Bitmap_bin,16,16);	
	CMyBitmap blackStone192(black_stone_192_type2_Bitmap_bin,16,16);
	CMyBitmap caution(caution_Bitmap_bin,16,16);	
	CMyBitmap checkmark(checkmark_Bitmap_bin,16,16);
	CMyBitmap clipboard(clipboard_Bitmap_bin,16,16);
	CMyBitmap database(database_Bitmap_bin,16,16);
	CMyBitmap user(user_Bitmap_bin,16,16);
	CMyBitmap x(x_Bitmap_bin,16,16);	
	CMyBitmap cclogo(cclogo_Bitmap_bin,96,32);
	CMyBitmap dragon1(dragon1_Bitmap_bin,112,112);
	CMyBitmap dragon2(dragon2_Bitmap_bin,112,160);
	CMyBitmap page_commentaire(256,256);
	CMyBitmap fleche_haut(fleche_haut_Bitmap_bin,16,16);
	CMyBitmap fleche_bas(fleche_bas_Bitmap_bin,16,16);
	CMyBitmap decor(decor_Bitmap_bin,256,192);
	CMyBitmap helpA(helpA_Bitmap_bin,256,192);
	CMyBitmap helpB(helpB_Bitmap_bin,256,192);	
	
	// Flags for langage selection
	CMyBitmap flagFRA(flagFRA_Bitmap_bin,32,20);
	CMyBitmap flagENG(flagENG_Bitmap_bin,32,20);

	// keyboard
	
	CMyBitmap keyboard_qwerty_lower(DSGF_keyboard_qwerty_lowercase_Bitmap_bin,256,89);	
	CMyBitmap keyboard_qwerty_shift(DSGF_keyboard_qwerty_shift_Bitmap_bin,256,89);	
	CMyBitmap keyboard_qwerty_caps(DSGF_keyboard_qwerty_caps_Bitmap_bin,256,89);	

	CMyKeyboard	keyboard;

	// sons

	CMySound S_intro(DSgf_intro_raw,DSgf_intro_raw_size,32000,127,64,0);
						// encod avec Switch en RAW, 16bitLE, 32000Hz, mono
						// 127 c'est le volume et 64 le "panning"; 0 pour 16bit/1 pour 8 bit signed
	CMySound S_valid(ting_raw,ting_raw_size,32000,96,64,0);	
	CMySound S_cancel(tulin_raw,tulin_raw_size,32000,32,64,0);
	CMySound S_pierre1(pierre3_raw,pierre3_raw_size,32000,127,64,0);
	CMySound S_pierre2(pierre5_raw,pierre5_raw_size,32000,127,64,0);
	CMySound S_capture(capture4_raw,capture4_raw_size,32000,127,64,0);
	CMySound S_menu(tchinglong_raw,tchinglong_raw_size,32000,8,64,0);
	CMySound S_typewriter1(typewriter1_raw,typewriter1_raw_size,32000,127,64,0);
	CMySound S_typewriter2(typewriter2_raw,typewriter2_raw_size,32000,127,64,0);
	
	// animations de sprites	
	MySpriteAnim nav1,nav2,nav3,nav4,nav5,nav6;	// les sprites de navigation (rewind, play, skip, et...)
	
	MySpriteAnim database_anim,eject_anim;	// pour le mode lecture de SGF
	
	MySpriteAnim comment_anim;	// pour l'dition de commentaires
	
	MySpriteAnim whitestone384_anim,blackstone384_anim;	
	MySpriteAnim whitestone192_anim,blackstone192_anim;	
	
	MySpriteAnim checkmark_anim;

// ------------------------------------------------

	u16* pMAIN_BG;
	u16* pMAIN_LARGE_BG;
	u16* pSUB_BG;
		
	MenuMode	current_mode;
	EcranHautMode modeEcranHaut;
	
	bool MAIN_BG2_is_in_front;
	
	bool menu_actif;
	
	CMyBitmap* pmasque_pierre384;
	CMyBitmap* pmasque_pierre192;
	
	CMyBitmap* pEcranCommentaires;
	CMyBitmap* pEcranStats;

	vector<string> proverbes; 
	vector<string> commandements; 

// ------------------------------------------------

CMySGFTree	SGF_tree;	// l'arbre SGF
	
Goban_type	Goban;		// le goban

Node_type* current_node;

Pierre_type NextToPlay;	// Qui doit jouer le prochain coup ? (mode record only)

// ------------------------------------------------

Pierre_type	Couleur_capturees;	// idem

u8 repartition_groupes [20][20];	// sert  dfinir les groupes de capture

// TODO : optimiser les listes d'lments capturs (dfinitions locale, taille tableaux variables,et...)

Coordonnees_type	Liste_capturees_g1[400];	// il peut y avoir jusqu' 4 groupes de capturs simultanment !
u16					Nb_capturees_g1;
bool				groupe1_vivant;

Coordonnees_type	Liste_capturees_g2[400];
u16					Nb_capturees_g2;
bool				groupe2_vivant;

Coordonnees_type	Liste_capturees_g3[400];
u16					Nb_capturees_g3;
bool				groupe3_vivant;

Coordonnees_type	Liste_capturees_g4[400];
u16					Nb_capturees_g4;
bool				groupe4_vivant;

u16					Total_prisonniers_blancs;
u16					Total_prisonniers_noirs;

u16					Nombre_total_coups;

bool				commentaire_avant;
u8					page_en_cours;	// l'index de la page de commentaire affiche (commence  1)
	
//-------------------------------------------------------------------

// Remarque : par convention, les transitions entre tats/menus se font avec les crans blancs...
// => revenir du fondu en dbut de boucle et y retourner en fin de traitement !

//-------------------------------------------------------------------

// Main loop

int main(void)
{			

	bool AskLangage=false;

	// Configuration VRAM et autres...
	
	InitialisationHardware();
	
	// let's go!
	
	SplashScreens();
	
	// Le point de non retour...
	
	SetPaletteMAIN_BG(master_Pal_bin);
	SetPaletteSUB_BG(master_Pal_bin);
			
		// on met la console en blanc sur noir
		
	BG_PALETTE_SUB[255] = RGB15(31,31,31);			// pour la console, on met en dur le blanc et le noir (ici, le blanc)
	BG_PALETTE_SUB[254] = RGB15(0,0,0);			// l, le noir...
		
	BG_PALETTE[255] = BG_PALETTE_SUB[255];
	BG_PALETTE[254] = BG_PALETTE_SUB[254];
					
	iprintf("DSgf ");
	iprintf(RELEASE_STRING);

#ifdef EMU_VERSION
	iprintf(" EMU version");
#endif

#ifndef EMU_VERSION
	iprintf(" DLDI version");
#endif

	iprintf("\n\n");

#ifndef EMU_VERSION

	// initialisation FAT et chargement des fichiers de configuration

	if (fatInitDefault()) {
   	// Success
   	iprintf("initialisation FAT : OK\n");
	} else {
   	// Failure
		iprintf("Erreur fatale : FAT non initialisee!\n");
		fadeFromWhite(BOTH_SCREENS);	
		return -1;
	} 

#endif

// Lecture des prfrences...

#ifdef EMU_VERSION
	SetFrench();
	AskLangage=true;	// debug
#else  

	ifstream inputstream( "/DSgf/prefs.txt" );
	if ( inputstream ) 
	{
		// le fichier existe, on lit le langage prfr...
		string ligne; // variable contenant chaque ligne lue
	
		string::size_type l1,l2;
		
		while ( getline( inputstream, ligne ) )
	  	{
	    	// afficher la ligne  l'cran
	      //iprintf("%s",ligne.c_str());
	      
	      l1 = ligne.find( "<langage>", 0 );
	      l2 = ligne.find( "</langage>", 0 );
   			if ((l1 != string::npos ) && (l2 != string::npos ))
   			{
   				string new1=ligne.substr(l1+9,l2-l1-9);
				
   				if (new1=="FRA")
				{
					SetFrench();
					AskLangage=false;
				}
				else
   				if (new1=="ENG")
				{
					SetEnglish();	
					AskLangage=false;
				}
   			}
		}
		inputstream.close();
	}
	else
	{
		// le fichier n'existe pas, on demande la langue prfre...
		// et on crit le rsultat dans /Dsgf/prefs.txt
		AskLangage=true;
	}
	
#endif	

// Lecture de proverbes.txt et fill de proverbes & commandements

#ifdef EMU_VERSION
			stringstream inputstream2((const char*)proverbes_txt_raw);
#else  
			ifstream inputstream2( "/DSgf/proverbes.txt" );
#endif

		if ( inputstream2 ) // ce test choue si le stream n'est pas ouvert
	  {
	  	string ligne; // variable contenant chaque ligne lue
	
			string::size_type l1,l2;
	
	  	// cette boucle s'arrte ds qu'une erreur de lecture survient
	  	while ( getline( inputstream2, ligne ) )
	  	{
	    	// afficher la ligne  l'cran
	      //iprintf("%s",ligne.c_str());
	      
	      l1 = ligne.find( "<proverbe>", 0 );
	      l2 = ligne.find( "</proverbe>", 0 );
   			if ((l1 != string::npos ) && (l2 != string::npos ))
   			{
   				string new1=ligne.substr(l1+10,l2-l1-10);
   				proverbes.push_back(new1);
   			}	      
				else
				{
					l1 = ligne.find( "<commandement>", 0 );
					l2 = ligne.find( "</commandement>", 0 );
   				if ((l1 != string::npos ) && (l2 != string::npos ))
   				{
   					string new1=ligne.substr(l1+14,l2-l1-14);
   					commandements.push_back(new1);
   				}
				}				   			
	  	}
	  }
	  else
	  {
	   	// Failure
			iprintf("Erreur fatale a l'ouverture de /DSgf/proverbes.txt\n");
			fadeFromWhite(BOTH_SCREENS);
			WaitForTouch();	
			return -1;	  	
	  }
	      
#ifndef EMU_VERSION

	    inputstream2.close();
	    
#endif

	ClearConsole();		

	// on remet la console en noir sur blanc...
	
	BG_PALETTE_SUB[254] = RGB15(31,31,31);
	BG_PALETTE_SUB[255] = RGB15(0,0,0);
	
	BG_PALETTE[255] = BG_PALETTE_SUB[255];
	BG_PALETTE[254] = BG_PALETTE_SUB[254];
	
	// ET ajoute en force une couleur "goban"  la palette
	
	BG_PALETTE_SUB[253] = RGB15(31,27,15);
	BG_PALETTE[253] = BG_PALETTE_SUB[253];

	gobanNormal.Copy2VRAM(pMAIN_BG);  
	gobanZoom.Copy2VRAM(pMAIN_LARGE_BG);
			
	// Cration des sprites
			
	SetPaletteSUB_Sprite(sprites_Pal_bin);
	SetPaletteMAIN_Sprite(sprites_Pal_bin);

	whiteStone384_spr=new CMySprite(MAIN_SCREEN,white_stone_384_type2_Sprite_bin,32,32);
	blackStone384_spr=new CMySprite(MAIN_SCREEN,black_stone_384_type2_Sprite_bin,32,32);
	whiteStone192_spr=new CMySprite(MAIN_SCREEN,white_stone_192_type2_Sprite_bin,16,16);
	blackStone192_spr=new CMySprite(MAIN_SCREEN,black_stone_192_type2_Sprite_bin,16,16);

	database_spr=new CMySprite(MAIN_SCREEN,spr_database_Sprite_bin,16,16);
	diskette_spr=new CMySprite(MAIN_SCREEN,spr_diskette_Sprite_bin,16,16);
	eject_spr=new CMySprite(MAIN_SCREEN,spr_eject_Sprite_bin,16,16);
	fastforward_spr=new CMySprite(MAIN_SCREEN,spr_fastforward_Sprite_bin,16,16);
	play_spr=new CMySprite(MAIN_SCREEN,spr_play_Sprite_bin,16,16);
	quote_spr=new CMySprite(MAIN_SCREEN,spr_quote_Sprite_bin,16,16);
	rewind_spr=new CMySprite(MAIN_SCREEN,spr_rewind_Sprite_bin,16,16);
	skipback_spr=new CMySprite(MAIN_SCREEN,spr_skipback_Sprite_bin,16,16);
	skip_spr=new CMySprite(MAIN_SCREEN,spr_skip_Sprite_bin,16,16);
	trash_spr=new CMySprite(MAIN_SCREEN,spr_trash_Sprite_bin,16,16);
	user_spr=new CMySprite(MAIN_SCREEN,spr_user_Sprite_bin,16,16);
	playback_spr=new CMySprite(MAIN_SCREEN,spr_playback_Sprite_bin,16,16);
	checkmark_spr=new CMySprite(MAIN_SCREEN,spr_checkmark_Sprite_bin,16,16);
	
	SetBG2AsForeground();	// on passe le petit cran devant le grand!
	
	if (AskLangage)
	{
		AskForLangage();
	}
	
	while(1)
	{
		MenuPrincipal();
		
		if (current_mode==modeOptions)
		{
			ShowOptions();			
		}		
		else
		{
			// modeView ou modeRecord...
			
			if (current_mode==modeView)
			{
				if (SelectAndLoadSGF())
					BoucleJeu();
			}
			else	// modeRecord
			{
				if (SaisieInfosSGF())
					BoucleJeu();
			}															
		}
	}
	return 0;
}

//---------------------------------------------------------------------------

void InitialisationHardware()
{
	Initialisation_2D();	// Allume le moteur 2D et teint le reste (conomise les batteries)
		
	//lcdSwap();	// l'cran principal passe "en bas" et le secondaire "en haut"

	// configuration du mode vido pour l'cran principal
	videoSetMode(MODE_5_2D | DISPLAY_BG2_ACTIVE | DISPLAY_BG3_ACTIVE | DISPLAY_SPR_ACTIVE | DISPLAY_SPR_1D);	
	// activation du mode 5 avec 2 backgrounds bitmap (BG2 et BG3) & des sprites
	
	// configuration du mode vido pour l'cran secondaire
	videoSetModeSub(MODE_5_2D | DISPLAY_BG0_ACTIVE | DISPLAY_BG3_ACTIVE | DISPLAY_SPR_ACTIVE | DISPLAY_SPR_1D);	
	// activation du mode 5 avec 1 background bitmap (BG3), un background de texte (BG0) & des sprites
	
	// Configuration de la mmoire de la DS pour nos besoins...	
	vramSetMainBanks(VRAM_A_MAIN_BG, VRAM_B_MAIN_BG, VRAM_C_SUB_BG , VRAM_D_SUB_SPRITE);
	// VRAM_A : 128ko pour les backgrounds de l'cran principal
	// VRAM_B : +128ko pour les backgrounds de l'cran principal
	// VRAM_C : 128ko pour les backgrounds de l'cran secondaire
	// VRAM_D : 128ko pour les sprites de l'cran secondaire
	vramSetBankE(VRAM_E_MAIN_SPRITE);
	// VRAM_E : 64ko pour les sprites de l'cran principal
	vramSetBankF(VRAM_F_MAIN_SPRITE);
	// VRAM_F : +16ko pour les sprites de l'cran principal
	vramSetBankG(VRAM_G_MAIN_SPRITE);
	// VRAM_G : +16ko pour les sprites de l'cran principal
	vramSetBankH(VRAM_H_LCD);
	vramSetBankI(VRAM_I_LCD);
	// VRAM_H et I : 32ko + 16ko disponibles comme mmoire tampon
	
	// Configuration du background BG3 de l'cran principal (512x512 mais en fait 512x384! / 256 couleurs)
	
	BG3_CR = BG_BMP8_512x512 | BG_BMP_BASE(0) | BG_PRIORITY(2);
	
        BG3_XDX = 1 << 8;
        BG3_XDY = 0;
        BG3_YDX = 0;
        BG3_YDY = 1 << 8;
        BG3_CX = 193 << 8;	// ca c'est pour dcaler en X et en Y
        BG3_CY = 0 << 8;	// utilis pour scroller ou centrer l'image

  // Configuration du background BG2 de l'cran principal (256x256 mais en fait 256x192! / 256 couleurs)

	BG2_CR = BG_BMP8_256x256 | BG_BMP_BASE(12) | BG_PRIORITY(3); 

        BG2_XDX = 1 << 8;
        BG2_XDY = 0;
        BG2_YDX = 0;
        BG2_YDY = 1 << 8;
        BG2_CX = 0;	// pas besoin de centrer... la rsolution est celle de l'cran...
        BG2_CY = 0;

	// quelques explications / utilisation et mappage de la mmoire pour les backgrounds de l'cran principal :
	// pour BG2 et BG3, on a 256ko (VRAM_A+VRAM_B).
	// BG3 prend le dbut de la mmoire ddie aux backgrounds de l'cran principal, il est donc dclar comme
	// commenant  BG_BMP_BASE(0). Il occupe (512*384/1024=) 192 Ko.
	// Chaque BG_BMP_BASE quivaut  une tranche de 16Ko, donc BG2 qui suit commence  la tranche (192/16=) 12.
	// Il occupe les (256*192/1024=) 48 Ko suivants. On utilise 192+48=240Ko sur les 256Ko disponibles... ouf!

	pMAIN_BG=(u16*)BG_BMP_RAM(12);			// Pointeurs plus pratiques  utiliser que des index mmoire !
	pMAIN_LARGE_BG=(u16*)BG_BMP_RAM(0);

	// Configuration du BG0 (texte) de l'cran secondaire

	// On utilise les 3 premiers blocks de 16Ko pour cet cran texte
	// les deux premiers blocs pour les caractres (CHAR_BASE_BLOCK_SUB(0)) 
	// et le suivant pour les "tiles" (BG_MAP_BASE(2)) 

	SUB_BG0_CR = BG_MAP_BASE(2);
	// La police est rendue par dfaut avec la couleur 255 de la palette
	// ici on force cette couleur  255 (attention si des images bitmap utilisent cette couleur de palette!)
	BG_PALETTE_SUB[255] = RGB15(0,0,0);	
	// Initialisation de la console
	consoleInitDefault((u16*)SCREEN_BASE_BLOCK_SUB(2), (u16*)CHAR_BASE_BLOCK_SUB(0), 16);
	
	// Configuration du background bitmap de l'cran secondaire (256x256 mais en fait 256x192! / 256 couleurs)
	
	SUB_BG3_CR = BG_BMP8_256x256 | BG_BMP_BASE(3) | BG_PRIORITY(3);

        SUB_BG3_XDX = 1 << 8;
        SUB_BG3_XDY = 0;
        SUB_BG3_YDX = 0;
        SUB_BG3_YDY = 1 << 8;
        SUB_BG3_CX = 0;
        SUB_BG3_CY = 0;

	// On commence  BG_BMP_BASE(3) puisque les 3 premiers blocs sont pris pour le texte
	// On utilise 256*192/1024=48 Ko donc 3 blocs pour ce background.
	// Au total, on utilise donc 6 blocs (96Ko) sur les 8 blocs (128Ko) dispo. en VRAM_C.

	pSUB_BG=(u16*) BG_BMP_RAM_SUB(3);	// pointeur pratique  utiliser	  
	
	CMySprite::InitialisationOAMs();	// Initialisation de notre systme de sprites	

	lcdMainOnBottom();	// le MAIN screen est en bas, le SUB en haut	                					
}

//---------------------------------------------------------------------------

void SplashScreens()	// Introduction de DSgf : les "splashscreens" !
{
	
#ifndef NO_SPLASH	

	SetBG2AsForeground(); 
	
	ecranBlanc(SUB_SCREEN);	// joue sur la luminosit
	ecranNoir(MAIN_SCREEN);

	// on charge la palette pour les BG de l'cran principal (haut par dfaut)
	SetPaletteSUB_BG(lords_Pal_bin);	

	// on charge la palette pour les BG de l'cran secondaire (bas par dfaut)
	SetPaletteMAIN_BG(CC_Pal_bin);	
			
	CMyBitmap* lords=new CMyBitmap(lords_Bitmap_bin,256,192);
	
	lords->Copy2VRAM(pSUB_BG); // on demande gentillement au bitmap de se copier sur l'cran principal...
			
	CMyBitmap* CC=new CMyBitmap(CC_Bitmap_bin,256,192);		
	
	CC->Copy2VRAM(pMAIN_BG);	// on demande gentillement au bitmap lords de se copier sur l'cran secondaire...
	
	// retour fondu au blanc (c'est comme  qu'on dit ?)
	
	S_intro.play();	
	
	fadeFromWhite(SUB_SCREEN,2);	// d'abord celui du haut		
	//S_intro.play();	
	fadeFromBlack(MAIN_SCREEN,2);	// puis celui du bas

#endif

	// on va en profiter pour charger les polices de caractre,
	// car a prend pas mal de temps...
	
	arial12=new CMyFont(arial12_raw,arial12_Bitmap_bin);		
	arialb22=new CMyFont(arialb22_raw,arialb22_Bitmap_bin);	

#ifndef NO_SPLASH
		
	fadeToWhite(BOTH_SCREENS);	// les 2 crans en mme temps...	

	// let's free the now useless resources...

	delete lords;
	delete CC;			

#else

	ecranBlanc(BOTH_SCREENS);
	
#endif

}

void AskForLangage()
{
	CMyBitmap* pHaut=new CMyBitmap(256,192);		// va servir d'ecran virtuel pour crire		
	CMyBitmap* pBas=new CMyBitmap(256,192);		// idem	
	
	pHaut->Fill(254);
	pBas->Fill(254);	

	// cran du haut	

	string ver="DSgf ";
	ver+=RELEASE_STRING;

	arialb22->BasicWrite((char*)ver.c_str(),pHaut,8,4);	
	pHaut->DrawHorizLine(8,30,240,253);		
	dragon1.Copy2Bitmap(pHaut,256-112,192-112);
	
	// cran du bas
	
	// les flags sont en 32x20
	
	flagFRA.Copy2Bitmap(pBas,16,16);
	flagENG.Copy2Bitmap(pBas,64,16);
	
	string selected_langage;
	
	// Affichage
	
	pHaut->Copy2VRAM(pSUB_BG);
	pBas->Copy2VRAM(pMAIN_BG);

	fadeFromWhite(BOTH_SCREENS);

	u8  styletx=0;
	u8  stylety=0;

	while(1)
	{		
		scanKeys();
		if (keysDown() & KEY_TOUCH)
		{							
			styletx=IPC->touchXpx;
			stylety=IPC->touchYpx;	
			
			if (IsHit(styletx,stylety,16,16,32,20))	// FRA
			{
				SetFrench();
				selected_langage="FRA";
				break;
			}
			else
			if (IsHit(styletx,stylety,64,16,32,20))	// ENG
			{
				SetEnglish();
				selected_langage="ENG";
				break;
			}	
		}
	}
	
	swiWaitForVBlank(); // ncessaire sinon le play() suivant va merder	
	S_pierre2.play();
	
	// Sauvegarde dans le fichier de prfrences...
	
#ifndef EMU_VERSION	
	FILE* outputfile = fopen ("/DSgf/prefs.txt","wb");

	string output_str="<langage>"+selected_langage+"</langage>\n";

	for(int t=0;t<(int)output_str.length();t++)
		fputc(output_str.at(t),outputfile);

	fclose(outputfile);
   
#endif	

	fadeToWhite(BOTH_SCREENS);
	
	delete pHaut;
	delete pBas;
}

//#define	REG_WIFI_W_RANDOM		(*(vu16*)0x4800044)
#define	REG_WIFI_W_RANDOM   *(volatile unsigned short *)0x04000132

//---------------------------------------------------------------------------------------------------------

void MenuPrincipal()
{		
	// Mise en page pour l'cran du haut
	
	CMyBitmap* ptmp2=new CMyBitmap(256,192);		// va servir d'ecran virtuel pour crire		
		
	pageMenuHaut.Copy2Bitmap(ptmp2);
	
	// Choix d'un proverbe au hasard...
	// pour l'instant, c'est toujours le premier qui sort !
			
    int random_integer; 
    int lowest=0, highest=proverbes.size(); 
    int range=(highest-lowest)+1; 
    random_integer = lowest+int(range*rand()/(RAND_MAX + 1.0)); 
	
	string reste=arial12->WriteParagraph(proverbes[random_integer].c_str(),ptmp2,105,51,244,175,-3);	
		
	// Mise en page pour l'cran du bas	
	
	CMyBitmap* ptmp=new CMyBitmap(256,192);		// va servir d'ecran virtuel pour crire		

	ptmp->Fill(254);
		
	MyPoint	p1a,p1b,p2a,p2b,p3a,p3b,p4a,p4b;
	
	int ecart=20;
	
	p1a.x=36;
	p1a.y=ecart+10;		
	p1b=arialb22->Write((char*)MyLocalization.main_menu_edit_file.c_str(),ptmp,p1a);
	
	blackStone192.BitBltOnBitmap(ptmp,p1a.x-12,p1a.y+11);
	
	p2a.x=36;
	p2a.y=p1b.y+ecart;
	p2b=arialb22->Write((char*)MyLocalization.main_menu_create_file.c_str(),ptmp,p2a);	
	
	blackStone192.BitBltOnBitmap(ptmp,p2a.x-12,p2a.y+11);
	
	p3a.x=36;
	p3a.y=p2b.y+ecart;
	p3b=arialb22->Write((char*)MyLocalization.main_menu_options.c_str(),ptmp,p3a);
			
	blackStone192.BitBltOnBitmap(ptmp,p3a.x-12,p3a.y+11);
			
	// Affichage des pages sur les crans
	
	ptmp2->Copy2VRAM(pSUB_BG);
	ptmp->Copy2VRAM(pMAIN_BG);
	
	fadeFromWhite(BOTH_SCREENS);
	
	u8  styletx=0;
	u8  stylety=0;
		
	while(1)
  {  
  	scanKeys();  
  	if ((keysDown() & KEY_TOUCH))
  	{
  		styletx=IPC->touchXpx;
  		stylety=IPC->touchYpx;
  		
  		// Anacliqu!
  		
  		if (IsHit(styletx,stylety,p1a,p1b))	// Revoir
  		{
  			S_pierre1.play();
  			current_mode=modeView;
  			break;
  		}
  		else 
  		if (IsHit(styletx,stylety,p2a,p2b))	// Noter
  		{  	
  			S_pierre2.play();		
  			current_mode=modeRecord;
  			break;
  		}
  		else 
  		if (IsHit(styletx,stylety,p3a,p3b))	// Options
  		{
  			S_pierre1.play();
  			current_mode=modeOptions;
  			break;
  		}
  	}
	else
	if ((keysDown() & KEY_SELECT))
	{
			
		fadeToWhite(BOTH_SCREENS);
		
		SetPaletteMAIN_BG(help_Pal_bin);
		SetPaletteSUB_BG(help_Pal_bin);

		helpA.Copy2VRAM(pSUB_BG);
		helpB.Copy2VRAM(pMAIN_BG);
		
		fadeFromWhite(BOTH_SCREENS);
		
		WaitForTouch();
		
		// retour au menu...
	
		fadeToWhite(BOTH_SCREENS);
	
		ptmp2->Copy2VRAM(pSUB_BG);
		ptmp->Copy2VRAM(pMAIN_BG);		
	
		SetPaletteMAIN_BG(master_Pal_bin);
		SetPaletteSUB_BG(master_Pal_bin);
	
		BG_PALETTE_SUB[254] = RGB15(31,31,31);
		BG_PALETTE_SUB[255] = RGB15(0,0,0);
		
		BG_PALETTE[255] = BG_PALETTE_SUB[255];
		BG_PALETTE[254] = BG_PALETTE_SUB[254];
		
		// ET ajoute en force une couleur "goban"  la palette
		
		BG_PALETTE_SUB[253] = RGB15(31,27,15);
		BG_PALETTE[253] = BG_PALETTE_SUB[253];
		
		fadeFromWhite(BOTH_SCREENS);	
	}
 		swiWaitForVBlank(); 		
	}		
	
	delete ptmp;	// on peut maintenant librer l'cran virtuel du menu...
	delete ptmp2;

	fadeToWhite(BOTH_SCREENS);
	  	
	// Fin du MENU PRINCIPAL...
}

void ShowOptions()
{

	bool select_langage=false;

	CMyBitmap* pHaut=new CMyBitmap(256,384);		// scrolling du bitmap "about"		
	CMyBitmap* pBas=new CMyBitmap(256,192);		// idem	
	
	//SetBG2AsForeground(); // sinon on reste sur la vue du goban zoom
	
	//about.Copy2Bitmap(pHaut);
	
	pHaut->Fill(254);
	pBas->Fill(254);	

	// cran du bas

	arialb22->BasicWrite((char*)MyLocalization.options_title.c_str(),pBas,8,4);	
	pBas->DrawHorizLine(8,30,240,253);	

	// Options...
	
	arial12->BasicWrite("Dummy option1",pBas,8,40);
	arial12->BasicWrite("Dummy option2",pBas,8,60);
	arial12->BasicWrite("Dummy option3",pBas,8,80);
	arial12->BasicWrite((char*)MyLocalization.langage_texte1.c_str(),pBas,8,100);
		
	CMySwitch option1(pBas,MyLocalization.switch_on_text,MyLocalization.switch_off_text,false,126,40);	
	CMySwitch option2(pBas,MyLocalization.switch_on_text,MyLocalization.switch_off_text,false,126,60);	
	CMySwitch option3(pBas,MyLocalization.switch_on_text,MyLocalization.switch_off_text,false,126,80);	

	MyPoint p=arial12->WriteCentered((char*)MyLocalization.langage_texte2.c_str(),pBas,138,100);	

	checkmark.Copy2Bitmap(pBas,208,168);
	x.Copy2Bitmap(pBas,232,168);
		
	// cran du haut	

	dragon2.Copy2Bitmap(pHaut,0,0);
	dragon1.Copy2Bitmap(pHaut,256-112,384-112);
	
	cclogo.Copy2Bitmap(pHaut,24,350);
			
	string ver=RELEASE_STRING;
	
#ifdef EMU_VERSION
	ver+=" EMU";
#else
	ver+=" NDS";
#endif
	
	arialb22->Write("DSgf",pHaut,128,8);
			
	arial12->Write((char*)ver.c_str(),pHaut,128+2,42);	

	pHaut->DrawHorizLine(124,68,110,253);
/*	
	string texte="Brought to you by :\n\
* Lord Nio\n\
* Lord PureWhite\n\
* Lord Trooper\n\
* Lord Koopa\n";
*/

string texte="DSgf homepage:\nhttp://tenuki.fr/stuff\n\t\nauthor email:\ntetsuo_no_go@yahoo.com";

arial12->WriteParagraph(texte,pHaut,124,81,253,162);


texte="Thanks to : Wintermute for DevkitPro, DevKitArm, libnds.\
 Chism for libfat & DLDI.\
 Mollusk for PAgfx. Thanks to people from GBADev forum.\n\t\n";

	
texte+="Big thanks to my friends Oaksun, Trooper & Koopa for their support ! ^ ^\n\t\n";

texte+="Now let's have a game on DGS! My nickname is nio_101...";

	arial12->WriteParagraph(texte,pHaut,4,163,254,289);

texte="Published under an \nAttribution Non Commercial ShareAlike licence.\n\
For more information, check :\n\
http://creativecommons.org";

	arial12->WriteParagraph(texte,pHaut,4,270,171,343);
	
	pHaut->Copy2VRAMscroll256x192(pSUB_BG,0);
	pBas->Copy2VRAM(pMAIN_BG); 
	
	fadeFromWhite(BOTH_SCREENS);
		
	u16 scroll=0;
	bool pause=true;
	bool scroll_down=true;
	u16 boucle=0;
	u16 long_boucle=256;
	
	u8 styletx;
	u8 stylety;
	bool valid;
//iprintf("\n\nok2?");
//WaitForTouch();		
	while(1)
	{		
		scanKeys();
		if (keysDown() & KEY_TOUCH)
		{
			styletx=IPC->touchXpx;
			stylety=IPC->touchYpx;		
			if (IsHit(styletx,stylety,208,168,16,16))
			{
				valid=true;
				swiWaitForVBlank();		
				S_pierre2.play();
				break;
			}
			else if (IsHit(styletx,stylety,232,168,16,16))
			{
				valid=false;	
				swiWaitForVBlank();	
				S_capture.play();
				break;
			}
			else if (option1.IsHit(styletx,stylety))	//option1
			{
				option1.doSwitch();
				swiWaitForVBlank();
				S_pierre1.play();	
				pBas->Copy2VRAM(pMAIN_BG);		
			}
			else if (option2.IsHit(styletx,stylety))	//option2
			{
				option2.doSwitch();
				swiWaitForVBlank();	
				S_pierre2.play();
				pBas->Copy2VRAM(pMAIN_BG);		
			}
			else if (option3.IsHit(styletx,stylety))	//option3
			{
				option3.doSwitch();
				swiWaitForVBlank();	
				S_pierre1.play();
				pBas->Copy2VRAM(pMAIN_BG);		
			}
			else if (IsHit(styletx,stylety,138,100,p.x-138,p.y-100))
			{
				select_langage=true;
				break;
			}
		}
		
		boucle++;
		if (boucle==long_boucle)
		{
			boucle=0;
		
			if (pause)
			{
				pause=false;
				long_boucle=1;
			}
		
			if (scroll_down)
			{			
				scroll++;
				if (scroll==(192))
				{
					scroll_down=false;
					pause=true;
					long_boucle=256;
				}
			}
			else
			{
				scroll--;
				if (scroll==0)
				{
					scroll_down=true;				
					pause=true;
					long_boucle=256;
				}
			}
			swiWaitForVBlank();	
			pHaut->Copy2VRAMscroll256x192(pSUB_BG,scroll);		
		}
		swiWaitForVBlank();	
	}

	fadeToWhite(BOTH_SCREENS);
	//SetBG3AsForeground();	// on remet le goban zoom en premier plan
	
	delete pHaut;
	delete pBas;
	
	if (select_langage)
		AskForLangage();
}

bool SelectAndLoadSGF()
{
	// Partie 1 - Slection du fichier
	
	// Slection et chargement d'un SGF

	CMyBitmap* pHaut=new CMyBitmap(256,192);		// va servir d'ecran virtuel pour crire		
	CMyBitmap* pBas=new CMyBitmap(256,192);		// idem	

	pHaut->Fill(254);
	
	arialb22->BasicWrite((char*)MyLocalization.select_title1.c_str(),pHaut,8,4);	
	pHaut->DrawHorizLine(8,30,240,253);
	
	pBas->Fill(254);	

	arialb22->BasicWrite((char*)MyLocalization.select_title2.c_str(),pBas,8,4);

	// Lecture de la liste des fichiers
	
	vector<string> liste_fichiers;  
	
#ifdef EMU_VERSION

	liste_fichiers.push_back("Debug1.sgf");
	liste_fichiers.push_back("Debug2.sgf");
	liste_fichiers.push_back("Debug3.sgf");
	liste_fichiers.push_back("Debug4.sgf");
	liste_fichiers.push_back("firzen.sgf");
	liste_fichiers.push_back("jules.sgf");

#else  

	struct stat st;
	char filename[256]; // may need to be 256 instead of a constant
	DIR_ITER* dir;

	char* dir1="/SGF";

	dir = diropen (dir1); // no error checking -- make sure you check for NULL!
		
	if (dir==NULL)
	{
		iprintf("Erreur fatale : diropen(%s) retourne NULL!\n",dir1);
		fadeFromWhite(BOTH_SCREENS);
		WaitForTouch();
	}

	while (dirnext(dir, filename, &st) == 0)
	{
    	// st.st_mode & S_IFDIR indicates a directory
    	//iprintf ("%s: %s\n", (st.st_mode & S_IFDIR ? " DIR" : "FILE"), filename);
    	if (!(st.st_mode & S_IFDIR))
    	{
    		// C'est un fichier...
    		
    		u8 l=strlen(filename);
    		
    		// on convertit les 3 dernires lettre en minuscules
    		filename[l-3]=tolower(filename[l-3]);
    		filename[l-2]=tolower(filename[l-2]);
    		filename[l-1]=tolower(filename[l-1]);

    		// est-ce un ".sgf" ?    		
    		if ((filename[l-4]=='.')&&(filename[l-3]=='s')&&(filename[l-2]=='g')&&(filename[l-1]=='f'))
    		{
    			string nom(filename);
    			liste_fichiers.push_back(nom);    		
    		}
    	}
   }
			
#endif

//fadeFromWhite(BOTH_SCREENS);

	// On cr la liste droulante...

	CMyChoiceList	liste_choix(liste_fichiers,pBas,10);	// pour 10 lignes affiches
	
	MyRect liste_rect;
	
	liste_rect.x=12;
	liste_rect.y=32;
	liste_rect.width=230;
	liste_rect.height=10*12+4+4-1;	// multiple de 12==hauteur de police; ici 10 lignes + marge de 4 pixels de chaque ct
	
	liste_choix.initial_draw(liste_rect);	// dessine la liste (implicitement sur l'cran du bas/MAIN puisqu'on utilise le stylet)

	liste_choix.update();

	// on met les icones de validation et d'annulation
	
	MyPoint p1,p2,p3,p4;
	
	p1.x=liste_rect.x+liste_rect.width-40;
	p1.y=liste_rect.y+liste_rect.height+4;
	p2.x=p1.x+16;
	p2.y=p1.y+16;
	
	p3.x=liste_rect.x+liste_rect.width-16;
	p3.y=liste_rect.y+liste_rect.height+4;
	
	p4.x=p3.x+16;
	p4.y=p3.y+16;

	x.Copy2Bitmap(pBas,p3.x,p3.y);
	checkmark.Copy2Bitmap(pBas,p1.x,p1.y);
	
	clipboard.Copy2Bitmap(pBas,liste_rect.x+liste_rect.width-16,liste_rect.y-16-8);
	
	// Affichage  l'cran

	pHaut->Copy2VRAM(pSUB_BG);
	pBas->Copy2VRAM(pMAIN_BG);
	
	fadeFromWhite(BOTH_SCREENS);
	
	// Faire une boucle utilisant la liste droulante pour MAJ de la slection et des infos...	
	
	u8 styletx;
	u8 stylety;
	bool valid=false;
	string sgf_filename;	
	
	while(1)
	{		
		scanKeys();
		if (keysDown() & KEY_TOUCH)
		{							
			styletx=IPC->touchXpx;
			stylety=IPC->touchYpx;	
			
			if (IsHit(styletx,stylety,p1,p2))
			{
				valid=true;
				S_pierre1.play();
				break; //pas tout de suite... on va lire l'entte...
			}
			else if (IsHit(styletx,stylety,p3,p4))
			{
				valid=false;
				S_capture.play();
				break;
			}	
			if ((IsHit(styletx,stylety,liste_rect.x+liste_rect.width-16,liste_rect.y-16-6,16,16)))
			{
			
				S_pierre2.play();
				
				// on veut lire le rsum du fichier...
				
				//iprintf("%s\n",liste_fichiers[liste_choix.my_selection+liste_choix.my_scroll_index].c_str());
				
				sgf_filename="/SGF/";
				sgf_filename+=liste_fichiers[liste_choix.my_selection+liste_choix.my_scroll_index];
				
				#ifdef EMU_VERSION


  				string* pheader;
  				
  				if (sgf_filename=="/SGF/Debug1.sgf")							
  					pheader = new string((const char*)debug_sgf_raw);
  				else if (sgf_filename=="/SGF/Debug2.sgf")							
  					pheader = new string((const char*)debug_sgf2_raw);
  				else if (sgf_filename=="/SGF/Debug3.sgf")							
  					pheader = new string((const char*)debug_sgf3_raw);
  				else if (sgf_filename=="/SGF/Debug4.sgf")							
  					pheader = new string((const char*)debug_sgf4_raw);
  				else if (sgf_filename=="/SGF/firzen.sgf")							
  					pheader = new string((const char*)firzen_sgf_raw);
  				else if (sgf_filename=="/SGF/jules.sgf")							
  					pheader = new string((const char*)jules_sgf_raw);				
  				else
  					pheader = new string((const char*)debug_sgf_raw);
  				
  				stringstream inputstream;
  	
  				inputstream.str(*pheader);
  	
  				delete pheader;
								
				#else  
				
							//ifstream inputstream( sgf_filename.c_str() );
							FILE* inputfile = fopen (sgf_filename.c_str(), "rb");
							
				#endif
				
					u8 level;	// est utilis pour dtecter si le ';' est dans un attribut ou s'il est sparateur

          #ifndef EMU_VERSION	
          	int ch;
          #else
          	char ch;
          #endif
				
					#ifdef EMU_VERSION
			if ( inputstream ) // ce test choue si le stream n'est pas ouvert
	#else  
			if ( inputfile!=NULL )
	#endif 
        {					  
					  	string buffer;
        			
              #ifdef EMU_VERSION
        			//getline(inputstream, buffer,';');					  	
        			buffer="";
        			level=0;
        			inputstream.read(&ch,1);
        			
        			//iprintf("%c",ch);
        			while( !(inputstream.eof()) )
        			{	
        				if ((ch=='[')&&(buffer!="")&&(buffer[buffer.size()-1]!='\\'))	// C'est bien un [ d'attribut
        					level++;
        				if ((ch==']')&&(buffer!="")&&(buffer[buffer.size()-1]!='\\'))	// C'est bien un ] d'attribut
        					level--;
        				if ((ch==';')&&(level==0))
        					break;
        				buffer+=ch;
        				inputstream.read(&ch,1);
        				//iprintf("%c",ch);
        				
        			}			
        		#else	
        			buffer="";
        			level=0;
        			ch = getc( inputfile );	
        			
        			while( ch != EOF )
        			{	
        				if ((ch=='[')&&(buffer!="")&&(buffer[buffer.size()-1]!='\\'))	// C'est bien un [ d'attribut
        					level++;
        				if ((ch==']')&&(buffer!="")&&(buffer[buffer.size()-1]!='\\'))	// C'est bien un ] d'attribut
        					level--;
        				if ((ch==';')&&(level==0))
        					break;
        				buffer+=ch;
        				ch = getc( inputfile );
        			}
        		#endif
        		
        			// entete ne contient ici que la parenthse d'ouverture du fichier SGF		
        			
        		#ifdef EMU_VERSION
        			//getline(inputstream, buffer,';');					  	
        			buffer="";
        			level=0;
        			inputstream.read(&ch,1);
        			
        			//iprintf("%c",ch);
        			while( !(inputstream.eof()) )
        			{	
        				if ((ch=='[')&&(buffer!="")&&(buffer[buffer.size()-1]!='\\'))	// C'est bien un [ d'attribut
        					level++;
        				if ((ch==']')&&(buffer!="")&&(buffer[buffer.size()-1]!='\\'))	// C'est bien un ] d'attribut
        					level--;
        				if ((ch==';')&&(level==0))
        					break;
        				buffer+=ch;
        				inputstream.read(&ch,1);
        				
        				//iprintf("%c",ch);
        			}			
        		#else	
        			buffer="";
        			level=0;
        			ch = getc( inputfile );
        				
        			while( ch != EOF )
        			{	
        				if ((ch=='[')&&(buffer!="")&&(buffer[buffer.size()-1]!='\\'))	// C'est bien un [ d'attribut
        					level++;
        				if ((ch==']')&&(buffer!="")&&(buffer[buffer.size()-1]!='\\'))	// C'est bien un ] d'attribut
        					level--;
        				if ((ch==';')&&(level==0))
        					break;
        				buffer+=ch;
        				ch = getc( inputfile );
        				
        			}
        		#endif		  	
					  	SGF_tree.ExtractHeaderAttributes(buffer);					  	
					 }	
					 else
					 {
					   	// Failure
						iprintf("Erreur fatale a l'ouverture de %s!\n",sgf_filename.c_str());	
						WaitForTouch();  	
					 }
					      
				#ifndef EMU_VERSION
				
    			//inputstream.close();
    			fclose(inputfile);
					    
	      #endif
								
				pHaut->Fill(254);
				
				arialb22->BasicWrite((char*)MyLocalization.select_title3.c_str(),pHaut,8,4);	
				pHaut->DrawHorizLine(8,30,240,253);
				
				// affiche les infos...
				
				string texte;
				texte=liste_fichiers[liste_choix.my_selection+liste_choix.my_scroll_index]+"\n";

				if (SGF_tree.game_name!="")
					texte+=SGF_tree.game_name+"\n";
				
				if (SGF_tree.player_white!="" && SGF_tree.player_black!="")				
					texte+=SGF_tree.player_white+" "+SGF_tree.white_rank+" (W)\nvs "+SGF_tree.player_black+" "+SGF_tree.black_rank+" (B)\n\n";
				
				if (SGF_tree.result!="")
					texte+="resultat : "+SGF_tree.result+"\n";
																			
				if (SGF_tree.handicap!="")
					texte+="handicap : "+SGF_tree.handicap+"\n";								
												
				if (SGF_tree.event!="")
					texte+="event : "+SGF_tree.event+"\n";								
				if (SGF_tree.round!="")
					texte+="round : "+SGF_tree.round+"\n";								
				if (SGF_tree.place!="")
					texte+="place : "+SGF_tree.place+"\n";			
				if (SGF_tree.date!="")
					texte+="date : "+SGF_tree.date+"\n";								

				if (SGF_tree.komi!="")
					texte+="komi : "+SGF_tree.komi+"\n";		

				arial12->WriteParagraph(texte,pHaut,8,34,248,190);
				
				swiWaitForVBlank();	
				pHaut->Copy2VRAM(pSUB_BG);				
			}
			else				
			// Dterminer o est le stylet!			
			if (IsHit(styletx,stylety,liste_rect))	// sur la liste
			{			
				if (styletx<(liste_rect.x+liste_rect.width-16))
				{
					// Quelle ligne ?
					liste_choix.my_selection=(stylety-liste_rect.y-4)/12; // 12==hauteur de police
					if (liste_choix.my_selection>=(liste_choix.my_nb))
					{
						liste_choix.my_selection=(liste_choix.my_nb)-1;
					}
				}
				else
				if (IsHit(styletx,stylety,liste_rect.x+liste_rect.width-16,liste_rect.y,16,16))
				{
					// icone pour monter dans la liste
					liste_choix.my_scroll_index-=liste_choix.my_nb;
					if (liste_choix.my_scroll_index<0)
						liste_choix.my_scroll_index=0;
					else
						liste_choix.my_selection=liste_choix.my_nb-1;
				}
				else
				if (IsHit(styletx,stylety,liste_rect.x+liste_rect.width-16,liste_rect.y+16,16,16))
				{
					// icone pour descendre dans la liste
					liste_choix.my_scroll_index+=liste_choix.my_nb;
					//liste_choix.my_scroll_index++;
					if ((liste_choix.my_scroll_index+liste_choix.my_nb)>(s8)liste_choix.items.size())
					{
						liste_choix.my_scroll_index=liste_choix.items.size()-liste_choix.my_nb;					
					}
					liste_choix.my_selection=0;
				}
			
				// update de la liste si la slection change
			
				liste_choix.update();
				swiWaitForVBlank();	
				pBas->Copy2VRAM(pMAIN_BG);
			}
		}				
		else if (keysHeld() & KEY_DOWN)
		{
			// on descend dans la liste
			liste_choix.my_selection++;
							
			if (liste_choix.my_selection==(liste_choix.my_nb))	// Il faut scroller vers le bas!
			{	
				liste_choix.my_scroll_index+=liste_choix.my_nb;
				//liste_choix.my_scroll_index++;
				if ((liste_choix.my_scroll_index+liste_choix.my_nb)>(s8)liste_choix.items.size())
				{
					liste_choix.my_scroll_index=liste_choix.items.size()-liste_choix.my_nb;
					liste_choix.my_selection--;						
				}
				else
					liste_choix.my_selection=0;
			}
			else
			if (liste_choix.my_selection+liste_choix.my_scroll_index>(s8)liste_choix.items.size()-1)
			{
				liste_choix.my_selection--;
			}
				
			// MAJ de la liste
			liste_choix.update();
			swiWaitForVBlank();	
			pBas->Copy2VRAM(pMAIN_BG);
		}
		else if (keysHeld() & KEY_UP)
		{
			// on monte dans la liste
			if (liste_choix.my_selection==0)
			{
				//liste_choix.my_scroll_index--;
				liste_choix.my_scroll_index-=liste_choix.my_nb;
				if (liste_choix.my_scroll_index<0)
					liste_choix.my_scroll_index=0;
				else
					liste_choix.my_selection=liste_choix.my_nb-1;
			}
			else
				liste_choix.my_selection--;					
				
			// MAJ de la liste
			liste_choix.update();
			swiWaitForVBlank();	
			pBas->Copy2VRAM(pMAIN_BG);
		}		
	}	
	
	if (!valid)
	{
		fadeToWhite(BOTH_SCREENS);
		return false;
	}
		
	// le nom de fichier est dans items[liste_choix.my_selection+liste_choix.my_scroll_index]
	
	// Partie 2 - Lecture du fichier
		
	sgf_filename="/SGF/";
	sgf_filename+=liste_fichiers[liste_choix.my_selection+liste_choix.my_scroll_index];
		
	current_node=NULL;
	
	// lecture du contenu du fichier dans buff
	// ! mthode non bufferise => problme quand le fichier est de taille trop importante !
	// => A corriger avec la refonte complte de MySGF pour alpha3
	
	//string buff;

	fadeToWhite(BOTH_SCREENS);
/*	
	//BG_PALETTE_SUB[255] = RGB15(31,31,31);	// blanc
		
	//present20->WriteCentered("lecture de...",pBas,127,32);
		
	//pHaut->Copy2VRAM(pSUB_BG);
	//pBas->Copy2VRAM(pMAIN_BG);
	
	fadeFromWhite(BOTH_SCREENS);
*/	

	pHaut->Fill(254);
	pBas->Fill(254);

	arialb22->BasicWrite((char*)MyLocalization.loading_title.c_str(),pHaut,8,4);	
	pHaut->DrawHorizLine(8,30,240,253);		
	
	//pHaut->DrawRect(8,40,240,12,254);
	arial12->WriteParagraph((char*)MyLocalization.loading_text.c_str(),pHaut,8,60,248,84);
	//swiWaitForVBlank();	
	//pHaut->Copy2VRAM(pSUB_BG);
		
	//dragon1.Copy2Bitmap(pBas,256-112,192-112);
	//dragon2.Copy2Bitmap(pBas,0,0);	
	
	decor.Copy2Bitmap(pBas,0,0);

	pHaut->Copy2VRAM(pSUB_BG);
	pBas->Copy2VRAM(pMAIN_BG);

	fadeFromWhite(BOTH_SCREENS);

	SGF_tree.remplis_arbre(sgf_filename,pHaut);
	
	fadeToWhite(BOTH_SCREENS);
	
	delete pHaut;
	delete pBas;
	
	return true;
}

bool SaisieInfosSGF()
{
	string nom_joueur_noir=MyLocalization.default_white_player_name;
	string nom_joueur_blanc=MyLocalization.default_black_player_name;
	string handicap;
	string nom_fichier=MyLocalization.default_game_name;
		
	CMyBitmap* pHaut=new CMyBitmap(256,192);		// va servir d'ecran virtuel pour crire		
	CMyBitmap* pBas=new CMyBitmap(256,192);		// idem	
		
	// Affichage & Saisie des infos relatives au nouvel SGF
	
	pHaut->Fill(254);
	pBas->Fill(254);	

	// cran du haut	

	arialb22->BasicWrite((char*)MyLocalization.new_game_title.c_str(),pHaut,8,4);	
	pHaut->DrawHorizLine(8,30,240,253);		
	dragon1.Copy2Bitmap(pHaut,256-112,192-112);

	// en bas...
	
	// le nom du fichier .sgf
	
	//blackStone192.BitBltOnBitmap(pBas,8,9);
	arial12->WriteParagraph(nom_fichier,pBas,32,8,250,20);
	pBas->DrawFrameRect(31-4,7,254-32+2,20-8+2,253);
	
	// les noms des joueurs
		
	blackStone192.BitBltOnBitmap(pBas,8,9+32);
	arial12->WriteParagraph(nom_joueur_noir,pBas,32,8+32,250,20+32);
	pBas->DrawFrameRect(31-4,7+32,254-32+2,20-8+2,253);
	
	whiteStone192.BitBltOnBitmap(pBas,8,9+32+32);
	arial12->WriteParagraph(nom_joueur_blanc,pBas,32,8+32+32,250,20+32+32);
	pBas->DrawFrameRect(31-4,7+32+32,254-32+2,20-8+2,253);
		
	// le handicap...
	
	arial12->BasicWrite("Handicap : ",pBas,8,9+32+32+32);
	
	vector<string> liste_handicap;  
	
	liste_handicap.push_back("0");
	liste_handicap.push_back("1");
	liste_handicap.push_back("2");
	liste_handicap.push_back("3");
	liste_handicap.push_back("4");
	liste_handicap.push_back("5");
	liste_handicap.push_back("6");
	liste_handicap.push_back("7");
	liste_handicap.push_back("8");
	liste_handicap.push_back("9");
	
	CMyChoiceList liste_choix(liste_handicap,pBas,3);	// pour 3 lignes affiches
	
	MyRect liste_rect;
	
	liste_rect.x=64;
	liste_rect.y=9+32+32+32;
	liste_rect.width=32;
	liste_rect.height=3*12+4+4-1;	// multiple de 12==hauteur de police; ici 3 lignes + marge de 4 pixels de chaque ct
	
	liste_choix.initial_draw(liste_rect);	// dessine la liste (implicitement sur l'cran du bas/MAIN puisqu'on utilise le stylet)

	liste_choix.update();
	
	// les boutons de validation/annulation
	
		// on met les icones de validation et d'annulation
	
	MyPoint p1,p2,p3,p4;
	
	p1.x=208;
	p1.y=168;
	p2.x=p1.x+16;
	p2.y=p1.y+16;
	
	p3.x=232;
	p3.y=168;
	
	p4.x=p3.x+16;
	p4.y=p3.y+16;

	x.Copy2Bitmap(pBas,p3.x,p3.y);
	checkmark.Copy2Bitmap(pBas,p1.x,p1.y);
	
	// ok... on affiche !

	pHaut->Copy2VRAM(pSUB_BG);
	pBas->Copy2VRAM(pMAIN_BG);

	fadeFromWhite(BOTH_SCREENS);
	
	// c parti...
	
	// Faire une boucle utilisant la liste droulante pour MAJ de la slection et des infos...	
	
	u8 styletx;
	u8 stylety;
	bool valid=false;
	string sgf_filename;	
	
	while(1)
	{		
		scanKeys();
		if (keysDown() & KEY_TOUCH)
		{							
			styletx=IPC->touchXpx;
			stylety=IPC->touchYpx;	
			
			if (IsHit(styletx,stylety,p1,p2))
			{
				valid=true;
				S_pierre1.play();
				break;
			}
			else if (IsHit(styletx,stylety,p3,p4))
			{
				valid=false;
				S_capture.play();
				break;
			}	
			else				
			// Dterminer o est le stylet!			
			if (IsHit(styletx,stylety,liste_rect))	// sur la liste
			{			
				if (styletx<(liste_rect.x+liste_rect.width-16))
				{
					// Quelle ligne ?
					liste_choix.my_selection=(stylety-liste_rect.y-4)/12; // 12==hauteur de police
					if (liste_choix.my_selection>=(liste_choix.my_nb))
					{
						liste_choix.my_selection=(liste_choix.my_nb)-1;
					}
				}
				else
				if (IsHit(styletx,stylety,liste_rect.x+liste_rect.width-16,liste_rect.y,16,16))
				{
					// icone pour monter dans la liste
					liste_choix.my_scroll_index-=liste_choix.my_nb;
					if (liste_choix.my_scroll_index<0)
						liste_choix.my_scroll_index=0;
					else
						liste_choix.my_selection=liste_choix.my_nb-1;
				}
				else
				if (IsHit(styletx,stylety,liste_rect.x+liste_rect.width-16,liste_rect.y+16,16,16))
				{
					// icone pour descendre dans la liste
					liste_choix.my_scroll_index+=liste_choix.my_nb;
					//liste_choix.my_scroll_index++;
					if ((liste_choix.my_scroll_index+liste_choix.my_nb)>(s8)liste_choix.items.size())
					{
						liste_choix.my_scroll_index=liste_choix.items.size()-liste_choix.my_nb;					
					}
					liste_choix.my_selection=0;
				}
			
				// update de la liste si la slection change
			
				liste_choix.update();
				swiWaitForVBlank();	
				pBas->Copy2VRAM(pMAIN_BG);
			}
			else
			{
				// sur un des champs de saisie ?
				if (IsHit(styletx,stylety,31-4,7,254-32+2,20-8+2))	// nom de la partie	
				{	
					keyboard.Edit(MyLocalization.game_name_text,nom_fichier);
					
					pBas->DrawRect(31-4,7,254-32+2,20-8+2,254);
					arial12->WriteParagraph(nom_fichier,pBas,32,8,250,20);
					pBas->DrawFrameRect(31-4,7,254-32+2,20-8+2,253);
					
					pBas->Copy2VRAM(pMAIN_BG);
					
					fadeFromWhite(BOTH_SCREENS);					
				}
				else
				if (IsHit(styletx,stylety,31-4,7+32,254-32+2,20-8+2))	// nom du joueur noir
				{	
					keyboard.Edit(MyLocalization.black_player_text,nom_joueur_noir);
					
					pBas->DrawRect(31-4,7+32,254-32+2,20-8+2,254);
					arial12->WriteParagraph(nom_joueur_noir,pBas,32,8+32,250,20+32);
					pBas->DrawFrameRect(31-4,7+32,254-32+2,20-8+2,253);
					
					pBas->Copy2VRAM(pMAIN_BG);
					
					fadeFromWhite(BOTH_SCREENS);					
				}
				else
				if (IsHit(styletx,stylety,31-4,7+32+32,254-32+2,20-8+2))	// nom du joueur blanc
				{	
					keyboard.Edit(MyLocalization.white_player_text,nom_joueur_blanc);
					
					pBas->DrawRect(31-4,7+32+32,254-32+2,20-8+2,254);
					arial12->WriteParagraph(nom_joueur_blanc,pBas,32,8+32+32,250,20+32+32);
					pBas->DrawFrameRect(31-4,7+32+32,254-32+2,20-8+2,253);
					
					pBas->Copy2VRAM(pMAIN_BG);
					
					fadeFromWhite(BOTH_SCREENS);					
				}				
			}
		}				
		else if (keysHeld() & KEY_DOWN)
		{
			// on descend dans la liste
			liste_choix.my_selection++;
							
			if (liste_choix.my_selection==(liste_choix.my_nb))	// Il faut scroller vers le bas!
			{	
				liste_choix.my_scroll_index+=liste_choix.my_nb;
				//liste_choix.my_scroll_index++;
				if ((liste_choix.my_scroll_index+liste_choix.my_nb)>(s8)liste_choix.items.size())
				{
					liste_choix.my_scroll_index=liste_choix.items.size()-liste_choix.my_nb;
					liste_choix.my_selection--;						
				}
				else
					liste_choix.my_selection=0;
			}
			else
			if (liste_choix.my_selection+liste_choix.my_scroll_index>(s8)liste_choix.items.size()-1)
			{
				liste_choix.my_selection--;
			}
				
			// MAJ de la liste
			liste_choix.update();
			swiWaitForVBlank();	
			pBas->Copy2VRAM(pMAIN_BG);
		}
		else if (keysHeld() & KEY_UP)
		{
			// on monte dans la liste
			if (liste_choix.my_selection==0)
			{
				//liste_choix.my_scroll_index--;
				liste_choix.my_scroll_index-=liste_choix.my_nb;
				if (liste_choix.my_scroll_index<0)
					liste_choix.my_scroll_index=0;
				else
					liste_choix.my_selection=liste_choix.my_nb-1;
			}
			else
				liste_choix.my_selection--;					
				
			// MAJ de la liste
			liste_choix.update();
			swiWaitForVBlank();	
			pBas->Copy2VRAM(pMAIN_BG);
		}		
	}	
	
	if (!valid)
	{
		fadeToWhite(BOTH_SCREENS);
		return false;
	}
	
	// the end

	fadeToWhite(BOTH_SCREENS);	
	
	delete pHaut;
	delete pBas;
	
	// On initialise l'arbre...
	
	// RAZ du SGF
	
	SGF_tree.RAZ();
	
	SGF_tree.application="DSgf";
	SGF_tree.game_name=nom_fichier;
	SGF_tree.player_black=nom_joueur_noir;
	SGF_tree.player_white=nom_joueur_blanc;

	// cration de la premire node...

	Node_type* nouvelle_node;
	
	nouvelle_node=new (Node_type);
	SGF_tree.allocated_node_number++;
	
	nouvelle_node->setup_goban=NULL;
	nouvelle_node->move_number=0;
	nouvelle_node->node_name=MyLocalization.first_node_name;
	nouvelle_node->nb_volets_commentaires=0;
	nouvelle_node->commande_SGF="";
	nouvelle_node->setup_goban=NULL;	
	nouvelle_node->node_amont=NULL;
	
	handicap=liste_handicap[liste_choix.my_selection+liste_choix.my_scroll_index];
	
	SGF_tree.handicap=handicap;
	
	initialise_goban(&Goban,"19");
	
	if (handicap=="0")
	{
		nouvelle_node->type_node=node_neutral;
		SGF_tree.komi="7.5";
		nouvelle_node->move_couleur=PierreBlanche;
	}
	else if (handicap=="1")
	{
		nouvelle_node->type_node=node_neutral;
		SGF_tree.komi="0";
		nouvelle_node->move_couleur=PierreBlanche;
	}
	else
	{		
		nouvelle_node->move_couleur=PierreNoire;
		
		nouvelle_node->type_node=node_setup;
		SGF_tree.komi="0";
		
		//Goban.intersection[co.x][co.y]=PierreNoire;	
		
		// on sauvegarde le goban dans goban_setup...
		
		Goban_type* pgoban=new Goban_type;
		
		initialise_goban(pgoban,"19");
		
		nouvelle_node->setup_goban=pgoban;
		SGF_tree.allocated_goban_number++;

		if (handicap=="2")
		{
			pgoban->intersection[4][4]=PierreNoire;
			pgoban->intersection[16][16]=PierreNoire;
		}		
		else if (handicap=="3")
		{
			pgoban->intersection[4][4]=PierreNoire;
			pgoban->intersection[16][16]=PierreNoire;
			pgoban->intersection[16][4]=PierreNoire;
		}
		else if (handicap=="4")
		{
			pgoban->intersection[4][4]=PierreNoire;
			pgoban->intersection[16][16]=PierreNoire;
			pgoban->intersection[16][4]=PierreNoire;
			pgoban->intersection[4][16]=PierreNoire;
		}
		else if (handicap=="5")
		{
			pgoban->intersection[4][4]=PierreNoire;
			pgoban->intersection[16][16]=PierreNoire;
			pgoban->intersection[16][4]=PierreNoire;
			pgoban->intersection[4][16]=PierreNoire;
			pgoban->intersection[10][10]=PierreNoire;
		}
		else if (handicap=="6")
		{
			pgoban->intersection[4][4]=PierreNoire;
			pgoban->intersection[16][16]=PierreNoire;
			pgoban->intersection[16][4]=PierreNoire;
			pgoban->intersection[4][16]=PierreNoire;
			pgoban->intersection[4][10]=PierreNoire;
			pgoban->intersection[16][10]=PierreNoire;
		}
		else if (handicap=="7")
		{
			pgoban->intersection[4][4]=PierreNoire;
			pgoban->intersection[16][16]=PierreNoire;
			pgoban->intersection[16][4]=PierreNoire;
			pgoban->intersection[4][16]=PierreNoire;
			pgoban->intersection[4][10]=PierreNoire;
			pgoban->intersection[16][10]=PierreNoire;
			pgoban->intersection[10][10]=PierreNoire;
		}
		else if (handicap=="8")
		{
			pgoban->intersection[4][4]=PierreNoire;
			pgoban->intersection[16][16]=PierreNoire;
			pgoban->intersection[16][4]=PierreNoire;
			pgoban->intersection[4][16]=PierreNoire;
			pgoban->intersection[4][10]=PierreNoire;
			pgoban->intersection[16][10]=PierreNoire;
			pgoban->intersection[10][4]=PierreNoire;
			pgoban->intersection[10][16]=PierreNoire;
		}
		else if (handicap=="9")
		{
			pgoban->intersection[4][4]=PierreNoire;
			pgoban->intersection[16][16]=PierreNoire;
			pgoban->intersection[16][4]=PierreNoire;
			pgoban->intersection[4][16]=PierreNoire;
			pgoban->intersection[4][10]=PierreNoire;
			pgoban->intersection[16][10]=PierreNoire;
			pgoban->intersection[10][4]=PierreNoire;
			pgoban->intersection[10][16]=PierreNoire;
			pgoban->intersection[10][10]=PierreNoire;		}
	}

	SGF_tree.premiere_node=nouvelle_node;
	nouvelle_node->variantes.clear();
	
	return true;
}

void BoucleJeu()
{	

	// Prparation des animations de sprites
	
//fadeFromWhite(BOTH_SCREENS);	// debug
	
	whitestone384_anim.etat=animOFF;
	blackstone384_anim.etat=animOFF;
	whitestone384_anim.type=CaretAnim;
	blackstone384_anim.type=CaretAnim;
	whitestone384_anim.steps=24;
	blackstone384_anim.steps=24;
	whitestone384_anim.type=CaretAnim;
	blackstone384_anim.type=CaretAnim;
	whitestone384_anim.dx=0;
	blackstone384_anim.dx=0;
	whitestone384_anim.dy=10;
	blackstone384_anim.dy=-10;
	whitestone384_anim.sprite=whiteStone384_spr;
	blackstone384_anim.sprite=blackStone384_spr;
	
	whitestone192_anim.etat=animOFF;
	blackstone192_anim.etat=animOFF;
	whitestone192_anim.type=CaretAnim;
	blackstone192_anim.type=CaretAnim;
	whitestone192_anim.steps=24;
	blackstone192_anim.steps=24;
	whitestone192_anim.type=CaretAnim;
	blackstone192_anim.type=CaretAnim;
	whitestone192_anim.dx=0;
	blackstone192_anim.dx=0;
	whitestone192_anim.dy=10;
	blackstone192_anim.dy=-10;
	whitestone192_anim.sprite=whiteStone192_spr;
	blackstone192_anim.sprite=blackStone192_spr;
	
	nav1.etat=animOFF;
	nav2.etat=animOFF;
	nav3.etat=animOFF;
	nav4.etat=animOFF;
	nav5.etat=animOFF;
	nav6.etat=animOFF;

	eject_anim.etat=animOFF;
	database_anim.etat=animOFF;
	comment_anim.etat=animOFF;
	
	nav1.type=MenuAnim;	
	nav2.type=MenuAnim;	
	nav3.type=MenuAnim;	
	nav4.type=MenuAnim;	
	nav5.type=MenuAnim;	
	nav6.type=MenuAnim;	
	
	nav1.steps=16;
	nav2.steps=16;
	nav3.steps=16;
	nav4.steps=16;
	nav5.steps=16;
	nav6.steps=16;
	
	nav1.dx=3;
	nav1.dy=0;

	nav2.dx=5;
	nav2.dy=0;

	nav3.dx=7;
	nav3.dy=0;

	nav4.dx=9;
	nav4.dy=0;

	nav5.dx=11;
	nav5.dy=0;

	nav6.dx=13;
	nav6.dy=0;
	
	nav1.sprite=skipback_spr;	
	nav1.destination.x=16;
	nav1.destination.y=16;
	
	nav2.sprite=rewind_spr;
	nav2.destination.x=40;
	nav2.destination.y=16;

	nav3.sprite=playback_spr;
	nav3.destination.x=62;
	nav3.destination.y=16;

	nav4.sprite=play_spr;	
	nav4.destination.x=84;
	nav4.destination.y=16;

	nav5.sprite=fastforward_spr;	
	nav5.destination.x=106;
	nav5.destination.y=16;

	nav6.sprite=skip_spr;
	nav6.destination.x=128;
	nav6.destination.y=16;

	eject_anim.type=MenuAnim;	
	eject_anim.steps=16;
	eject_anim.dx=0;
	eject_anim.dy=3;
	eject_anim.sprite=eject_spr;
	eject_anim.destination.x=200;
	eject_anim.destination.y=16;

	database_anim.type=MenuAnim;	
	database_anim.steps=16;
	database_anim.dx=0;
	database_anim.dy=5;
	database_anim.sprite=diskette_spr;
	database_anim.destination.x=200;
	database_anim.destination.y=40;
	
	comment_anim.type=MenuAnim;	
	comment_anim.steps=16;
	comment_anim.dx=0;
	comment_anim.dy=7;
	comment_anim.sprite=quote_spr;
	comment_anim.destination.x=200;
	comment_anim.destination.y=62;

	checkmark_anim.type=MenuAnim;
	checkmark_anim.steps=0;
	checkmark_anim.dx=0;
	checkmark_anim.dy=0;
	checkmark_anim.sprite=checkmark_spr;	
	checkmark_anim.duree_affichage=125;	// infrieure  celle par dfaut (175)
												
	// Ici on passe en mode "jeu"/affichage goban	
	
	//lcdSwap();	// l'cran principal passe "en bas" et le secondaire "en haut"	
	
 	// bon allez assez jou... au boulot !!!

	//SetBG3AsForeground();	// on remet le goban zoom en premier plan		

	commentaire_avant=false;
		
	pEcranStats=new CMyBitmap(256,192);		// va servir d'ecran virtuel pour crire

	pEcranStats->Fill(254);	
		
	//ClearConsole();

	current_node=SGF_tree.premiere_node;

	modeEcranHaut=modeStats;
	
	// prparation de la page des stats
	string texte;
	
	// bandeau du bas
		
	pEcranStats->DrawFrameRect(0,128,255,6,255);	// cadre noir pour la barre d'avancement
		
	blackStone192.BitBltOnBitmap(pEcranStats,4,132+12);
	
	//iprintf("ca va toujours...?\n");
	
	if (SGF_tree.player_black!="")
		texte=SGF_tree.player_black+" "+SGF_tree.black_rank;
	else
		texte="(unknown player)";	
	
	arial12->WriteParagraph((char*)texte.c_str(),pEcranStats,16,131+12,255,143+12);
		
	whiteStone192.BitBltOnBitmap(pEcranStats,4,144+12);
	
	if (SGF_tree.player_white!="")
		texte=SGF_tree.player_white+" "+SGF_tree.white_rank;	
	else
		texte="(unknown player)";
		
	arial12->WriteParagraph((char*)texte.c_str(),pEcranStats,16,143+12,255,155+12);
		
	blackStone192.BitBltOnBitmap(pEcranStats,200,156+12);
	arial12->BasicWrite((char*)MyLocalization.captured_stones_text.c_str(),pEcranStats,212,155+12);
	
	whiteStone192.BitBltOnBitmap(pEcranStats,200,168+12);
	arial12->BasicWrite((char*)MyLocalization.captured_stones_text.c_str(),pEcranStats,212,167+12);	

//iprintf("avant MAJecranhaut\n");
	
	BoucleJeuMAJEcranHaut();

//iprintf("aprs MAJecranhaut\n");
		
	pEcranStats->Copy2VRAM(pSUB_BG);	
	
	// fin de la cration de l'cran stats
	
	gobanNormal.Copy2VRAM(pMAIN_BG); 
	gobanZoom.Copy2VRAM(pMAIN_LARGE_BG);
	
	// Si setup => on copie l'tat de dpart...
		
	if (current_node->type_node==node_setup)
	{
		Restore_Setup(current_node->setup_goban);
	}

	fadeFromWhite(BOTH_SCREENS);	// Affichage... 

	//iprintf("ok l...\n");
		
	bool mode_zoom=false;	
	
	Node_type* nouvelle_node=NULL;
	
	s16 dx=193;		// dcalage/scrolling du goban zoom
	s16 dy=0;
	
	swiWaitForVBlank(); // on attend la prochaine synchro verticale
			
	BG3_CX = dx << 8;   // on synchronise avec l'cran zoom
	BG3_CY = dy << 8;
	
	u8 styletx=0;	// position du stylet
	u8 stylety=0;
	u8 sx2, sy2, sx1, sy1;	// et ses variables pour lisser dans le temps (vs le "stylus jumping"!)	
	sx1=0;
	sx2=0;
	sy1=0;
	sy2=0;	
	
	u16 x2,y2;
	
	bool L_seul=false;	// Pour se souvenir si on a utilis une touche en plus de L, ou bien juste L tout seul
	bool scroll=false;
	menu_actif=false;
		
	bool selection=false;
	
	u8 caret_a=0,caret_b=0;
	
	u16 appui_pad=0;
	u16 appui_pad_palier1=64;
	u16 appui_pad_palier2=160;
	u8 sub_appui_pad=0;
	u8 sub_appui_pad_max=8;
	
	if (current_mode==modeRecord)	
	{
		// On cre une node "courante" qui sera remplie en fonction de la saisie et ajoute  l'arbre sur
		// validation...
		nouvelle_node=new (Node_type);
		// initialisation des attributs			
		nouvelle_node->nb_volets_commentaires=0;
		nouvelle_node->commande_SGF="";
		nouvelle_node->setup_goban=NULL;
		nouvelle_node->move_number=current_node->move_number+1;
	}
						
 	while(1)	// Quand on en sort, c'est pour revenir au menu principal	
	{
		swiWaitForVBlank();		// optionnel ?
		
		// ----------------------
		// 1) gestion des inputs
		// ----------------------
		
		scanKeys();	// lecture des inputs
		
		// --------------------------------------------------
		// 1-1) Fonction scroll & zoom/unzoom de la touche L
		// --------------------------------------------------
		
		if ((keysUp() & KEY_L)&&(L_seul))
		{
			if (mode_zoom)	// on dzoome!
			{
				//iprintf("BG2 en priorit 1\n");
 				SetBG2AsForeground(); 
				mode_zoom=false;	
				
				if (modeEcranHaut==modeGoban)	// sur un dzoom, on revient en mode stats en haut
					modeEcranHaut=modeStats;	// pour ne pas avoir 2 fois le goban_normal
				
				// MAJ de l'cran du haut
				BoucleJeuMAJEcranHaut();	
				
				// on annule la slection prcdente
				
				if (NextToPlay==PierreBlanche)
				{			
					whitestone384_anim.etat=animOFF;
					whitestone384_anim.step=0;
					whitestone384_anim.index_duree=0;
					whitestone384_anim.index_clignotement=0;	
					whitestone384_anim.sprite->cache();
				}
				else
				{			
					blackstone384_anim.etat=animOFF;
					blackstone384_anim.step=0;
					blackstone384_anim.index_duree=0;
					blackstone384_anim.index_clignotement=0;	
					blackstone384_anim.sprite->cache();
				}
				// MAJ des sprites
				CMySprite::updateMainOAM();	
				selection=false;				
				
			}
			else	// on zoome !
			{
				//iprintf("BG2 en priorit 3\n");
  			SetBG3AsForeground();
  			mode_zoom=true;   			
  			L_seul=false;
  			
  			// on annule la slection prcdente
			if (NextToPlay==PierreBlanche)
			{
				whitestone192_anim.etat=animOFF;
				whitestone192_anim.step=0;
				whitestone192_anim.index_duree=0;
				whitestone192_anim.index_clignotement=0;	
				whitestone192_anim.sprite->cache();
			}
			else
			{
				blackstone192_anim.etat=animOFF;
				blackstone192_anim.step=0;
				blackstone192_anim.index_duree=0;
				blackstone192_anim.index_clignotement=0;	
				blackstone192_anim.sprite->cache();
			}
			
				checkmark_spr->cache();	  		

				// MAJ des sprites
				CMySprite::updateMainOAM();	
				selection=false;
			}
		}
		
		if (keysDown() & KEY_L)
  	{
  		L_seul=true;
  	}
		
		if ((keysDown() & KEY_TOUCH)&&(keysHeld() & KEY_L))	// premier appui
		{
			L_seul=false;
			styletx=IPC->touchXpx;
			stylety=IPC->touchYpx;
			sx1=styletx;
			sy1=stylety;
			sx2=styletx;
			sy2=stylety;
		}
				
		if ((keysHeld() & KEY_TOUCH)&&(keysHeld() & KEY_L)) // drag & drop !
		{
			L_seul=false;
			dx-=(styletx-sx2);
			dy-=(stylety-sy2);
			scroll=true;
			
			sx2=sx1;
			sy2=sy1;
			sx1=styletx;
			sy1=stylety;
									
			styletx=IPC->touchXpx;
			stylety=IPC->touchYpx;
		}		

		// ------------------------------
		// 1-2) Menu par la touche START
		// ------------------------------

		if(keysDown() & KEY_START)
  	{  		
			// on vire toute slection...
			checkmark_spr->cache();	  						
			if (selection)
			{
				selection=false;
				if (NextToPlay==PierreBlanche)
				{				
					whitestone192_anim.etat=animOFF;
					whitestone384_anim.etat=animOFF;
					whitestone192_anim.sprite->cache();
					whitestone384_anim.sprite->cache();
				}
				else
				{				
					blackstone192_anim.etat=animOFF;
					blackstone384_anim.etat=animOFF;
					blackstone192_anim.sprite->cache();
					blackstone384_anim.sprite->cache();
				}
			}
			CMySprite::updateMainOAM();
	
  		if (!menu_actif)
  		{
  			swiWaitForVBlank();
			S_menu.play();
  			menu_actif=true;
  			BoucleJeuMontreMenu();
  		}
  		else
  		{
  			swiWaitForVBlank();
			S_menu.play();
  			menu_actif=false;
  			BoucleJeuCacheMenu();
  		}
  	}

		// ------------------------------
		// 1-3) Aide par la touche SELECT
		// ------------------------------

		if(keysDown() & KEY_SELECT)
		{
		
			// on vire toute slection...
			checkmark_spr->cache();	  						
			if (selection)
			{
				selection=false;
				if (NextToPlay==PierreBlanche)
				{				
					whitestone192_anim.etat=animOFF;
					whitestone384_anim.etat=animOFF;
					whitestone192_anim.sprite->cache();
					whitestone384_anim.sprite->cache();
				}
				else
				{				
					blackstone192_anim.etat=animOFF;
					blackstone384_anim.etat=animOFF;
					blackstone192_anim.sprite->cache();
					blackstone384_anim.sprite->cache();
				}
			}
			CMySprite::updateMainOAM();
		
			if (mode_zoom)
			{
				// on met BG2 devant car on va crire dessus
 				SetBG2AsForeground(); 
			}
		
  			BackupSubBG2();	// Backup subscreen to banks H+I
			
			CMyBitmap* ptmp=new CMyBitmap(256,192);		
			dmaCopy(pMAIN_BG, ptmp->p_data , 256*192);	// backup cran principal
			
			fadeToWhite(BOTH_SCREENS);
			
			SetPaletteMAIN_BG(help_Pal_bin);
			SetPaletteSUB_BG(help_Pal_bin);
	
			helpA.Copy2VRAM(pSUB_BG);
			helpB.Copy2VRAM(pMAIN_BG);
			
			fadeFromWhite(BOTH_SCREENS);
			
			WaitForTouch();
			
			// retour au menu...
		
			fadeToWhite(BOTH_SCREENS);
		
			
			// restore game's Main_BG
			ptmp->Copy2VRAM(pMAIN_BG);
			// restore sub screen
			RestoreSubBG2();

			if (mode_zoom)
			{
				// on remet BG3 devant
 				SetBG3AsForeground(); 
			}		
		
			SetPaletteMAIN_BG(master_Pal_bin);
			SetPaletteSUB_BG(master_Pal_bin);
		
			BG_PALETTE_SUB[254] = RGB15(31,31,31);
			BG_PALETTE_SUB[255] = RGB15(0,0,0);
			
			BG_PALETTE[255] = BG_PALETTE_SUB[255];
			BG_PALETTE[254] = BG_PALETTE_SUB[254];
			
			// ET ajoute en force une couleur "goban"  la palette
			
			BG_PALETTE_SUB[253] = RGB15(31,27,15);
			BG_PALETTE[253] = BG_PALETTE_SUB[253];
			
			fadeFromWhite(BOTH_SCREENS);

			sleepCycles(30);	
		}

		// --------------------
		// 1-4) Touches A et B
		// --------------------

		if (((keysDown() & KEY_A) && selection) && (current_mode==modeRecord))	// validation de la slection
		{  		
			// on joue la slection...
  		
			if (mode_zoom)	// mode zoom
					Goban2Screen384(caret_a,caret_b,x2,y2);
			else
					Goban2Screen192(caret_a,caret_b,x2,y2);
									
			// plus de slection
				
				if (selection)
				{
					selection=false;
					if (NextToPlay==PierreBlanche)
					{				
						whitestone192_anim.etat=animOFF;
						whitestone384_anim.etat=animOFF;
						whitestone192_anim.sprite->cache();
						whitestone384_anim.sprite->cache();
					}
					else
					{				
						blackstone192_anim.etat=animOFF;
						blackstone384_anim.etat=animOFF;
						blackstone192_anim.sprite->cache();
						blackstone384_anim.sprite->cache();
					}
				}
				
				checkmark_spr->cache();	  		
				CMySprite::updateMainOAM();				
							
				
				// enregistrement du coup (attention! toutes les branches ou variantes sont supprimes!
				
				bool coup_valide=SGF_tree.Enregistre_coup(current_node,caret_a,caret_b,NextToPlay);				
				
				if (coup_valide)
				{
					iprintf("ok. ");
					
					// on vire les sprites...
					
					if (NextToPlay==PierreBlanche)
					{				
						whitestone192_anim.etat=animOFF;
						whitestone384_anim.etat=animOFF;
						whitestone192_anim.sprite->cache();
						whitestone384_anim.sprite->cache();
						NextToPlay=PierreNoire;
					}
					else
					{				
						blackstone192_anim.etat=animOFF;
						blackstone384_anim.etat=animOFF;
						blackstone192_anim.sprite->cache();
						blackstone384_anim.sprite->cache();
						NextToPlay=PierreBlanche;
					}
				
					// on avance dans l'arbre...
					
					current_node=current_node->variantes[0];
					
					Nombre_total_coups=current_node->move_number;
					
					int res=SGF_tree.Move_forward(current_node);
					
					if (res>0)	// captures
					{	// capture(s) !
						swiWaitForVBlank(); // on attend la prochaine synchro verticale	
						S_capture.play();
					}
					else if (res==0)	// normal
					{	
						swiWaitForVBlank(); // on attend la prochaine synchro verticale				
						if (rand() % 2)	// 0 ou 1 !
							S_pierre1.play();
						else
							S_pierre2.play();
					}
					
					// MAJ de l'cran du haut				
					BoucleJeuMAJEcranHaut();
				}
				else
				{
					iprintf("KO! ");
				
					// le coup n'est pas valide... on retire tout...
					selection=false;
					if (NextToPlay==PierreBlanche)
					{				
						whitestone192_anim.etat=animOFF;
						whitestone384_anim.etat=animOFF;
						whitestone192_anim.sprite->cache();
						whitestone384_anim.sprite->cache();
					}
					else
					{				
						blackstone192_anim.etat=animOFF;
						blackstone384_anim.etat=animOFF;
						blackstone192_anim.sprite->cache();
						blackstone384_anim.sprite->cache();
					}
					swiWaitForVBlank();	
					S_cancel.play();
				}
				
				sleepCycles(30);
		}
		else
		if (((keysDown() & KEY_B) && selection) && (current_mode==modeRecord)) // annulation de la slection
		{
			selection=false;
			if (NextToPlay==PierreBlanche)
			{				
				whitestone192_anim.etat=animOFF;
				whitestone384_anim.etat=animOFF;
				whitestone192_anim.sprite->cache();
				whitestone384_anim.sprite->cache();
			}
			else
			{				
				blackstone192_anim.etat=animOFF;
				blackstone384_anim.etat=animOFF;
				blackstone192_anim.sprite->cache();
				blackstone384_anim.sprite->cache();
			}
			
			checkmark_spr->cache();	  		
			CMySprite::updateMainOAM();
			
			swiWaitForVBlank();	
			S_cancel.play();
		}

		// --------------------
		// 1-5) Touches X et Y
		// --------------------

		if (keysDown() & KEY_X)	// recherche d'un commentaire en aval
		{
			// on vire toute slection...
			checkmark_spr->cache();	  						
			if (selection)
			{
				selection=false;
				if (NextToPlay==PierreBlanche)
				{				
					whitestone192_anim.etat=animOFF;
					whitestone384_anim.etat=animOFF;
					whitestone192_anim.sprite->cache();
					whitestone384_anim.sprite->cache();
				}
				else
				{				
					blackstone192_anim.etat=animOFF;
					blackstone384_anim.etat=animOFF;
					blackstone192_anim.sprite->cache();
					blackstone384_anim.sprite->cache();
				}
			}
			CMySprite::updateMainOAM();
			
			// On va avancer tant qu'on est pas  la fin et tant qu'il n'y a pas de commentaires...
			if (current_node->variantes.size()!=0)
			{						
				current_node=current_node->variantes[0];
					
				SGF_tree.Move_forward(current_node);
				
				if (NextToPlay==PierreBlanche)
					NextToPlay=PierreNoire;
				else
					NextToPlay=PierreBlanche;

			}	

			while (current_node->variantes.size()!=0 && current_node->commentaire.size()==0)
			{										
				current_node=current_node->variantes[0];
					
				SGF_tree.Move_forward(current_node);
				if (NextToPlay==PierreBlanche)
					NextToPlay=PierreNoire;
				else
					NextToPlay=PierreBlanche;
			}
			
			// on est arrivs !
			// MAJ de l'cran du haut				
			BoucleJeuMAJEcranHaut();
			
		}
		else
		if (keysDown() & KEY_Y)	// recherche d'un commentaire en amont
		{
			// on vire toute slection...
			checkmark_spr->cache();	  						
			if (selection)
			{
				selection=false;
				if (NextToPlay==PierreBlanche)
				{				
					whitestone192_anim.etat=animOFF;
					whitestone384_anim.etat=animOFF;
					whitestone192_anim.sprite->cache();
					whitestone384_anim.sprite->cache();
				}
				else
				{				
					blackstone192_anim.etat=animOFF;
					blackstone384_anim.etat=animOFF;
					blackstone192_anim.sprite->cache();
					blackstone384_anim.sprite->cache();
				}
			}
			CMySprite::updateMainOAM();
			
			// On va reculer tant qu'on est pas au dbut et tant qu'il n'y a pas de commentaires...
			if (current_node!=SGF_tree.premiere_node)
			{						
				SGF_tree.Move_backward(current_node);
				
				current_node=current_node->node_amont;
				
				if (NextToPlay==PierreBlanche)
					NextToPlay=PierreNoire;
				else
					NextToPlay=PierreBlanche;
			}

			while (current_node!=SGF_tree.premiere_node && current_node->commentaire.size()==0)
			{
				SGF_tree.Move_backward(current_node);
				
				current_node=current_node->node_amont;
				
				if (NextToPlay==PierreBlanche)
					NextToPlay=PierreNoire;
				else
					NextToPlay=PierreBlanche;
			}
				
			// on est arrivs !
			// MAJ de l'cran du haut				
			BoucleJeuMAJEcranHaut();
		}

		// -------------------------
		// 1-6) Fonctions touche 'R'
		// -------------------------

		if ((keysDown() & KEY_R))
		{
			// changement de mode
			
			if (modeEcranHaut==modeStats && mode_zoom)
				modeEcranHaut=modeGoban;
			else if (modeEcranHaut==modeGoban)
				modeEcranHaut=modeStats;
				
			// MAJ de l'cran du haut
			BoucleJeuMAJEcranHaut();			
		}
		
		// -----------------------
		// 1-7) Gestion du stylet
		// -----------------------

		if ((keysDown() & KEY_TOUCH)&&(!(keysHeld() & KEY_L)))	// premier appui stylet sans 'L'
		{
			styletx=IPC->touchXpx;
			stylety=IPC->touchYpx;
			sx1=styletx;
			sy1=stylety;
			sx2=styletx;
			sy2=stylety;
			
			if ((!mode_zoom)&&((sx2<32)||(sx2>224)))	//clique en dehors du goban en mode unzoom => MENU on/off
			{	

				// on vire toute slection...
				checkmark_spr->cache();	  						
				if (selection)
				{
					selection=false;
					if (NextToPlay==PierreBlanche)
					{				
						whitestone192_anim.etat=animOFF;
						whitestone384_anim.etat=animOFF;
						whitestone192_anim.sprite->cache();
						whitestone384_anim.sprite->cache();
					}
					else
					{				
						blackstone192_anim.etat=animOFF;
						blackstone384_anim.etat=animOFF;
						blackstone192_anim.sprite->cache();
						blackstone384_anim.sprite->cache();
					}
				}
				CMySprite::updateMainOAM();

				if (!menu_actif)
				{
					swiWaitForVBlank();
					S_menu.play();
					menu_actif=true;
					//iprintf("menu actif\n");
					BoucleJeuMontreMenu();
				}
				else
				{
					swiWaitForVBlank();
					S_menu.play();
					menu_actif=false;
					//iprintf("menu inactif\n");
					BoucleJeuCacheMenu();
				}
			}					
		}
		
		if ((keysHeld() & KEY_TOUCH)&&(!(keysHeld() & KEY_L))) // Stylet maintenu sans 'L'
		{
			//iprintf("sx=%d sy=%d dx=%d dy=%d\n",sx2,sy2,dx,dy);
						
			sx2=sx1;
			sy2=sy1;
			sx1=styletx;
			sy1=stylety;
									
			styletx=IPC->touchXpx;
			stylety=IPC->touchYpx;	
						
			if ((mode_zoom)&&((sx2<=8)&&(sy2<=8)))	// coin haut/gauche
			{
				dy-=16;
				dx-=16;
	  		scroll=true;
			}	
			else if ((mode_zoom)&&((sx2>=256-8-1)&&(sy2<=8)))	// coin haut/droit
			{
				dy-=16;
				dx+=16;
	  		scroll=true;
			}	
			else if ((mode_zoom)&&((sx2>=256-8-1)&&(sy2>=192-8-1)))	// coin bas/droit
			{
				dy+=16;
				dx+=16;
	  		scroll=true;
			}	
			else if ((mode_zoom)&&((sx2<=8)&&(sy2>=192-8-1)))	// coin bas/gauche
			{
				dy+=16;
				dx-=16;
	  		scroll=true;
			}	
			else if ((mode_zoom)&&(sy2>=192-8-1))	// sur le bord du bas			
			{
				dy+=16;
	  		scroll=true;	
			}
			else if ((mode_zoom)&&(sy2<=8))	// sur le bord du haut
			{
				dy-=16;
	  		scroll=true;	
			}
			else if ((mode_zoom)&&(sx2<=8))	// sur le bord de gauche
			{
				dx-=16;
	  		scroll=true;	
			}
			else if ((mode_zoom)&&(sx2>=256-8-1))	// sur le bord de droite
			{
				dx+=16;
	  		scroll=true;	
			}
			else if (eject_spr->isHit(sx2,sy2)) // Anacliqu sur un sprite ?
			{				
				if (selection)
				{
					selection=false;
					if (NextToPlay==PierreBlanche)
					{				
						whitestone192_anim.etat=animOFF;
						whitestone384_anim.etat=animOFF;
						whitestone192_anim.sprite->cache();
						whitestone384_anim.sprite->cache();
					}
					else
					{				
						blackstone192_anim.etat=animOFF;
						blackstone384_anim.etat=animOFF;
						blackstone192_anim.sprite->cache();
						blackstone384_anim.sprite->cache();
					}
				}			
			
				S_pierre2.play();
				if (mode_zoom)
					SetBG2AsForeground(); 		
									
				if (MessageMenu((char*)MyLocalization.back_to_main_menu_confirm_text.c_str()))
				{
					//fadeToWhite(SUB_SCREEN);	
					break;
				}												
				if (mode_zoom)
					SetBG3AsForeground(); 
					
				//fadeFromWhite(MAIN_SCREEN);	
					
			}
			else if (diskette_spr->isHit(sx2,sy2)) // Sauvegarde
			{	
				// Seulement en mode "record"
				
				if (current_mode==modeRecord)	
				{
					if (selection)
					{
						checkmark_spr->cache();	
						selection=false;
						if (NextToPlay==PierreBlanche)
						{				
							whitestone192_anim.etat=animOFF;
							whitestone384_anim.etat=animOFF;
							whitestone192_anim.sprite->cache();
							whitestone384_anim.sprite->cache();
						}
						else
						{				
							blackstone192_anim.etat=animOFF;
							blackstone384_anim.etat=animOFF;
							blackstone192_anim.sprite->cache();
							blackstone384_anim.sprite->cache();
						}
					}
					CMySprite::updateMainOAM();					
									
					S_valid.play();
					
					if (mode_zoom)
						SetBG2AsForeground(); 		
										
					if (SaveDialog())
					{
						swiWaitForVBlank();
						S_valid.play();
					}	
					else	// annulation de la sauvegarde
					{
						swiWaitForVBlank();	
						S_cancel.play();
					}
											
					if (mode_zoom)
						SetBG3AsForeground(); 
						
					//fadeFromWhite(MAIN_SCREEN);	
				}
				else	// pas de sauvegarde en mode lecture!
				{
					swiWaitForVBlank();	
					S_cancel.play();
				}
					
			}
			else if (quote_spr->isHit(sx2,sy2)) // Edition commentaire
			{	
				// Seulement en mode "record"
				
				if (current_mode==modeRecord)	
				{
				
					// On commence par virer le menu
	
					menu_actif=false;
				  
					BoucleJeuCacheMenu();
				  
					while (1)	// on patiente gentillement que le menu se barre...
					{
						/*avanceAnimation(nav1);
						avanceAnimation(nav2);
						avanceAnimation(nav3);
						avanceAnimation(nav4);
						avanceAnimation(nav5);
						avanceAnimation(nav6);	*/
							
						avanceAnimation(database_anim);
						avanceAnimation(comment_anim);
						avanceAnimation(eject_anim);
							
						// MAJ des sprites
						CMySprite::updateMainOAM();		
						swiWaitForVBlank();	
							
						if (eject_anim.etat==animOFF)
							break;
					}
				
					if (mode_zoom)
						SetBG2AsForeground(); 		
										
					// Edition sur la fenetre du bas...
					string commentaire;
					if (current_node->commentaire.size()>0)
					{
						commentaire=current_node->commentaire[0];
					}
					
					keyboard.Edit("Commentaire",commentaire);
					
					current_node->commentaire.clear();					
					current_node->commentaire.push_back(commentaire);
					current_node->nb_volets_commentaires=1;				// on limite  1 volet de commentaires pour l'instant...
					
					fadeFromWhite(MAIN_SCREEN);
					
					if (mode_zoom)
						SetBG3AsForeground(); 

					sleepCycles(30);	
					
					// MAJ de l'cran du haut				
					BoucleJeuMAJEcranHaut();
				}
				else	// pas de sauvegarde en mode lecture!
				{
					swiWaitForVBlank();	
					S_cancel.play();
				}
					
			}
			else if (checkmark_spr->isHit(sx2,sy2))				// Slection d'un emplacement de pose
																	// en mode normal - stade 2 : validation
			{  		
				// plus de slection
				
				if (selection)
				{
					selection=false;
					if (NextToPlay==PierreBlanche)
					{				
						whitestone192_anim.etat=animOFF;
						whitestone384_anim.etat=animOFF;
						whitestone192_anim.sprite->cache();
						whitestone384_anim.sprite->cache();
					}
					else
					{				
						blackstone192_anim.etat=animOFF;
						blackstone384_anim.etat=animOFF;
						blackstone192_anim.sprite->cache();
						blackstone384_anim.sprite->cache();
					}
				}
				
				checkmark_spr->cache();	  		
				CMySprite::updateMainOAM();
				Goban2Screen192(caret_a,caret_b,x2,y2);
													
				selection=false;			
				
				// enregistrement du coup (attention! toutes les branches ou variantes sont supprimes!
				
				bool coup_valide=SGF_tree.Enregistre_coup(current_node,caret_a,caret_b,NextToPlay);				
				
				if (coup_valide)
				{
					// on vire les sprites...
					
					if (NextToPlay==PierreBlanche)
					{				
						whitestone192_anim.etat=animOFF;
						whitestone384_anim.etat=animOFF;
						whitestone192_anim.sprite->cache();
						whitestone384_anim.sprite->cache();
						NextToPlay=PierreNoire;
					}
					else
					{				
						blackstone192_anim.etat=animOFF;
						blackstone384_anim.etat=animOFF;
						blackstone192_anim.sprite->cache();
						blackstone384_anim.sprite->cache();
						NextToPlay=PierreBlanche;
					}
				
					// on avance dans l'arbre...
					
					current_node=current_node->variantes[0];
					
					Nombre_total_coups=current_node->move_number;
					
					int res=SGF_tree.Move_forward(current_node);
					
					if (res>0)	// captures
					{	// capture(s) !
						swiWaitForVBlank(); // on attend la prochaine synchro verticale	
						S_capture.play();
					}
					else if (res==0)	// normal
					{	
						swiWaitForVBlank(); // on attend la prochaine synchro verticale				
						if (rand() % 2)	// 0 ou 1 !
							S_pierre1.play();
						else
							S_pierre2.play();
					}
					
					// MAJ de l'cran du haut				
					BoucleJeuMAJEcranHaut();
				}
				else
				{
					// le coup n'est pas valide... on retire tout...
					selection=false;
					if (NextToPlay==PierreBlanche)
					{				
						whitestone192_anim.etat=animOFF;
						whitestone384_anim.etat=animOFF;
						whitestone192_anim.sprite->cache();
						whitestone384_anim.sprite->cache();
					}
					else
					{				
						blackstone192_anim.etat=animOFF;
						blackstone384_anim.etat=animOFF;
						blackstone192_anim.sprite->cache();
						blackstone384_anim.sprite->cache();
					}
					swiWaitForVBlank();	
					S_cancel.play();
				}
				
				sleepCycles(30);
			}
			
			else if (current_mode==modeRecord)	// ben ouais...
			{
				// sur le goban
				
				if (mode_zoom)	// mode zoom
				{
					u8 na,nb;
					Screen2Goban384(sx2+dx,sy2+dy,na,nb);
					if (na<=19 && nb<=19)
					{
						if ((selection)&&((na==caret_a)&&(nb==caret_b)))	// Slection d'un emplacement de pose
																			// en mode zoom - stade 2 : validation
						{
							// plus de slection
				
							if (selection)
							{
								selection=false;
								if (NextToPlay==PierreBlanche)
								{				
									whitestone192_anim.etat=animOFF;
									whitestone384_anim.etat=animOFF;
									whitestone192_anim.sprite->cache();
									whitestone384_anim.sprite->cache();
								}
								else
								{				
									blackstone192_anim.etat=animOFF;
									blackstone384_anim.etat=animOFF;
									blackstone192_anim.sprite->cache();
									blackstone384_anim.sprite->cache();
								}
							}
							
							checkmark_spr->cache();	  		
							CMySprite::updateMainOAM();
							Goban2Screen384(caret_a,caret_b,x2,y2);
																
							selection=false;			
							
							// enregistrement du coup (attention! toutes les branches ou variantes sont supprimes!
							
							bool coup_valide=SGF_tree.Enregistre_coup(current_node,caret_a,caret_b,NextToPlay);				
							
							if (coup_valide)
							{
								// on vire les sprites...
								
								if (NextToPlay==PierreBlanche)
								{				
									whitestone192_anim.etat=animOFF;
									whitestone384_anim.etat=animOFF;
									whitestone192_anim.sprite->cache();
									whitestone384_anim.sprite->cache();
									NextToPlay=PierreNoire;
								}
								else
								{				
									blackstone192_anim.etat=animOFF;
									blackstone384_anim.etat=animOFF;
									blackstone192_anim.sprite->cache();
									blackstone384_anim.sprite->cache();
									NextToPlay=PierreBlanche;
								}
							
								// on avance dans l'arbre...
								
								current_node=current_node->variantes[0];
								
								Nombre_total_coups=current_node->move_number;
								
								int res=SGF_tree.Move_forward(current_node);
								
								if (res>0)	// captures
								{	// capture(s) !
									swiWaitForVBlank(); // on attend la prochaine synchro verticale	
									S_capture.play();
								}
								else if (res==0)	// normal
								{	
									swiWaitForVBlank(); // on attend la prochaine synchro verticale				
									if (rand() % 2)	// 0 ou 1 !
										S_pierre1.play();
									else
										S_pierre2.play();
								}
								
								// MAJ de l'cran du haut				
								BoucleJeuMAJEcranHaut();
							}
							else
							{
								// le coup n'est pas valide... on retire tout...
								selection=false;
								if (NextToPlay==PierreBlanche)
								{				
									whitestone192_anim.etat=animOFF;
									whitestone384_anim.etat=animOFF;
									whitestone192_anim.sprite->cache();
									whitestone384_anim.sprite->cache();
								}
								else
								{				
									blackstone192_anim.etat=animOFF;
									blackstone384_anim.etat=animOFF;
									blackstone192_anim.sprite->cache();
									blackstone384_anim.sprite->cache();
								}
								swiWaitForVBlank();	
								S_cancel.play();
							}
							
							sleepCycles(30);
						}
						else
						{											// Slection d'un emplacement de pose
																	// en mode zoom - stade 1 : slection
																	
							u8 caret_a_tmp,caret_b_tmp;
																	
							Screen2Goban384(sx2+dx,sy2+dy,caret_a_tmp,caret_b_tmp);
							
							Goban2Screen384(caret_a_tmp,caret_b_tmp,x2,y2);
							
							// est-ce que l'emplacement est vide ?
						
							if (Goban.intersection[caret_a_tmp][caret_b_tmp]!=AucunePierre)
							{
								swiWaitForVBlank();	
								S_cancel.play();
							}
							else	// oui... on slectionne l'emplacement
							{
								caret_a=caret_a_tmp;
								caret_b=caret_b_tmp;
							
								selection=true;
								
								if (NextToPlay==PierreBlanche)
								{				
									whitestone384_anim.destination.x=x2-dx-9;				
									whitestone384_anim.destination.y=y2-dy-7;
														
									whitestone384_anim.x=whitestone384_anim.destination.x;
									whitestone384_anim.y=whitestone384_anim.destination.y;
									
									whitestone384_anim.etat=animBlink;
									whitestone384_anim.step=0;
									whitestone384_anim.index_duree=0;
									whitestone384_anim.index_clignotement=0;					
									whitestone384_anim.sprite->move(whitestone384_anim.destination.x,whitestone384_anim.destination.y);																				
								}
								else
								{				
									blackstone384_anim.destination.x=x2-dx-9;				
									blackstone384_anim.destination.y=y2-dy-7;
														
									blackstone384_anim.x=blackstone384_anim.destination.x;
									blackstone384_anim.y=blackstone384_anim.destination.y;
									
									blackstone384_anim.etat=animBlink;
									blackstone384_anim.step=0;
									blackstone384_anim.index_duree=0;
									blackstone384_anim.index_clignotement=0;					
									blackstone384_anim.sprite->move(blackstone384_anim.destination.x,blackstone384_anim.destination.y);																				
								}							
							}
							sleepCycles(30);
						}
					}
				}
				else	// mode normal
				if ((sx2>32)&&(sx2<224))
				{	
					u8 caret_a_tmp, caret_b_tmp;
					Screen2Goban192(sx2,sy2,caret_a_tmp,caret_b_tmp);		// Slection d'un emplacement de pose
																	// en mode normal - stade 1 : slection
					if (caret_a_tmp<=19 && caret_b_tmp<=19)				
					{
						Goban2Screen192(caret_a_tmp,caret_b_tmp,x2,y2);
						
						// est-ce que l'emplacement est vide ?
						
						if (Goban.intersection[caret_a_tmp][caret_b_tmp]!=AucunePierre)
						{
							swiWaitForVBlank();	
							S_cancel.play();
						}
						else	// oui... on slectionne l'emplacement
						{
							caret_a=caret_a_tmp;
							caret_b=caret_b_tmp;
						
							selection=true;
							
							if (current_node->move_couleur==PierreBlanche)
								NextToPlay=PierreNoire;
							else
								NextToPlay=PierreBlanche;
							
							if (NextToPlay==PierreBlanche)
							{
								whitestone192_anim.destination.x=x2-3;				
								whitestone192_anim.destination.y=y2-4;
													
								whitestone192_anim.x=whitestone192_anim.destination.x;
								whitestone192_anim.y=whitestone192_anim.destination.y;
								
								whitestone192_anim.etat=animBlink;
								whitestone192_anim.step=0;
								whitestone192_anim.index_duree=0;
								whitestone192_anim.index_clignotement=0;					
								whitestone192_anim.sprite->move(whitestone192_anim.destination.x,whitestone192_anim.destination.y);																		
							}
							else
							{
								blackstone192_anim.destination.x=x2-3;				
								blackstone192_anim.destination.y=y2-4;
													
								blackstone192_anim.x=blackstone192_anim.destination.x;
								blackstone192_anim.y=blackstone192_anim.destination.y;
								
								blackstone192_anim.etat=animBlink;
								blackstone192_anim.step=0;
								blackstone192_anim.index_duree=0;
								blackstone192_anim.index_clignotement=0;					
								blackstone192_anim.sprite->move(blackstone192_anim.destination.x,blackstone192_anim.destination.y);											
							}
							
							checkmark_anim.etat=animWaiting;
							checkmark_anim.step=0;
							checkmark_anim.index_duree=0;
							checkmark_anim.index_clignotement=0;
              
              if (caret_a==19)
              {  checkmark_anim.destination.x=x2-3-20; }
              else
							{  checkmark_anim.destination.x=x2-3+12; }				
							checkmark_anim.destination.y=y2-4-4;										
							checkmark_anim.x=whitestone384_anim.destination.x;
							checkmark_anim.y=whitestone384_anim.destination.y;
							checkmark_anim.sprite->move(checkmark_anim.destination.x,checkmark_anim.destination.y);					
						}
					}
				}
			}
		}
		
		// --------------------
		// 1-7) Gestion du PAD
		// --------------------		
		
		if (((keysDown() & KEY_DOWN)) && (modeEcranHaut==modeStats)) // scroll down du texte demand
		{
			//iprintf("pec=%d nbv=%d siz=%d\n",page_en_cours,current_node->nb_volets_commentaires,current_node->commentaire.size());
		
			if (current_node->nb_volets_commentaires==0)	// pas de commentaire!
			{
				// non mais n'importe quoi lui alors, hein !
			}
			else if (page_en_cours==current_node->nb_volets_commentaires)
			{
				// on est dj  fond !!!
			}
			else
			{
				// on peut encore descendre... encore un tout petit peu... on y est presque !
				ScrollCommentairesDown();
			}
		
		}
		
		if (((keysDown() & KEY_UP)) && (modeEcranHaut==modeStats)) // scroll down du texte demand
		{
			//iprintf("pec=%d nbv=%d siz=%d\n",page_en_cours,current_node->nb_volets_commentaires,current_node->commentaire.size());
		
			if (current_node->nb_volets_commentaires==0)	// pas de commentaire!
			{
				// non mais n'importe quoi lui alors, hein !
			}
			else if (page_en_cours==1)
			{
				// on est dj  fond !!!
			}
			else
			{
				// on remonte...
				ScrollCommentairesUp();
			}
		
		}
  	
  	// Mode View...
  	//if (current_mode==modeView)
  	//{		
	  	if ((keysHeld() & KEY_RIGHT)||(keysDown() & KEY_RIGHT)||(keysUp() & KEY_RIGHT))	// gestion du pad droit
	  	{  	
				checkmark_spr->cache();	  						
				if (selection)
				{
					selection=false;
					if (NextToPlay==PierreBlanche)
					{				
						whitestone192_anim.etat=animOFF;
						whitestone384_anim.etat=animOFF;
						whitestone192_anim.sprite->cache();
						whitestone384_anim.sprite->cache();
					}
					else
					{				
						blackstone192_anim.etat=animOFF;
						blackstone384_anim.etat=animOFF;
						blackstone192_anim.sprite->cache();
						blackstone384_anim.sprite->cache();
					}
				}
				CMySprite::updateMainOAM();
  	
			if ((keysDown() & KEY_RIGHT))	// on avance d'un coup
			{
				appui_pad=0;
				sub_appui_pad=0;
								
				// on prend toujours la dernire variante...
				if (current_node->variantes.size()!=0)
				{
					//current_node=current_node->variantes[current_node->variantes.size()-1];
					current_node=current_node->variantes[0];
					
					if (SGF_tree.Move_forward(current_node)>0)	// captures
					{	// capture(s) !
						swiWaitForVBlank(); // on attend la prochaine synchro verticale	
						S_capture.play();
						
						if (NextToPlay==PierreBlanche)
							NextToPlay=PierreNoire;
						else
							NextToPlay=PierreBlanche;

					}
					else if (SGF_tree.Move_forward(current_node)==0)	// normal
					{	
						swiWaitForVBlank(); // on attend la prochaine synchro verticale				
						if (rand() % 2)	// 0 ou 1 !
							S_pierre1.play();
						else
							S_pierre2.play();
							
						if (NextToPlay==PierreBlanche)
							NextToPlay=PierreNoire;
						else
							NextToPlay=PierreBlanche;

					}
					else if (SGF_tree.Move_forward(current_node)<0)	// coup illgal,pass move,neutral move ou setup move!
					{
						//iprintf("Coup illgal!\n");
					}
				}		
				
			}
			else if ((keysHeld() & KEY_RIGHT))		// on est en KeysHeld... le pad est maintenu appuy
			{
				u8 nb;
		
				appui_pad++;				
				
				if (appui_pad==0)	// si on est au max, on y reste...
					appui_pad--;
				
				if (appui_pad > appui_pad_palier2)
				{
					// on avance de 5 coups
					nb=5;
					//iprintf("x5; ");
				}
				else
				if (appui_pad > appui_pad_palier1)
				{
					// on avance d'un coup, mais attention, ca s'enchane rapidos !
					nb=2;
					//iprintf("x1; ");
				}				
				else
				{
					nb=0;
					// on avance que tous les 'sub_appui_pad_max'!
					sub_appui_pad++;
					if (sub_appui_pad==sub_appui_pad_max)
					{
						swiWaitForVBlank(); // on attend la prochaine synchro verticale				
						if (rand() % 2)	// 0 ou 1 !
							S_pierre1.play();
						else
							S_pierre2.play();
						nb=1;
						sub_appui_pad=0;						
					}
				}
				u8 i;				
				
				for (i=1;i<=nb;i++)
				{
					// on prend toujours la dernire variante...
					if (current_node->variantes.size()!=0)
					{						
						//current_node=current_node->variantes[current_node->variantes.size()-1];
						current_node=current_node->variantes[0];
					
						SGF_tree.Move_forward(current_node);
						
						if (NextToPlay==PierreBlanche)
							NextToPlay=PierreNoire;
						else
							NextToPlay=PierreBlanche;
					}						
				}
			}
			else if ((keysUp() & KEY_RIGHT))
			{
				appui_pad=0;				
			}
			
			// MAJ de l'cran du haut				
			BoucleJeuMAJEcranHaut();
				  
	  	}
	  	else
		if ((keysHeld() & KEY_LEFT)||(keysDown() & KEY_LEFT)||(keysUp() & KEY_LEFT))	// gestion du pad gauche
	  	{  	 
				checkmark_spr->cache();	  
				if (selection)
				{
					selection=false;
					if (NextToPlay==PierreBlanche)
					{				
						whitestone192_anim.etat=animOFF;
						whitestone384_anim.etat=animOFF;
						whitestone192_anim.sprite->cache();
						whitestone384_anim.sprite->cache();
					}
					else
					{				
						blackstone192_anim.etat=animOFF;
						blackstone384_anim.etat=animOFF;
						blackstone192_anim.sprite->cache();
						blackstone384_anim.sprite->cache();
					}
				}
				CMySprite::updateMainOAM();
 	
			if ((keysDown() & KEY_LEFT))	// on recule d'un coup
			{
				appui_pad=0;
				sub_appui_pad=0;
				
				if (current_node!=SGF_tree.premiere_node)
				{
					SGF_tree.Move_backward(current_node);
					if (current_node->node_amont!=NULL)
						{
							current_node=current_node->node_amont;
							if (NextToPlay==PierreBlanche)
								NextToPlay=PierreNoire;
							else
								NextToPlay=PierreBlanche;
						}
					//swiWaitForVBlank(); // on attend la prochaine synchro verticale				
					//S_capture.play();
				}
				else
				{
					//iprintf("1 seule node !!!\n");
				}
			}
			else if ((keysHeld() & KEY_LEFT))		// on est en KeysHeld... le pad est maintenu appuy
			{
				u8 nb;
		
				appui_pad++;				
				
				if (appui_pad==0)	// si on est au max, on y reste...
					appui_pad--;
				
				if (appui_pad > appui_pad_palier2)
				{
					// on avance de 5 coups
					nb=5;
					//iprintf("x5; ");
				}
				else
				if (appui_pad > appui_pad_palier1)
				{
					// on avance d'un coup, mais attention, ca s'enchane rapidos !
					nb=2;
					//iprintf("x1; ");
				}				
				else
				{
					nb=0;
					// on avance que tous les 'sub_appui_pad_max'!
					sub_appui_pad++;
					if (sub_appui_pad==sub_appui_pad_max)
					{
						//swiWaitForVBlank(); // on attend la prochaine synchro verticale				
						//S_capture.play();
						nb=1;
						sub_appui_pad=0;						
					}
				}
				u8 i;				
				
				for (i=1;i<=nb;i++)
				{
					if (current_node!=SGF_tree.premiere_node)
					{
						SGF_tree.Move_backward(current_node);
						if (current_node->node_amont!=NULL)
							{
								current_node=current_node->node_amont;
							}
						if (NextToPlay==PierreBlanche)
							NextToPlay=PierreNoire;
						else
							NextToPlay=PierreBlanche;
					}	
				}
			}
			else if ((keysUp() & KEY_RIGHT))
			{
				appui_pad=0;				
			}
			
			// MAJ de l'cran du haut				
			BoucleJeuMAJEcranHaut();
				  
	  	}
/*	  	if (((keysUp() & KEY_B) || (keysHeld() & KEY_Y))	// Idem pour revenir en arrire...
	  		||(keysHeld() & KEY_LEFT))
	  	{	 	  		
	  		if (current_node!=SGF_tree.premiere_node)
	  		{
	  			SGF_tree.Move_backward(current_node);
			  	if (current_node->node_amont!=NULL)
					{
						current_node=current_node->node_amont;
					}
			}
				
			// MAJ de l'cran du haut				
			BoucleJeuMAJEcranHaut();		
	  	}
*/
	//}
	  
	  // ---------------------------
		// 2) Routines de scrolling 
		// ---------------------------

	  if (scroll)
		{
			if (dx<64)
				{ dx=64; }
			if (dy<0)
				{ dy=0; }
			if (dy>192)
				{ dy=192; }
			if (dx>193)
				{ dx=193; }
			
			if (selection && mode_zoom)
			{	
				// on scrolle => on annule la slection			
				whitestone384_anim.etat=animOFF;
				whitestone384_anim.step=0;
				whitestone384_anim.index_duree=0;
				whitestone384_anim.index_clignotement=0;	
				whitestone384_anim.sprite->cache();
				// MAJ des sprites
				CMySprite::updateMainOAM();	
				selection=false;
			}		
				
			swiWaitForVBlank(); // on attend la prochaine synchro verticale
			
			BG3_CX = dx << 8;   // on scrolle l'cran zoom
			BG3_CY = dy << 8;
			
			scroll=false;
		}			
		
		// ------------------------------------------------	
		// 3) moteur d'animation
		// ------------------------------------------------
		
		if (avanceAnimation(eject_anim))
		{
			// timeout nav1
			//iprintf("timeout: menu inactif\n");
			menu_actif=false;
		}
		/*
		avanceAnimation(nav1);
		avanceAnimation(nav2);
		avanceAnimation(nav3);
		avanceAnimation(nav4);
		avanceAnimation(nav5);
		avanceAnimation(nav6);			
		*/
		avanceAnimation(database_anim);
		//avanceAnimation(eject_anim); // dj effectu dans le test plus haut
		avanceAnimation(comment_anim);
		
		if (current_mode==modeRecord)
		{
			if (mode_zoom)
			{
				avanceAnimation(whitestone384_anim);
				avanceAnimation(blackstone384_anim);
			}
			else
			{
				avanceAnimation(whitestone192_anim);
				avanceAnimation(blackstone192_anim);
				avanceAnimation(checkmark_anim);
			}
		}
		
		// MAJ des sprites
		CMySprite::updateMainOAM();							
	}
	
	// Retour au menu principal...
	
	// cacher les sprites des animations de caret (le menu est dj planqu, lui...)
	
	whitestone384_anim.sprite->cache();
	blackstone384_anim.sprite->cache();
	whitestone192_anim.sprite->cache();
	blackstone192_anim.sprite->cache();
	
	// RAZ du SGF
	
	SGF_tree.RAZ();
	
	fadeToWhite(BOTH_SCREENS);
	
	//lcdSwap();	// l'cran principal passe "en bas" et le secondaire "en haut"	
	
	//SetBG3AsForeground();	// on remet le goban zoom en premier plan		
	
	delete pEcranCommentaires;
	delete pEcranStats;
}

void ScrollCommentairesDown()
{
	// on crit la page en cours sur la pageA
	// la suivante sur la B et on scrolle un coup...
	page_commentaire.Fill(254);
	
	arial12->WriteParagraph(current_node->commentaire[page_en_cours-1],&page_commentaire,4,4,254,126);
	arial12->WriteParagraph(current_node->commentaire[page_en_cours],&page_commentaire,4,4+126,254,126+126);
	
	// let's scroll !
	
	u16 scroll=0;
	
	while (scroll<=126)
	{
		swiWaitForVBlank();	
		page_commentaire.Copy2VRAMscroll256x126(pSUB_BG,scroll);
		scroll+=2;
	}
	
	page_en_cours++;
}

void ScrollCommentairesUp()
{
	page_commentaire.Fill(254);
	
	page_en_cours--;

	arial12->WriteParagraph(current_node->commentaire[page_en_cours-1],&page_commentaire,4,4,254,126);
	arial12->WriteParagraph(current_node->commentaire[page_en_cours],&page_commentaire,4,4+126,254,126+126);
	
	// let's scroll !
	
	u16 scroll=126;
	
	while (scroll>0)
	{
		swiWaitForVBlank();	
		page_commentaire.Copy2VRAMscroll256x126(pSUB_BG,scroll);
		scroll-=2;
	}		
	page_commentaire.Copy2VRAMscroll256x126(pSUB_BG,0);	
}

void BoucleJeuMAJEcranHaut()
{
	string texte;
			if (modeEcranHaut==modeStats)
			{
				// MAJ de l'cran stats
					
					// MAJ de la barre d'avancement
				//iprintf("total=%d\n",Nombre_total_coups);
					
					u8 avancement=div32(253*current_node->move_number, Nombre_total_coups);
					if (avancement > 253)
						avancement = 253;
						
					pEcranStats->DrawRect(1,129,avancement,5,253);	// orange
					if (avancement<253)
						pEcranStats->DrawRect(1+avancement,129,253-avancement,5,254); // blanc
				//iprintf("1\n");	
					// on efface
					pEcranStats->DrawRect(184,155+12,200-184,24,254);
					
					texte=to_string(Total_prisonniers_noirs);	
					arial12->BasicWrite((char*)texte.c_str(),pEcranStats,184,155+12);
					texte=to_string(Total_prisonniers_blancs);	
					arial12->BasicWrite((char*)texte.c_str(),pEcranStats,184,167+12);
				//iprintf("2\n");	
					pEcranStats->DrawRect(4,179,183-4,12,254);
					
					if (current_node->move_number>0 && current_node->move_number<=Nombre_total_coups && current_node->type_node==node_move)
					{
					//iprintf("3\n");
						texte=MyLocalization.move_number_text;	
						texte+=to_string(current_node->move_number);						
						texte+="/"+to_string(Nombre_total_coups);
						texte+=+" : "+current_node->node_name;	
					//iprintf("4\n");
					}
					else
					{
					//iprintf("5\n");
						texte=current_node->node_name;
					//iprintf("6\n");
					}
					//iprintf("7\n");
					//iprintf("texte=.%s.\n",texte.c_str());
					arial12->WriteParagraph((char*)texte.c_str(),pEcranStats,4,179,183,179+12);	
			
					// Les commentaires, maintenant...
					//iprintf("8\n");
					page_en_cours=1;	// quoiqu'il en soit, on RAZ le scrolling
					
					if (commentaire_avant)	// on fait une RAZ s'il y avait un commentaire avant...
							pEcranStats->DrawRect(0,0,256,126,254); // RAZ
					
					if (current_node->nb_volets_commentaires==0)	// pas de commentaires
						commentaire_avant=false;
					else
					{	
						//iprintf("9\n");
						commentaire_avant=true;
						//ClearConsole();
						//iprintf("comm=.%s.",current_node->commentaire[0].c_str());
						arial12->WriteParagraph(current_node->commentaire[0],pEcranStats,4,4,254,125);						
						//iprintf("10\n");
						
						if (current_node->nb_volets_commentaires>1)
						{
							fleche_bas.BitBltOnBitmap(pEcranStats,254-10,125-12);
						}						
					}

					// fin de la cration de l'cran stats					
					
					swiWaitForVBlank(); // on attend la prochaine synchro verticale
					pEcranStats->Copy2VRAM(pSUB_BG);
			}				
			else	// mode_goban...
			{
				// on copie le goban sur l'cran du haut...
				swiWaitForVBlank();
				dmaCopy(pMAIN_BG, pSUB_BG , 256*192);
			}	
}

void BoucleJeuMontreMenu()
{
/*
	nav1.etat=animIncoming;
	nav1.step=0;
	nav1.index_duree=0;
	nav1.index_clignotement=0;	
	nav1.x=(nav1.destination.x-nav1.steps*nav1.dx);
	nav1.y=(nav1.destination.y-nav1.steps*nav1.dy);
	nav1.sprite->move(nav1.x,nav1.y);
	
	nav2.etat=animIncoming;
	nav2.step=0;
	nav2.index_duree=0;
	nav2.index_clignotement=0;
	nav2.x=(nav2.destination.x-nav2.steps*nav2.dx);
	nav2.y=(nav2.destination.y-nav2.steps*nav2.dy);
	nav2.sprite->move(nav2.x,nav2.y);
	//iprintf("nav2x=%d nav2y=%d\n",nav2.x,nav2.y);
	
	nav3.etat=animIncoming;
	nav3.step=0;
	nav3.index_duree=0;
	nav3.index_clignotement=0;
	nav3.x=(nav3.destination.x-nav3.steps*nav3.dx);
	nav3.y=(nav3.destination.y-nav3.steps*nav3.dy);
	nav3.sprite->move(nav3.x,nav3.y);
	
	nav4.etat=animIncoming;
	nav4.step=0;
	nav4.index_duree=0;
	nav4.index_clignotement=0;
	nav4.x=(nav4.destination.x-nav4.steps*nav4.dx);
	nav4.y=(nav4.destination.y-nav4.steps*nav4.dy);
	nav4.sprite->move(nav4.x,nav4.y);
	
	nav5.etat=animIncoming;
	nav5.step=0;
	nav5.index_duree=0;
	nav5.index_clignotement=0;
	nav5.x=(nav5.destination.x-nav5.steps*nav5.dx);
	nav5.y=(nav5.destination.y-nav5.steps*nav5.dy);
	nav5.sprite->move(nav5.x,nav5.y);
	
	nav6.etat=animIncoming;
	nav6.step=0;
	nav6.index_duree=0;
	nav6.index_clignotement=0;
	nav6.x=(nav6.destination.x-nav6.steps*nav6.dx);
	nav6.y=(nav6.destination.y-nav6.steps*nav6.dy);
	nav6.sprite->move(nav6.x,nav6.y);
*/	
	database_anim.etat=animIncoming;
	database_anim.step=0;
	database_anim.index_duree=0;
	database_anim.index_clignotement=0;
	database_anim.x=(database_anim.destination.x-database_anim.steps*database_anim.dx);
	database_anim.y=(database_anim.destination.y-database_anim.steps*database_anim.dy);
	database_anim.sprite->move(database_anim.x,database_anim.y);
	
	comment_anim.etat=animIncoming;
	comment_anim.step=0;
	comment_anim.index_duree=0;
	comment_anim.index_clignotement=0;
	comment_anim.x=(comment_anim.destination.x-comment_anim.steps*comment_anim.dx);
	comment_anim.y=(comment_anim.destination.y-comment_anim.steps*comment_anim.dy);
	comment_anim.sprite->move(comment_anim.x,comment_anim.y);
	
	eject_anim.etat=animIncoming;
	eject_anim.step=0;
	eject_anim.index_duree=0;
	eject_anim.index_clignotement=0;
	eject_anim.x=(eject_anim.destination.x-eject_anim.steps*eject_anim.dx);
	eject_anim.y=(eject_anim.destination.y-eject_anim.steps*eject_anim.dy);
	eject_anim.sprite->move(eject_anim.x,eject_anim.y);
}

void BoucleJeuCacheMenu()
{
/*
	nav1.etat=animFleeing;
	nav1.step=0;
	nav1.index_duree=0;
	nav1.index_clignotement=0;	
	
	nav2.etat=animFleeing;
	nav2.step=0;
	nav2.index_duree=0;	
	nav2.index_clignotement=0;
	
	nav3.etat=animFleeing;
	nav3.step=0;
	nav3.index_duree=0;
	nav3.index_clignotement=0;
	
	nav4.etat=animFleeing;
	nav4.step=0;
	nav4.index_duree=0;
	nav4.index_clignotement=0;
	
	nav5.etat=animFleeing;
	nav5.step=0;
	nav5.index_duree=0;
	nav5.index_clignotement=0;
	
	nav6.etat=animFleeing;
	nav6.step=0;
	nav6.index_duree=0;
	nav6.index_clignotement=0;
*/	
	database_anim.etat=animFleeing;
	database_anim.step=0;
	database_anim.index_duree=0;
	database_anim.index_clignotement=0;
	
	comment_anim.etat=animFleeing;
	comment_anim.step=0;
	comment_anim.index_duree=0;
	comment_anim.index_clignotement=0;
	
	eject_anim.etat=animFleeing;
	eject_anim.step=0;
	eject_anim.index_duree=0;
	eject_anim.index_clignotement=0;
}

void Screen2Goban384(u16 X,u16 Y, u8 &a, u8 &b)
{
	// convertit les coordonnes du stylet (sx,sy) en mode zoom
	// en coordonnes goban (a,b) avec 1,1 en bas  gauche...
	
	//TODO: Refaire from scratch
	
	a=((X-78)/19)+1; //87
	b=((Y-12)/19)+1; //20
	b=20-b;	// car les y sont inverss !
	if (a==0)	// quand on "clique" vraiment au bord...
		a=1;
	if (b==0)
		b=1;
	//iprintf("a=%d b=%d\n",a,b);
}

void Goban2Screen384(u8 a, u8 b,u16 &X,u16 &Y)
{	
	//TODO: Refaire from scratch
	
	X=78+((a-1)*19);
	b=20-b;
	Y=12+((b-1)*19);
}

void Screen2Goban192(u16 X,u16 Y, u8 &a, u8 &b)
{	
	// convertit les coordonnes du stylet (sx,sy) en mode zoom
	// en coordonnes goban (a,b) avec 1,1 en bas  gauche...
	
	//TODO: Refaire from scratch
	
	a=(u8)((X-37)/9.5)+1;
	b=(u8)((Y-5)/9.5)+1;
	b=20-b;	// car les y sont inverss !
	if (a==0)	// quand on "clique" vraiment au bord...
		a=1;
	if (b==0)
		b=1;
	//iprintf("a=%d b=%d\n",a,b);
}

void Goban2Screen192(u8 a, u8 b,u16 &X,u16 &Y)
{	
	//TODO: Refaire from scratch
	
	X=(u16)(42+((a-1)*9.5));
	b=20-b;
	Y=(u16)(10+((b-1)*9.5));
}

bool SaveDialog()	// Cration/Sauvegarde du fichier SGF d'une partie
{

	// On commence par virer le menu
	
	menu_actif=false;
  
	BoucleJeuCacheMenu();
  
	while (1)	// on patiente gentillement que le menu se barre...
	{
 		//avanceAnimation(nav1);
		//avanceAnimation(nav2);
		//avanceAnimation(nav3);
		//avanceAnimation(nav4);
		//avanceAnimation(nav5);
		//avanceAnimation(nav6);	
		
		avanceAnimation(database_anim);
		avanceAnimation(comment_anim);
		avanceAnimation(eject_anim);
		
		// MAJ des sprites
		CMySprite::updateMainOAM();		
		swiWaitForVBlank();	
		
		if (eject_anim.etat==animOFF)
			break;
	}
	
		//fadeToWhite(MAIN_SCREEN,0);

	CMyBitmap* ptmp=new CMyBitmap(256,192);		// va servir d'ecran virtuel pour crire
		
	dmaCopy(pMAIN_BG, ptmp->p_data , 256*192);	// Sauvegarde l'cran principal BG2 sur notre cran virtuel temporaire
	// Remarque : on utilise pas BackupMainBG2() car keyboard.edit l'utilise dj !

	CMyBitmap* pHaut=new CMyBitmap(256,192);		// va servir d'ecran virtuel pour crire		
	CMyBitmap* pBas=new CMyBitmap(256,192);		// idem	
		
	// Affichage & Saisie des infos relatives au nouvel SGF
	
	pHaut->Fill(254);
	pBas->Fill(254);	

	// cran du haut	

	arialb22->BasicWrite((char*)MyLocalization.save_game_title.c_str(),pHaut,8,4);	
	pHaut->DrawHorizLine(8,30,240,253);		
	dragon1.Copy2Bitmap(pHaut,256-112,192-112);
		
	arial12->Write((char*)MyLocalization.save_game_confirm.c_str(),pBas,32,32);
	
	SGF_tree.filename=MyLocalization.save_game_default_filename;
	
	arial12->WriteParagraph(SGF_tree.filename,pBas,32,8,250,20);
	pBas->DrawFrameRect(31-4,7,254-32+2,20-8+2,253);
		
	// Affiche les sprites de validation/annulation
	
	checkmark.Copy2Bitmap(pBas,180,35);
	x.Copy2Bitmap(pBas,200,35);
	
	pHaut->Copy2VRAM(pSUB_BG);
	pBas->Copy2VRAM(pMAIN_BG);
	
	//fadeFromWhite(MAIN_SCREEN,0);
	
	swiWaitForVBlank();
	
	u8 styletx;
	u8 stylety;
	bool res;
	
	while(1)
	{
		scanKeys();
		if (keysHeld() & KEY_TOUCH)
		{
			styletx=IPC->touchXpx;
			stylety=IPC->touchYpx;	
			
			if ((styletx>=180 && styletx<=196)&&(stylety>=35 && stylety<=51))
			{
				res=true;
				S_valid.play();
				break;
			}
			else
			if ((styletx>=200 && styletx<=216)&&(stylety>=35 && stylety<=51))
			{
				res=false;
				S_valid.play();
				break;
			}			
			else
			// sur un des champs de saisie ?
			if (IsHit(styletx,stylety,31-4,7,254-32+2,20-8+2))	// nom du fichier		
			{	
				keyboard.Edit("Nom du fichier",SGF_tree.filename);
					
				pBas->DrawRect(31-4,7,254-32+2,20-8+2,254);
				arial12->WriteParagraph(SGF_tree.filename,pBas,32,8,250,20);
				pBas->DrawFrameRect(31-4,7,254-32+2,20-8+2,253);
				pBas->Copy2VRAM(pMAIN_BG);
					
				fadeFromWhite(BOTH_SCREENS);					
			}
		}	
	}	
	
	sleepCycles(30);
	
	if (res)
	{
		// Sauvegarde effective...
		
		arial12->WriteParagraph("Patientez, s'il vous plat...\n(ne pas teindre la console)",pHaut,8,60,248,84);		
		
		// TODO : infos & barre d'avancement en dessous des noms / icones de confirmation
		
		// Etape 1 : Cration du contenu SGF
		
		string SGF_data="";
		
		Create_SGF_data(SGF_data);
		
		//iprintf("%s",SGF_data.c_str());
		
		// Etape 2 : Sauvegarde physique
		
		// ouverture du fichier en bas niveau et sauvegarde caractre par caractre...
		
		string filename="/SGF/"+SGF_tree.filename+".sgf";
		
		#ifdef EMU_VERSION	
			iprintf("fichier=%s\n",filename.c_str());
			WaitForTouch();
			iprintf("contenu=%s\n",SGF_data.c_str());
			WaitForTouch();
			for(int t=0;t<=30;t++)	// ~clearscr()
				iprintf("\n");
		#else
			FILE* outputfile = fopen (filename.c_str(), "wb");

			for(int t=0;t<(int)SGF_data.length();t++)
				fputc(SGF_data.at(t),outputfile);

			fclose(outputfile);
					    
		#endif	
	}
	
	// restore game's Main_BG
	ptmp->Copy2VRAM(pMAIN_BG);	
	
	BoucleJeuMAJEcranHaut();
	
	delete pHaut;
	delete pBas;
	delete ptmp;

	sleepCycles(30);

	return res;

}

void Create_SGF_data(string &res)
{
	res="(;SZ[19]AP[DSgf - http://sourceforge.net/projects/dsgf]GN[nom de la partie]";
	res+="PB["+SGF_tree.player_black+"]PW["+SGF_tree.player_white+"]KM["+SGF_tree.komi+"]HA["+SGF_tree.handicap+"]";
	
	// Sauvegarde du commentaire...
	string commentaire;
	
	if (SGF_tree.premiere_node->commentaire.size()>0)
	{
		//iprintf("commentaire 1ere node\n");
		commentaire=SGF_tree.premiere_node->commentaire.at(0);
		res+="C["+commentaire+"]";
	}
	
	// Mise en place du handicap...
	// si handicap => AB[pp][dp][pd] avec "PL[W]" pour prciser que c'est  blanc de jouer...
	if (SGF_tree.handicap!="0" && SGF_tree.handicap!="1")
	{
		// on prend le setup_goban et pour chaque pierre, on fait des AB[]...
		
		res+="AB";
		
		// on ajoute chaque pierre de setup...
		
		int i,j;
		for (i=1; i<=19;i++)
			for (j=1; j<=19;j++)
			{
				if (SGF_tree.premiere_node->setup_goban->intersection[i][j]!=AucunePierre)
				{
					res+="["+gobanx2letterWithI(i)+gobanx2letterWithI(20-j)+"]";
				}
			}
		
		res+="PL[W]";	// white's turn to play (it's black'turn by default)...
	}
	// fin de l'entte du SGF
	
	res+="\n";
	
	// Maintenant, droule chaque coup...
	
	// le premier a droit au "move number"...
	
	Node_type*	node=SGF_tree.premiere_node;
	
	while (node->variantes.size()>0)
	{
		node=node->variantes.at(0);
		
		res+="\n;";
		
		if (node->move_couleur==PierreBlanche)
			res+="W";
		else
			res+="B";
		
		res+="["+gobanx2letterWithI(node->move_coord.x)+gobanx2letterWithI(20-node->move_coord.y)+"]";
		
		if (node->move_number==1)
			res+="MN[1]";

		if (node->commentaire.size()>0)
		{
			//iprintf("commentaire 1ere node\n");
			commentaire=node->commentaire.at(0);
			res+="C["+commentaire+"]";
		}
	}
	
	// fin du SGF
	
	res+="\n)";
}

bool MessageMenu(char* mess)	// Demande confirmation lors de l'utilisation d'une commande du menu
{
	
	// On commence par virer le menu
	
	menu_actif=false;
  
  BoucleJeuCacheMenu();
  
  while (1)	// on patiente gentillement que le menu se barre...
  {
 		/*avanceAnimation(nav1);
		avanceAnimation(nav2);
		avanceAnimation(nav3);
		avanceAnimation(nav4);
		avanceAnimation(nav5);
		avanceAnimation(nav6);	*/
		
		avanceAnimation(database_anim);
		avanceAnimation(comment_anim);
		avanceAnimation(eject_anim);
		
		// MAJ des sprites
		CMySprite::updateMainOAM();		
		swiWaitForVBlank();	
		
		if (eject_anim.etat==animOFF)
			break;
	}
	
	//fadeToWhite(MAIN_SCREEN,0);

	BackupMainBG2();	// sauvegarde de l'cran MAIN/BG2 en VRAM H et I (32Ko+16Ko)
	
	//swiWaitForVBlank();
	
	CMyBitmap* ptmp=new CMyBitmap(256,192);		// va servir d'ecran virtuel pour crire
		
	dmaCopy(pMAIN_BG, ptmp->p_data , 256*192);	// Copie l'cran principal BG2 sur notre cran virtuel temporaire
	
	//swiWaitForVBlank();

	// on crit le message...
	
	arial12->Write(mess,ptmp,32,32);
	
	//swiWaitForVBlank();
	
	// Affiche les sprites de validation/annulation
	
	checkmark.Copy2Bitmap(ptmp,180,35);
	x.Copy2Bitmap(ptmp,200,35);

	ptmp->Copy2VRAM(pMAIN_BG);	
	
	//fadeFromWhite(MAIN_SCREEN,0);
	
	swiWaitForVBlank();
	
	u8 styletx;
	u8 stylety;
	bool res;
	
	while(1)
	{
		scanKeys();
		if (keysHeld() & KEY_TOUCH)
		{
			styletx=IPC->touchXpx;
			stylety=IPC->touchYpx;	
			
			if ((styletx>=180 && styletx<=196)&&(stylety>=35 && stylety<=51))
			{
				res=true;
				S_pierre1.play();
				break;
			}
			if ((styletx>=200 && styletx<=216)&&(stylety>=35 && stylety<=51))
			{
				res=false;
				S_capture.play();
				break;
			}			
		}		
	}	
	
	//fadeToWhite(MAIN_SCREEN,0);
	
	RestoreMainBG2();
	
	//fadeFromWhite(MAIN_SCREEN,0);
			
	delete ptmp;
	
	sleepCycles(30); // sinon la slection du stylet sera prise en compte sur le goban en cas d'annulation
	
	return res;
	
}

void BackupMainBG2()
{
	dmaCopy(pMAIN_BG, VRAM_H , 32768);
	dmaCopy(pMAIN_BG+(16384), VRAM_I , 16384);
}

void RestoreMainBG2()
{
	dmaCopy( VRAM_H , pMAIN_BG, 32768);
	dmaCopy( VRAM_I, pMAIN_BG+(16384), 16384);
}

void BackupSubBG2()
{
	dmaCopy(pSUB_BG, VRAM_H , 32768);
	dmaCopy(pSUB_BG+(16384), VRAM_I , 16384);
}

void RestoreSubBG2()
{
	dmaCopy( VRAM_H , pSUB_BG, 32768);
	dmaCopy( VRAM_I, pSUB_BG+(16384), 16384);
}

void SetBG2AsForeground()
{
	BG2_CR = BG_BMP8_256x256 | BG_BMP_BASE(12) | BG_PRIORITY(1); 
	MAIN_BG2_is_in_front=true;
}

void SetBG3AsForeground()
{
	BG2_CR = BG_BMP8_256x256 | BG_BMP_BASE(12) | BG_PRIORITY(3);
	MAIN_BG2_is_in_front=false;
}


 	  	 
