//
// main.h
// ------
// 
// DSgf main header
//
// DSgf : http://sourceforge.net/projects/dsgf
//

#ifndef MYMAIN_H
#define MYMAIN_H

//------------------------------------------

// my last minute defines

// dernire version
#define RELEASE_STRING "alpha 2.1"

// si dcomment, on bypasse la libfat pour pouvoir tourner sous mulateur
// commenter pour compiler pour hardware NDS

//#define EMU_VERSION

// dcommenter pour skipper le splashscreen

//#define NO_SPLASH

//------------------------------------------

/* system includes */
#include <nds.h>
#include <vector>
#include <string>

using namespace std ;					// vite d'avoir  mettre std::string  chaque fois...

// inclusion des donnes binaires

//make file automaticaly makes a header file for access
//to the binary data in any file ending in .bin that is in
//the data folder.  It also links in that data to your project

// localization
#include "localization_raw.h"

// Sprite files : 
#include "black_stone_384_type2_Sprite_bin.h"
#include "white_stone_384_type2_Sprite_bin.h"
#include "black_stone_192_type2_Sprite_bin.h"
#include "white_stone_192_type2_Sprite_bin.h"
#include "spr_database_Sprite_bin.h"
#include "spr_diskette_Sprite_bin.h"
#include "spr_eject_Sprite_bin.h"
#include "spr_fastforward_Sprite_bin.h"
#include "spr_play_Sprite_bin.h"
#include "spr_quote_Sprite_bin.h"
#include "spr_rewind_Sprite_bin.h"
#include "spr_skipback_Sprite_bin.h"
#include "spr_skip_Sprite_bin.h"
#include "spr_trash_Sprite_bin.h"
#include "spr_user_Sprite_bin.h"
#include "spr_playback_Sprite_bin.h"
#include "spr_checkmark_Sprite_bin.h"

// Background files : 
#include "lords_Bitmap_bin.h"
#include "CC_Bitmap_bin.h"
#include "menu_haut_Bitmap_bin.h"
#include "goban_256x192_zinger3_Bitmap_bin.h"
#include "goban_512x384_zinger3_Bitmap_bin.h"

// Other bitmap files
#include "black_stone_384_type2_Bitmap_bin.h"
#include "white_stone_384_type2_Bitmap_bin.h"
#include "black_stone_192_type2_Bitmap_bin.h"
#include "white_stone_192_type2_Bitmap_bin.h"
#include "caution_Bitmap_bin.h"
#include "checkmark_Bitmap_bin.h"
#include "clipboard_Bitmap_bin.h"
#include "database_Bitmap_bin.h"
#include "user_Bitmap_bin.h"
#include "x_Bitmap_bin.h"
#include "dragon1_Bitmap_bin.h"
#include "dragon2_Bitmap_bin.h"
#include "cclogo_Bitmap_bin.h"
#include "fleche_haut_Bitmap_bin.h"
#include "fleche_bas_Bitmap_bin.h"
#include "decor_Bitmap_bin.h"
// pour le clavier perso
#include "DSGF_keyboard_qwerty_lowercase_Bitmap_bin.h"
#include "DSGF_keyboard_qwerty_shift_Bitmap_bin.h"
#include "DSGF_keyboard_qwerty_caps_Bitmap_bin.h"
// ecrans d'aide
#include "helpA_Bitmap_bin.h"
#include "helpB_Bitmap_bin.h"
// flags pour langage selection
#include "flagFRA_Bitmap_bin.h"
#include "flagENG_Bitmap_bin.h"

// Palette files : 
#include "sprites_Pal_bin.h"
#include "lords_Pal_bin.h"
#include "CC_Pal_bin.h"
#include "master_Pal_bin.h"
#include "help_Pal_bin.h"

// Fichiers de polices de caractres issus de Bitmap Font Generator																					

	// fichier de description texte renomm en .raw dans /data
#include "arial12_raw.h"
#include "arialb22_raw.h"

	// et bitmaps correspondants
#include "arial12_Bitmap_bin.h"
#include "arialb22_Bitmap_bin.h"

// ajouter l'include pour preset et presentb !

// sons

#include "DSgf_intro_raw.h"
#include "tulin_raw.h"
#include "ting_raw.h"
#include "tchinglong_raw.h"
#include "pierre3_raw.h"
#include "pierre5_raw.h"
#include "capture4_raw.h"
#include "typewriter1_raw.h"
#include "typewriter2_raw.h"

#ifdef EMU_VERSION	

  // fichiers ajout  la ROM pour faciliter le debug (sur emulateur)
  #include "proverbes_txt_raw.h"	// le fichier des proverbes
  
  // quelques SGF de debug puor la version EMU
  #include "debug_sgf_raw.h"
  #include "debug_sgf2_raw.h"
  #include "debug_sgf3_raw.h"
  #include "debug_sgf4_raw.h"
  #include "firzen_sgf_raw.h"
  #include "jules_sgf_raw.h"

#endif

//--------------------------------------------------------------------

#define MAIN_SCREEN		0
#define SUB_SCREEN		1
#define BOTH_SCREENS 	2

#define REG_BRIGHT 0x0400006C  // Brightness
#define _REG16 *(volatile u16 *)

//---------------------------------------------------------------------

// Dclarations de types gnraux

enum MenuMode
{
	modeView,modeRecord,modeOptions,modeAbout
};

enum EcranHautMode
{
	modeStats,modeGoban
};

// Pr-dclarations des sous-fonctions de la boucle principale

void InitialisationHardware();
void SplashScreens();
void AskForLangage();
void MenuPrincipal();
void TellAbout();
void ShowOptions();
bool SelectAndLoadSGF();
bool SaisieInfosSGF();
void BoucleJeu();

void BoucleJeuMontreMenu();
void BoucleJeuCacheMenu();

void Screen2Goban384(u16 X,u16 Y, u8 &a, u8 &b);
void Goban2Screen384(u8 a, u8 b,u16 &X,u16 &Y);

void Screen2Goban192(u16 X,u16 Y, u8 &a, u8 &b);
void Goban2Screen192(u8 a, u8 b,u16 &X,u16 &Y);

bool MessageMenu(char* mess);

bool SaveDialog();

void BackupMainBG2();
void RestoreMainBG2();

void BackupSubBG2();
void RestoreSubBG2();

void SetBG2AsForeground();
void SetBG3AsForeground();

void BoucleJeuMAJEcranHaut();

void ScrollCommentairesDown();
void ScrollCommentairesUp();

void Create_SGF_data(string &res);

#endif /* MYMAIN_H */

