//
// MyFont.cpp
// ----------
// 
// Pour exploiter une police unicode gnre avec Bitmap Font Generator...
//
// DSgf : http://sourceforge.net/projects/dsgf
//

// TODO : rendre les fonctions UTC-8 compliant !

// TODO : mettre les caractres ASCII (id 0  255) en accs direct!
//				+ prendre en charge l'unicode

#define _UNICODE	// Tell C we're using Unicode, notice the _

/* system includes */
#include <nds.h>
#include <nds/arm9/console.h> // module console	pour iprintf (debug)
#include <stdio.h>						// fonctions standarts d'I/O (idem:debug/console)
#include <string>							// ha... les string en C++... c'est quand mme autre chose qu'en C, hein !
#include <sstream>						// string streams... marvelous!

using namespace std ;					// vite d'avoir  mettre std::string  chaque fois...

/* my includes */
#include "main.h"
#include "MyBitmap.h"
#include "MyTools.h"
#include "MySprite.h"
#include "MyFont.h"

CMyFont::CMyFont(const u8* pdescr,const u8* pbitmap)
{
	m_background_color=254;
	m_frame_color=255;
	m_GlyphWidthAverage=0;
	
	u32 totalglyphwidth=0;
	
	//iprintf("creation de la font\n");
	
	string* pheader=new string((const char*)pdescr);	// on convertit le binaire pdescr (un fichier .txt renomm en raw dans /data) en string
	stringstream HeaderStream;
	
	HeaderStream.str(*pheader);
	
	delete pheader;
	
	// On a maintenant un stream sur le buffer...
	
	string Line;
	string Read, Key, Value;
	size_t i;
	//u16	index_glyph=0;
	//u16	index_kerning=0;
	
	GlyphDesc	desc;
	KernCouple kernc;
	
	s16 kern_amount;
		
	while (!HeaderStream.eof())
	{
		stringstream LineStream;
		getline( HeaderStream, Line );
		LineStream << Line;

		//read the line's type
		LineStream >> Read;
		if( Read == "common" )
		{
			//this holds common data
			while( !LineStream.eof() )
			{
				stringstream Converter;
				LineStream >> Read;
				i = Read.find( '=' );
				Key = Read.substr( 0, i );
				Value = Read.substr( i + 1 );

				//assign the correct value
				Converter << Value;
				if( Key == "lineHeight" )
					Converter >> m_LineHeight;
				else if( Key == "base" )
					Converter >> m_Base;
				else if( Key == "scaleW" )
					Converter >> m_Width;
				else if( Key == "scaleH" )
					Converter >> m_Height;
				else if( Key == "pages" )
					Converter >> m_Pages;					
			}									
		}
		else if( Read == "chars" )
		{
			// nombre de Glyphs/caractres (ca fait bien, 'Glyph', avec un 'G' majuscule ! Ca fait tout de suite classe!)
			while( !LineStream.eof() )
			{
				stringstream Converter;
				LineStream >> Read;
				i = Read.find( '=' );
				Key = Read.substr( 0, i );
				Value = Read.substr( i + 1 );

				//assign the correct value
				Converter << Value;
				if( Key == "count" )
					Converter >> m_nbGlyph;				
			}
			//iprintf("%d glyphs\n",m_nbGlyph);
			
			// on dimensionne la liste de description des Glyphs
			//m_pListeGlyph = new GlyphDesc[m_nbGlyph];			
		}
				
		else if( Read == "char" )
		{			
			while( !LineStream.eof() )
			{
				std::stringstream Converter;
				LineStream >> Read;
				i = Read.find( '=' );
				Key = Read.substr( 0, i );
				Value = Read.substr( i + 1 );

				//assign the correct value
				Converter << Value;
				if( Key == "id" )
					Converter >> desc.m_id;
				else if( Key == "x" )
					Converter >> desc.m_x;
				else if( Key == "y" )
					Converter >> desc.m_y;
				else if( Key == "width" )
					Converter >> desc.m_width;
				else if( Key == "height" )
					Converter >> desc.m_height;
				else if( Key == "xoffset" )
					Converter >> desc.m_xoffset;
				else if( Key == "yoffset" )
					Converter >> desc.m_yoffset;
				else if( Key == "xadvance" )
					Converter >> desc.m_xadvance;
				//else if( Key == "page" )
					//Converter >> GlyphDesc[index].m_page;
			}			
			//iprintf("id=%ld x=%d y=%d\n",m_pListeGlyph[index_glyph].m_id,m_pListeGlyph[index_glyph].m_x,m_pListeGlyph[index_glyph].m_y);
			totalglyphwidth+=(desc.m_xoffset+desc.m_width);	// sert pour calculer la largeur moyenne des glyph
			m_MapGlyph[desc.m_id]=desc;
		}
/*		else if( Read == "kernings" )
		{
			// nombre de Glyphs
			while( !LineStream.eof() )
			{
				stringstream Converter;
				LineStream >> Read;
				i = Read.find( '=' );
				Key = Read.substr( 0, i );
				Value = Read.substr( i + 1 );

				//assign the correct value
				Converter << Value;
				if( Key == "count" )
					Converter >> m_nbKerning;				
			}
			//iprintf("%d kernings\n",m_nbKerning);
			
			// on dimensionne la liste de description des Kernings
			//m_pListeKerning = new KernDesc[m_nbKerning];
		}*/				
		else if( Read == "kerning" )
		{			
			while( !LineStream.eof() )
			{
				std::stringstream Converter;
				LineStream >> Read;
				i = Read.find( '=' );
				Key = Read.substr( 0, i );
				Value = Read.substr( i + 1 );

				//assign the correct value
				Converter << Value;
				if( Key == "first" )
					Converter >> kernc.first;
				else if( Key == "second" )
					Converter >> kernc.second;
				else if( Key == "amount" )
					Converter >> kern_amount;
			}
			//if (m_pListeKerning[index_kerning].m_amount==-1)
				//iprintf("amount=%d\n",m_pListeKerning[index_kerning].m_amount);			
			//index_kerning++;
			
			m_MapKerning[kernc]=kern_amount;
			
		}
	}
	//iprintf("header lu.\n");
	
	m_pbitmapfont=new CMyBitmap(pbitmap,m_Width,m_Height);	
	
	// Normalement, le premier point en haut  gauche est de couleur blanche, donc transparente pour nous !
	
	m_transp_color=m_pbitmapfont->GetPixel(0,0);
	
	// largeur moyenne de glyph
	
	m_GlyphWidthAverage=totalglyphwidth/m_nbGlyph;
}

CMyFont::~CMyFont()
{
	delete m_pbitmapfont;
}

void CMyFont::BasicWrite(char* pstr,CMyBitmap* pbitmapdest,u16 posx, u16 posy)
{
	u16 c_x=posx;
	u16 c_y=posy;
	
	u16 xadvance;
	s16 kerning;
	
	// ATTENTION ! Ce code n'est pas compatible UTF8!!!
	// JUSTE ASCII !!!  => revoir la dcoupe et la conversion vers l'id du glyph...
	
	char lettre_precedente=0;
	
	char lettre=(*pstr++);
	while (lettre!='\0')
	{
		
		// kerning ventuel...
		if (lettre_precedente!=0)
		{
			kerning=GetKerning(lettre_precedente,lettre);
			c_x+=kerning;
		}
		
		xadvance=DrawGlyphOnBitmap(lettre,pbitmapdest,c_x,c_y);
		
		c_x+=xadvance;
		
		lettre_precedente=lettre;				
		lettre=(*pstr++);
	}	
}

MyPoint CMyFont::Write(char* pstr,CMyBitmap* pbitmapdest,MyPoint point,u8 marge)
{
	return Write(pstr,pbitmapdest,point.x,point.y,marge);
}

MyPoint CMyFont::WriteCentered(char* pstr,CMyBitmap* pbitmapdest,MyPoint &point,u8 marge)
{
	return WriteCentered(pstr,pbitmapdest,point.x,point.y,marge);
}

MyPoint CMyFont::WriteIcon(char* pstr,CMyBitmap* picon,CMyBitmap* pbitmapdest,MyPoint point,u8 marge)
{
	return WriteIcon(pstr,picon,pbitmapdest,point.x,point.y,marge);
}

MyPoint CMyFont::Write(char* pstr,CMyBitmap* pbitmapdest,u16 posx, u16 posy,u8 marge)
{
	// On va calculer les dimensions du texte pour tracer un rectangle avec d'crire...
	// on retourne le point bas/droite du rectangle...
	
	// ! pas de test de dpassement ! ne pas sortir de l'cran ou utiliser la version "AdvWrite" !
	
	// TODO : A recrire from scratch !!!
	// Code pourri !!!
	
	u8 marge_x=marge;
	u8 marge_y=marge;
	
	MyPoint res;

	res.y=posy+m_LineHeight+marge_y;
	
	//iprintf("lineheight=%d\n",m_LineHeight);

	u16 c_x,c_y;
	
	c_x=posx+marge_x;
	c_y=posy+marge_y;
	
	u16 xadvance;
	s16 kerning;
	
	// ATTENTION ! Ce code n'est pas compatible UTF8!!!
	// JUSTE ASCII !!!  => revoir la dcoupe et la conversion vers l'id du glyph...
	
	char lettre_precedente=0;
	
	char* pstrbackup=pstr;
	
	char lettre=(*pstr++);
	while (lettre!='\0')
	{
		
		// kerning ventuel...
		if (lettre_precedente!=0)
		{
			kerning=GetKerning(lettre_precedente,lettre);
			c_x+=kerning;
			//iprintf("kerning: %d;",kerning);
		}
				
		xadvance=GetGlyphAdvance(lettre);
		
		c_x+=xadvance;
		//iprintf("lettre=%c xadvance:%d.",lettre,xadvance);
		
		lettre_precedente=lettre;				
		lettre=(*pstr++);
	}
	// c_x contient la valeur finale...
	res.x=c_x;
	
	if (m_background_color!=0)
		pbitmapdest->DrawRect(posx,posy,(res.x-posx)+marge_x,(res.y-posy)+marge_y,m_background_color);
	//if (m_frame_color!=0)
		//pbitmapdest->DrawFrameRect(posx,posy,(res.x-posx)+marge_x,(res.y-posy)+marge_y,m_frame_color);				
	BasicWrite(pstrbackup,pbitmapdest,posx+marge_x,posy+marge_y);
	return(res);
};

MyPoint CMyFont::WriteCentered(char* pstr,CMyBitmap* pbitmapdest,u16 posx, u16 posy,u8 marge)
{
	// Ecriture basique, mais centre autour de posx...
	
	// on retourne le point bas/droite du rectangle...
	
	// ! pas de test de dpassement ! ne pas sortir de l'cran ou utiliser la version "AdvWrite" !
	
	// TODO : A recrire from scratch !!!
	// Code pourri !!!
	
	u8 marge_x=marge;
	u8 marge_y=marge;
	
	MyPoint res;

	res.y=posy+m_LineHeight+marge_y;
	
	//iprintf("lineheight=%d\n",m_LineHeight);

	u16 c_x,c_y;
	
	c_x=posx+marge_x;
	c_y=posy+marge_y;
	
	u16 xadvance;
	s16 kerning;
	
	// ATTENTION ! Ce code n'est pas compatible UTF8!!!
	// JUSTE ASCII !!!  => revoir la dcoupe et la conversion vers l'id du glyph...
	
	char lettre_precedente=0;
	
	char* pstrbackup=pstr;
	
	char lettre=(*pstr++);
	while (lettre!='\0')
	{
		
		// kerning ventuel...
		if (lettre_precedente!=0)
		{
			kerning=GetKerning(lettre_precedente,lettre);
			c_x+=kerning;
			//iprintf("kerning: %d;",kerning);
		}
				
		xadvance=GetGlyphAdvance(lettre);
		
		c_x+=xadvance;
		//iprintf("lettre=%c xadvance:%d.",lettre,xadvance);
		
		lettre_precedente=lettre;				
		lettre=(*pstr++);
	}
	// c_x contient la valeur finale...
	res.x=c_x;
	
	if (m_background_color!=0)
		pbitmapdest->DrawRect(posx-((res.x-posx)+marge_x)/2,posy,(res.x-posx)+marge_x,(res.y-posy)+marge_y,m_background_color);
	if (m_frame_color!=0)
		pbitmapdest->DrawFrameRect(posx-((res.x-posx)+marge_x)/2,posy,(res.x-posx)+marge_x,(res.y-posy)+marge_y,m_frame_color);				
	BasicWrite(pstrbackup,pbitmapdest,posx-((res.x-posx)+marge_x)/2+marge_x,posy+marge_y);
		
	u16 x=posx-((res.x-posx)+marge_x)/2;
	u16 dx=(res.x-posx)+marge_x;
	posx=x;
	res.x=x+dx;
	return(res);
};

MyPoint CMyFont::WriteIcon(char* pstr,CMyBitmap* picon,CMyBitmap* pbitmapdest,u16 posx, u16 posy,u8 marge)
{
	// Idem Write mais avec l'affichage d'une icone!	
	// TODO : A recrire from scratch !!!
	// Code pourri !!!
	
	u8 marge_x=marge;
	u8 marge_y=marge;
	
	MyPoint res;

	res.y=posy+m_LineHeight+marge_y;
	
	//iprintf("lineheight=%d\n",m_LineHeight);

	u16 c_x,c_y;
	
	c_x=posx+marge_x+picon->size_x+marge_x;
	c_y=posy+marge_y;
	
	u16 xadvance;
	s16 kerning;
	
	// ATTENTION ! Ce code n'est pas compatible UTF8!!!
	// JUSTE ASCII !!!  => revoir la dcoupe et la conversion vers l'id du glyph...
	
	char lettre_precedente=0;
	
	char* pstrbackup=pstr;
	
	char lettre=(*pstr++);
	while (lettre!='\0')
	{
		
		// kerning ventuel...
		if (lettre_precedente!=0)
		{
			kerning=GetKerning(lettre_precedente,lettre);
			c_x+=kerning;
			//iprintf("kerning: %d;",kerning);
		}
				
		xadvance=GetGlyphAdvance(lettre);
		
		c_x+=xadvance;
		//iprintf("lettre=%c xadvance:%d.",lettre,xadvance);
		
		lettre_precedente=lettre;				
		lettre=(*pstr++);
	}
	// c_x contient la valeur finale...
	res.x=c_x;
	
	if (m_background_color!=0)
		pbitmapdest->DrawRect(posx,posy,(res.x-posx)+2*marge_x,(res.y-posy)+marge_y,m_background_color);
	if (m_frame_color!=0)
		pbitmapdest->DrawFrameRect(posx,posy,(res.x-posx)+2*marge_x,(res.y-posy)+marge_y,m_frame_color);
								
	BasicWrite(pstrbackup,pbitmapdest,posx+2*marge_x+marge_x/2+picon->size_x,posy+marge_y);
	
	picon->Copy2Bitmap(pbitmapdest,posx+marge_x+marge_x/2,posy+(res.y+marge_y-posy)/2-8);
	
	res.y+=marge_y;
	
	return(res);
};

void CMyFont::SetBackgroundColor(u8 color_index)
{
	m_background_color=color_index;
}

void CMyFont::SetFrameColor(u8 color_index)
{
	m_frame_color=color_index;
}

u16 CMyFont::DrawGlyphOnBitmap(u32 glyphid,CMyBitmap* pbitmapdest,u16 posx, u16 posy)
{
	// On va retrouver les infos concernant le caractre  afficher
	// et le copier sur pbitmapdest
	// On va retrouver les infos concernant le caractre  afficher
	// et le copier sur pbitmapdest
	// remarque : on copie toutes les couleurs, sauf celle de fond (m_transp_color)
																					
	// Il faut retrouver les infos du glyph...
	
	// TODO : pour les caractre dont l'id > 255 (unicode et non ASCII), faire une recherche optimise, au moins dichotomique !
	// TODO : pour ceux dont l'id <255 (ASCII), faire un tableau d'accs direct pour gagner du temps !
	
	GlyphDesc desc;
	
	desc=m_MapGlyph[glyphid];	// TODO: traiter le cas o glyphid est inconnu!
				
	// Ok on a les infos...
	// on fait la copie!
	
	int x,y;
	u8 color;
	for (x=0;x<desc.m_width;x++)
		for (y=0;y<desc.m_height;y++)
		{
			// est-ce qu'il y a un pixel noir  (x,y) ?
			color=m_pbitmapfont->GetPixel((x+desc.m_x),(y+desc.m_y));
			//iprintf("color=%d;",(u16) color);
			if (color!=m_transp_color)	// S'il n'est pas blanc...
				pbitmapdest->SetPixel((posx+x+desc.m_xoffset),(posy+y+desc.m_yoffset),color);
		}
	
	return (desc.m_xadvance);	// on retourne le dcalage en x...		
}

s16 CMyFont::GetKerning(u32 glyphid1,u32 glyphid2)	// retourne le kerning (le plus souvent ngatif!) correspondant
{																										// s'il existe dans la table, sinon 0
	KernCouple couple;
	couple.first=glyphid1;
	couple.second=glyphid2;
	
	//if (m_MapKerning[couple]!=0)
		//iprintf("%d;",m_MapKerning[couple]);
	
	return(m_MapKerning[couple]);
}

u8 CMyFont::GetGlyphAdvance(u32 glyphid)	// retourne la largeur d'un glyph (==xoffset+width)
{
	GlyphDesc desc;
	
	desc=m_MapGlyph[glyphid];	// TODO: traiter le cas o glyphid est inconnu!
	
	return (desc.m_xadvance);					
}

u16 CMyFont::GetWordAdvance(string word)
{
	if (word=="")
	{
		return 0;
	}
	
	u16 res;	
	u16 t;
	
	/*iprintf("getwordstring\n");
	WaitForTouch();
	iprintf("string=%s\n",word.c_str());
	iprintf("length=%d\n",word.length());
	*/
	res=(GetGlyphAdvance(word.at(0)));
	//iprintf("t=%d\n",0);
	//WaitForTouch();
	for (t=1;t<word.length();t++)
	{				
		res+=GetGlyphAdvance(word.at(t))+GetKerning(word.at(t-1),word.at(t));
	}

	//iprintf("mot=%s res=%d\n",word.c_str(),res);
	//WaitForTouch();
		
	return res;
}

void CMyFont::WriteText(string texte,CMyBitmap* pbitmapdest,u16 x0, u16 y0)
{
	// en attendant que tout soit en C++ strings!	
	BasicWrite((char*)texte.c_str(),pbitmapdest,x0,y0)	;	
}

string CMyFont::WriteParagraph(string texte,CMyBitmap* pbitmapdest,u16 x0, u16 y0,u16 x1, u16 y1,s8 espace_lignes)
{
	if (texte=="")
		return "";
		
	// Bon ben... faut y aller !
	
	u16 x_ligne,y_ligne;	// position en x et y de la ligne courante
		
	u16 p;
	
	x_ligne=x0;
	y_ligne=y0;
	
	string texte2,ligne1,ligne2,delta;
	
	string mot;
	
	while	((texte.length()>0) && ((y_ligne+espace_lignes+m_LineHeight)<=y1))	// boucle parcours cadre/texte
	{
		// on commence une nouvelle ligne...
		
		ligne1="";		
		ligne2="";
		texte2=texte;
		delta="";
				
		//iprintf("%s\n",texte.c_str());
		//WaitForTouch();
				
		while (((x_ligne+GetWordAdvance(ligne2))<=x1) && (texte2.length()>0))	// boucle dtermination longueur max ligne
		{
			// ligne 2 est valide... on garde...
			ligne1=ligne2;

			//iprintf("%s;%d; ",ligne2.c_str(),(x_ligne+GetWordAdvance(ligne2)));

			//iprintf("\ndelta=.%s.\n",delta.c_str());
						
			if (delta!="")			// on retire delta de texte2
			{
//iprintf("p1. ");
				texte2=texte2.substr(delta.length(),texte2.length()-delta.length());
			}
			
			if (texte2.length()>0)
			{			
				//iprintf("ligne1=.%s. ligne2=.%s. texte2=.%s.\n",ligne1.c_str(),ligne2.c_str(),texte2.c_str());
				//WaitForTouch();
				// on ajoute le prochain mot/ensemble non scable  ligne2
	
				p=texte2.find_first_of(" \n");	// cherche un espace ou un retour ligne
				
				//iprintf("p=%d\n",p);
				
				if (p==(u16)string::npos)	// pas trouv
				{	
					//iprintf("Plus de caractre scable... on prend ce qui reste\n");			
					// on ajoute tout ce qui reste  la ligne...
					delta=texte2;
					ligne2+=delta;
				}
				else if (p==0)	// le texte commence par un caractre scable
				{
					if (texte2[0]==' ')  // plus prcisment par un espace 
					{
						//iprintf("commence par un espace...\n");
						// on ne l'ajoute que si on n'est pas en dbut de ligne !
						if (ligne1!="")
						{
							delta=" ";
							ligne2+=delta;
						}
						else
						{
							delta="";
							// on est en dbut de ligne, on peut donc supprimer l'espace de texte2 (sinon on boucle!)
//iprintf("p2. ");				
              if (texte2.length()<=1)
              {
                  texte2="";
              }
              else
              {			
							    texte2=texte2.substr(1,texte2.length()-1);
							}
						}					
						//iprintf("ligne2=:.%s.\n",ligne2.c_str());
					}
					
					else
					{
						// retour chariot en dbut de ligne...
						
						
//iprintf("p3. ");
//iprintf("t2=%s\n",texte2.c_str());
//iprintf("l=%d\n",texte2.length());
						
              if (texte2.length()<=1)
              {
                  texte2="";
              }
              else
              {			
      						texte2=texte2.substr(1,texte2.length()-1);
      				}
//iprintf("p3ok. ");
						// texte1 contient ce qu'il faut... on peut donc faire un break!
						break;
					}

				}
				else
				{
					// ajoute jusqu'au prochain caractre scable...
//iprintf("p4. ");

					delta=texte2.substr(0,p);	// on extrait le mot							
					ligne2+=delta;
				}			
			}
		}
		
		// Test pour le cas bloquant du mot plus long qu'une ligne => on coupe le mot!
		
		if (ligne1=="" && texte2!="")
		{
		  // on met la partie que l'on peut crire de ligne2 dans ligne1 et
		  // l'autre dans texte2
		  string tmp;
      tmp=texte2[0];
      u8 t=1;
		  while ((x_ligne+GetWordAdvance(tmp))<=x1)
		  {
		    delta=tmp;
		    if (t<texte2.length())
		      tmp+=texte2[t++];
        else
          break;		    
      }
		  
		  ligne1=delta;
		  
		  // on retire delta  texte2
		  texte2=texte2.substr(delta.length(),texte2.length()-delta.length());
    }
		
		//iprintf("on crit:%s\n",ligne1.c_str());
		//WaitForTouch();
		// ligne1 contient tout ce que l'on peut crire sur la ligne en cours...
		WriteText(ligne1,pbitmapdest,x_ligne,y_ligne);
		
		texte=texte2;
				
		y_ligne+=espace_lignes+m_LineHeight;
		
	}		
	return (texte);	// ce qui n'a pas pu tre crit...!
	//iprintf("termin!\n");
}

void CMyFont::BasicWriteCentered(char* pstr,CMyBitmap* pbitmapdest,u16 posx, u16 posy)
{
	// Ecriture basique, mais centre autour de posx...
		
	// ! pas de test de dpassement ! ne pas sortir de l'cran ou utiliser la version "AdvWrite" !
	
	// TODO : A recrire from scratch !!!
	// Code pourri !!!
	
	MyPoint res;

	res.y=posy+m_LineHeight;
	
	//iprintf("lineheight=%d\n",m_LineHeight);

	u16 c_x,c_y;
	
	c_x=posx;
	c_y=posy;
	
	u16 xadvance;
	s16 kerning;
	
	// ATTENTION ! Ce code n'est pas compatible UTF8!!!
	// JUSTE ASCII !!!  => revoir la dcoupe et la conversion vers l'id du glyph...
	
	char lettre_precedente=0;
	
	char* pstrbackup=pstr;
	
	char lettre=(*pstr++);
	while (lettre!='\0')
	{
		
		// kerning ventuel...
		if (lettre_precedente!=0)
		{
			kerning=GetKerning(lettre_precedente,lettre);
			c_x+=kerning;
			//iprintf("kerning: %d;",kerning);
		}
				
		xadvance=GetGlyphAdvance(lettre);
		
		c_x+=xadvance;
		//iprintf("lettre=%c xadvance:%d.",lettre,xadvance);
		
		lettre_precedente=lettre;				
		lettre=(*pstr++);
	}
	// c_x contient la valeur finale...
	res.x=c_x;

	BasicWrite(pstrbackup,pbitmapdest,posx-((res.x-posx))/2,posy);	
}
