//
// MyFont.h
// --------
// 
// Pour exploiter une police unicode gnre avec Bitmap Font Generator...
//
// DSgf : http://sourceforge.net/projects/dsgf
//

// TODO : mettre les caractres ASCII (id 0  255) en accs direct!

#ifndef MYFONT_H
#define MYFONT_H

/* system includes */
#include <nds.h>
#include <string>							// ha... les string en C++... c'est quand mme autre chose qu'en C, hein !
#include <sstream>							// string streams... marvelous!
#include <map>								// des hash version C++... cool!

using namespace std ;					// vite d'avoir  mettre std::string  chaque fois...

/* my includes */
#include "MyBitmap.h"

struct GlyphDesc
{
		u32	m_id;
		u16	m_x,m_y;
		u16	m_width,m_height;
		u16	m_xoffset,m_yoffset;
		u16	m_xadvance;	
		
		GlyphDesc() : m_id (0),m_x( 0 ), m_y( 0 ), m_width( 0 ), m_height( 0 ), m_xoffset( 0 ), m_yoffset( 0 ),
		m_xadvance( 0 )
		{ }
};

struct KernCouple
{
	u32 first;
	u32 second;	
};

class CMyBitmap;

class CMyFont
{
	public:
		
		// attributs
				
		CMyBitmap*		m_pbitmapfont;
		
		u8 m_background_color;
		u8 m_frame_color;
		
		u8	m_transp_color;
		
		u16	m_LineHeight;	// hauteur de ligne
		u16	m_Base;				// ?
		u16	m_Width;			// largeur du bitmap
		u16	m_Height;			// hauteur du bitmap
		u16	m_Pages;			// nombre de pages (descriptions/bitmaps)
											// TOUJOURS==1! car on restera sur une seule page pour viter d'avoir  grer plusieurs bitmaps...
		
		u8 m_GlyphWidthAverage;	// moyenne de la largeur des caractres... utilis pour estimer plus rapidement ce que l'on peut
														// crire sur une ligne...
		
		u16	m_nbGlyph;		// Nombre de Glyph
		u16 m_nbKerning;	// nombre de kerning
		
		map<u32,GlyphDesc> m_MapGlyph;	// map contenant la description des glyphs

		struct KernCoupleCmp {
    	bool operator()( KernCouple s1, KernCouple s2 ) const {
    		if (s1.first==s2.first)
    			return (s1.second>s2.second);
    		else return(s1.first>s2.first);
    	}
  	};

		map<KernCouple,s16,KernCoupleCmp> m_MapKerning;	// map contenant les infos de kerning
				
		// --- fonctions A SUPPRIMER/REECRIRE/OPTIMISER
				
		// criture trs basique
		void BasicWrite(char* pstr,CMyBitmap* pbitmapdest,u16 posx, u16 posy);		
		
		// criture basique sans cadre
		MyPoint Write(char* pstr,CMyBitmap* pbitmapdest,u16 posx, u16 posy,u8 marge=4);
		MyPoint Write(char* pstr,CMyBitmap* pbitmapdest,MyPoint point,u8 marge=4);
		
		// version centre autour de posx		
		MyPoint WriteCentered(char* pstr,CMyBitmap* pbitmapdest,u16 posx, u16 posy,u8 marge=4);
		MyPoint WriteCentered(char* pstr,CMyBitmap* pbitmapdest,MyPoint &point,u8 marge=4);
		
		// la mme sans cadre ni point de retour...
		void BasicWriteCentered(char* pstr,CMyBitmap* pbitmapdest,u16 posx, u16 posy);

		// et avec un icone dans le cadre
		MyPoint WriteIcon(char* pstr,CMyBitmap* picon,CMyBitmap* pbitmapdest,u16 posx, u16 posy,u8 marge=4);
		MyPoint WriteIcon(char* pstr,CMyBitmap* picon,CMyBitmap* pbitmapdest,MyPoint point,u8 marge=4);
		
		// --- Fonctions "OK"

		// dessin unitaire d'un glyph sur un bitmap
		u16 DrawGlyphOnBitmap(u32 glyphid,CMyBitmap* pbitmapdest,u16 x, u16 y);
						
		// couleurs des cadres
		void SetBackgroundColor(u8 color_index);
		void SetFrameColor(u8 color_index);
		
		// fonctions pour dterminer la taille/position d'un string(!)
		u8 GetGlyphAdvance(u32 glyphid);		
		s16 GetKerning(u32 glyphid1,u32 glyphid2);
		u16 GetWordAdvance(string word);
				
		// criture simple d'un texte
		void WriteText(string texte,CMyBitmap* pbitmapdest,u16 x0, u16 y0);
				
		// criture avance avec wordwrapping (c'est comme  qu'on dit ?)
		string WriteParagraph(string texte,CMyBitmap* pbitmapdest,u16 x0, u16 y0,u16 x1, u16 y1,s8 espace_lignes=0);
								
		// Cration, destruction, ainsi va la vie d'une instance...
		CMyFont(const u8* pdescr,const u8* pbitmap);
		~CMyFont();
		
};

#endif /* MYFONT_H */
